2010-07-23  Marek Habersack  <mhabersack@novell.com>

	* MenuItemBindingCollection.cs: added the OnClear,
	OnRemoveComplete and OnValidate methods (2.0+)

	* MenuItemStyleCollection.cs: added the OnInsert method (2.0+)

	* TreeNodeStyleCollection.cs: added the OnInsert method (2.0+)

	* TreeNodeBindingCollection.cs: added the OnClear,
	OnRemoveComplete and OnValidate methods (2.0+)

	* ValidationSummary.cs: implemented OnInit (4.0)

	* WizardStepBase.cs: added the LoadViewState, OnLoad and
	RenderChildren methods (2.0+)

2010-07-22  Marek Habersack  <mhabersack@novell.com>

	* MenuItemBinding.cs: made code a bit more compact.
	Implemented ToString (4.0)

	* MenuRenderingMode.cs: added (4.0)

	* Menu.cs: added the IncludeStyleBlock and RenderingMode 4.0
	properties (not used in the code yet).

2010-07-21  Marek Habersack  <mhabersack@novell.com>

	* Wizard.cs: made rendering 100% compliant with .NET (button IDs,
	2.0+)
	Implemented LayoutTemplate (4.0+)

	* LinkButton.cs: render id first

	* CreateUserWizard.cs: CreateUserNavigationContainer.UpdateState
	doesn't add a previous button if we're on the first step.

2010-07-20  Marek Habersack  <mhabersack@novell.com>

	* StyleCollection.cs: added

2010-07-19  Marek Habersack  <mhabersack@novell.com>

	* SqlDataSourceView.cs: added the RaiseUnsupportedCapabilityError
	method (2.0+)

	* RoleGroupCollection.cs: added OnValidate (undocumented) overload

	* ParameterCollection.cs: added missing Add method overload (2.0+)

	* LiteralControlBuilder.cs: added the AppendLiteralString method
	override (2.0+)

	* DataKey.cs: implemented IEquatable interface methods (4.0)

	* XmlDataSource.cs: implemented CacheKeyContext property (4.0)

2010-07-16  Marek Habersack  <mhabersack@novell.com>

	* Login.cs, PasswordRecovery.cs: implemented RenderOuterTable
	(4.0)

	* FormViewRow.cs: added internal property RenderJustCellContents
	which makes the control render only its children (4.0)

	* FormView.cs: implemented RenderOuterTable property and the
	ModifiedOuterTableStylePropertyName method (4.0)

2010-07-15  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: implemented verifying that no inline style
	property is set for controls which support the RenderOuterTable
	property (4.0)

	* IRenderOuterTable.cs: internal helper interface for controls
	which support the RenderOuterTable property (for now only
	ChangePassword, 3 more to come)

	* ChangePassword.cs: implemented RenderOuterTable property and the
	corresponding behavior of not rendering surrounding table when the
	property is set to false (4.0).
	Modified BaseChangePasswordContainer to not inherit from Table
	anymore. Table is an instance variable (always used as the
	template container in 2.0) which is optionally (and by default)
	used to contain the templates.

	* PlaceHolder.cs, View.cs, WizardStepBase: added EnableTheming
	property

	* MultiViewControlBuilder.cs: added

2010-07-14  Marek Habersack  <mhabersack@novell.com>

	* Menu.cs: fixed skip link rendering (no child controls are added
	in the process, writing directly to HtmlTextWriter). Fixes tests
	for 4.0
	If StaticSubMenuIndent equals Unit.Empty on 4.0, default to using
	16px as the value of the margin-left CSS attribute.

2010-07-13  Marek Habersack  <mhabersack@novell.com>

	* BoundField.cs: implemented HtmlEncodeFormatString property
	(3.5+) and modified the way FormatDataValue works accordingly.

	* ListBox.cs, CheckBoxList.cs, ListControl.cs: VerifyMultiSelect
	is not part of the official API. MultiSelect capability validation
	is performed using an internal virtual method MultiSelectOk ().

	* BaseDataList.cs: OnPagePreLoad is not part of the official API

	* BaseDataBoundControl.cs, BaseDataList.cs, DataListItem.cs,
	ValidationSummary.cs: implemented 4.0 SupportsDisabledAttribute
	property.

	* Wizard.cs: wizard table doesn't contain any instances of
	HtmlAnchor or Image controls. Moved rendering of the skip link
	anchor to the TableCellNamingContainer class, which does that in
	RenderChildren by directly writing to the passed writer. Fixes 4.0
	rendering and all the failing Wizard tests.

2010-07-08  Marek Habersack  <mhabersack@novell.com>

	* CheckBoxList.cs: RepeatLayout property update for new values of
	the RepeatLayout enum in 4.0

	* TreeView.cs: in 4.0, checkbox renders the value of the current
	node's ToolTip, if anything, and not Text.

	* RepeatLayout.cs: added two new members, UnorderedList and
	OrderedList (4.0)

	* ImageMap.cs: implemented missing Enabled property (2.0+)
	RaisePostBackEvent must be protected and virtual (2.0+)
	NavigateUrl is ignored if the control is disabled (4.0)

2010-07-07  Marek Habersack  <mhabersack@novell.com>

	* TreeView.cs: 4.0 rendering changes.
	When using registered CSS classes, the node style must use them in
	reverse order.

2010-07-06  Marek Habersack  <mhabersack@novell.com>

	* HyperLink.cs: the associated image is not rendered using the
	Image control.

2010-07-02  Marek Habersack  <mhabersack@novell.com>

	* Menu.cs: 4.0 API updates.

	* GridView.cs: implemented 4.0 properties -
	SortedAscendingCellStyle, SortedAscendingHeaderStyle,
	SortedDescendingCellStyle, SortedDescendingHeaderStyle,
	ClientIDRowSuffix, ClientIDRowSuffixDataKeys, ShowHeaderWhenEmpty
	along with associated rendering changes.

	* DetailsView.cs, FormView.cs, GridView.cs: 4.0 API changes -
	renamed ShowPage to SetPageIndex and made it public.
	Added 4.0 interfaces to inheritance list and implemented them.

	* DataKeyArray.cs: added internal constructor which accepts IList
	instead of ArrayList. Changed the 'keys' field type to IList.

	* ContainedTable.cs: the 'id' attribute must be rendered last.

	* CheckBox.cs, CheckBoxList.cs, SiteMapPath.cs, Table.cs,
	TableStyle.cs, TextBox.cs, WebControl.cs: 4.0 rendering changes.

	* Calendar.cs, CompositeControl.cs, DropDownList.cs, HyperLink.cs,
	Image.cs, ImageButton.cs, Label.cs, LinkButton.cs, LoginName.cs,
	Panel.cs, Table.cs, TableCell.cs, TableRow.cs:
	added new 4.0 property, SupportsDisabledAttribute.

2010-06-21  Marek Habersack  <mhabersack@novell.com>

	* BaseValidator.cs, BulletedList.cs, Calendar.cs, CheckBox.cs,
	CheckBoxList.cs, DataGrid.cs, DropDownList.cs, GridView.cs,
	HyperLink.cs, ImageButton.cs, LinkButton.cs, ListBox.cs,
	ListControl.cs, Menu.cs, RadioButton.cs, RadioButtonList.cs,
	RepeatInfo.cs, Repeater.cs, TextBox.cs, TreeView.cs,
	ValidationSummary.cs, WebControl.cs: use WebControl.IsEnabled
	instead of Enabled wherever necessary.

2010-06-16  Marek Habersack  <mhabersack@novell.com>

	* FormView.cs: row values must be retrieved with inclusion of
	keys. Fixes bug #607722

2010-06-03  Marek Habersack  <mhabersack@novell.com>

	* Parameter.cs, ControlParameter.cs, SessionParameter.cs,
	CookieParameter.cs, FormParameter.cs, ProfileParameter.cs,
	QueryStringParameter.cs: Evaluate is 'protected internal virtual'
	in 4.0.

	* RouteParameter.cs: implemented.

2010-04-28  Marek Habersack  <mhabersack@novell.com>

	* CheckBoxList.cs: do not modify list item status in LoadPostData
	when the list control is disabled.
	If an item is selected and it was unchecked by the user, deselect
	it. Fixes bug #600415

2010-04-13  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: make sure Header and Footer visibility are set when
	binding the data. Fixes bug #595567

	* ImageField.cs, CheckBoxField.cs: OnDataBindField must expect
	sender to be something else than DataControlFieldCell. Fixes bug
	#595568

2010-04-07  Marek Habersack  <mhabersack@novell.com>

	* FormParameter.cs, CookieParameter.cs, ProfileParameter.cs,
	QueryStringParameter.cs, SessionParameter.cs: implemented
	constructor overloads which take DbType as one of the arguments.

2010-04-01  Marek Habersack  <mhabersack@novell.com>

	* FormView.cs: do not show the pager if PagerSettings.Visible is
	false. Fixes bug #578863

2010-03-29  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: main table must be created and added to the
	controls collection before any OnRowCreated event is fired.

2010-03-19 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* TreeView.cs: use enums instead of strings for attributes.

2010-03-06  Marek Habersack  <mhabersack@novell.com>

	* XmlDataSource.cs: reload document when one of Data, DataFile,
	Transform or TransformFile properties is set. Fixes bug
	#585968. Fix based on patch from Jeffrey Alvarez
	<kuritsu@gmail.com>, thanks.

2010-02-19  Marek Habersack  <mhabersack@novell.com>

	* SqlDataSource.cs: call base.OnInit in OnInit. Fixes bug #572781

2010-02-18  Marek Habersack  <mhabersack@novell.com>

	* ListItemCollection.cs: ItemsEnabled and associated code removed
	- there's no need to alter ListItem's Enabled property when
	loading view state.

	* ListControl.cs: SaveViewState doesn't set the items collection's
	ItemsEnabled property as it was removed from ListItemCollection

	* CheckBoxList.cs: LoadPostData never unselects any item. A better
	fix for bug #377703
	RenderItem renders items as disabled when Enabled is false, but if
	Enabled is true, item is rendered according to the value of its
	own Enabled property. Fixes bug #578770

	* TreeView.cs: RegisterStyle must copy CssClass in addition to
	other style properties. Fixes bug #580692

2010-01-18  Marek Habersack  <mhabersack@novell.com>

	* Parameter.cs: added missing 3.5 APIs - constructors taking
	DbType as one of the parameters, ConvertDbTypeToTypeCode,
	ConvertTypeCodeToDbType and GetDatabaseType. Fixes bug #567850

2010-01-15  Marek Habersack  <mhabersack@novell.com>

	* ChangePassword.cs: BaseChangePasswordContainer forwards
	EnsureChildControls call to its owner, so that finding controls in
	the container works correctly.

2009-11-30  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: HasAttributes made available as internal for 1.1
	Avoid calling the Attributes getter many times in
	CopyBaseAttributes.
	If TrackViewState is called and attributes state bag already
	exists, mark all items in the latter as dirty.

	* CheckBox.cs, Button.cs, ImageButton.cs, LinkButton.cs: do not
	create the Attributes collection if not necessary.

2009-11-16  Marek Habersack  <mhabersack@novell.com>

	* TreeNodeCollection.cs: whenever a node is added, let the owner
	know about it.

	* TreeNode.cs: added internal property HadChildrenBeforePopulating
	which is used to let TreeView know about an error condition where
	a populate-on-demand node contains children added outside the
	OnTreeNodePopulate event

	* TreeView.cs: if a node has any child nodes and PopulatOnDemand
	is set, throw an exception from RenderNode. This is the behavior
	of .NET

2009-11-13  Marek Habersack  <mhabersack@novell.com>

	* TableRowCollection.cs: added .NET compatibility NREX throws to
	several methods.
	Whenever a row is added/removed, its Container property is
	set. Fixes bug #551666

	* TableRow.cs: introduced an internal property, Container, which
	is set by TableRowCollection whenever this row is added/removed
	to/from the collection. This allows the row to notify the
	collectio and, in consequence, collection owner that TableSection
	has been set and thead/tbody/tfoot elements need to be
	generated. Fixes bug #551666

2009-11-10  Marek Habersack  <mhabersack@novell.com>

	* PasswordRecovery.cs:
	{Question,Success,UserName}TemplateContainer must all be populated
	the first time the property is accessed, so that calling
	FindControl on the container returns valid and expected
	results. If the associated template is not defined, though,
	populating is postponed till CreateChildControls is called -
	that's where default, empty, template will be created. This is
	required to fix YetAnotherForum's password recovery control.
	Mail template used in SendPasswordByMail must match the one used
	in .NET (it has to end with a newline) as YAF parses the message
	to retrieve user name and password and breaks if the last line
	doesn't end with a newline character.

2009-10-30  Marek Habersack  <mhabersack@novell.com>

	* PasswordRecovery.cs: mail message replacements should include <%
	Password %> and <% UserName %> and matching should be
	case-insensitive. Fixes bug #545370

2009-10-28  Marek Habersack  <mhabersack@novell.com>

	* ListControl.cs: OnDataBinding must call base implementation
	before performing the binding, so that DataSource can be assigned
	from within the handler.

2009-10-13  Marek Safar  <marek.safar@novell.com>

	* WebColorConverter.cs: Delegate ConvertFrom to
	ColorTranslator.FromHtml, it is correctly implemented and knows
	many more tricks.

2009-10-13  Marek Habersack  <mhabersack@novell.com>

	* WebColorConverter.cs: don't use a dictionary to check for valid
	color names, use Color.IsKnownColor instead. Update for bug
	#546173 fix.
	Added more CSS2 color name mappings.

2009-10-12  Marek Habersack  <mhabersack@novell.com>

	* WebColorConverter.cs: when converting from color name, check if
	the returned color's name is a member of the
	System.Drawing.KnownColor enumeration to test for error condition,
	as some colors might be #000000. Preserve the old error check as a
	fallback only. 
	Map "captiontext" and "background" color names to
	"ActiveCaptionText" and "Desktop", respectively, before passing
	them to Color.FromName (). Fixes bug #546173

2009-10-02  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: added two 3.5 properties - SelectedPersistedDataKey
	and IPersistedSelector.DataKey.

	* BaseDataBoundControl.cs: slight optimizations to FindDataSource

2009-09-28  Marek Habersack  <mhabersack@novell.com>

	* DataBoundControl.cs: Initialize sets RequiresDataBinding
	properly, only when we're not data-bound already, when we aren't
	in postback or when we are in postback, but with viewstate
	enabled. Fixes bug #542076

2009-09-01  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: ExecuteSelect must call
	QueryTotalRowCount after executing the select method (that's what
	.NET does)

2009-08-25  Marek Habersack  <mhabersack@novell.com>

	* WebColorConverter.cs: inform the user that the might need to
	check if libgdiplus is installed when parsing a color name
	fails. Fixes bug #533749

2009-08-21  Marek Habersack  <mhabersack@novell.com>

	* Menu.cs: separator image is rendered next to the item in
	horizontal layout and is preceeded by 3px spacer (unless
	itemSpacing is set) to make output match .NET. Fixes bug #474716

	* TreeNodeCollection.cs: {Save,Load}ViewState now store/load the
	type of the node, if node is a of a custom type. Fixes bug #475997

2009-06-29 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* Parameter.cs: add new DbType property.

2009-06-16  Marek Habersack  <mhabersack@novell.com>

	* IPersistedSelector.cs: removed AspNetHostingPermission
	attributes from the 4.0 profile.

	* IDataBoundControl.cs, IDataBoundItemControl.cs,
	IDataBoundListControl.cs, IFieldControl.cs: added

	* DetailsView.cs: control implements 4.0 IDataBoundItemControl
	interface.

	* DataBoundControl.cs: implemented 4.0 property DataSourceObject
	(internal for 2.0) and made the InternalPerformDataBinding method
	internal for the 4.0 profile.

2009-06-11 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* ContentControlBuilderInternal.cs: detect missing
	ContentPlaceHolderID attribute when parsing instead of throwing a
	nullref later on.

2009-05-29  Marek Habersack  <mhabersack@novell.com>

	* ListItem.cs: when tracking view state is turned on after
	attributes have been set, make sure that the associated state bag
	begins tracking state and that all of its existing items are
	marked as dirty. Do the same after loading view state. Fixes bug
	#507836

2009-04-29  Marek Habersack  <mhabersack@novell.com>

	* DataBoundControl.cs: added InternalGetDataSource method, used by
	DynamicData

2009-04-28  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: implemented ColumnsGenerator and enabled its use in
	CreateColumns.

	* DetailsView.cs: implemented the RowsGenerator property and
	enabled its use in CreateFieldSet.

2009-04-07  Marek Habersack  <mhabersack@novell.com>

	* TreeView.js: removed nodeText parameter from the JS calls.

	* TreeView.cs: encode | characters into U+007C, so that
	RaiseCallbackEvent doesn't get confused.
	Removed nodeText parameter from the JS calls.

2009-04-06 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* TreeNode.cs: reset the path data for all child nodes too.
	* TreeView.cs: HtmlAttribute encode the node text. When rebuilding the
	node tree, set the correct index for the nodes so that the Path is
	correct.

2009-04-06  Marek Habersack  <mhabersack@novell.com>

	* TreeView.js: TreeView_ToggleExpand now takes more parameters - a
	full definition of treeview's node contents.
	Added new function, TreeView_PopulateNode, which partially takes
	over role of the PopulateNode function generated in
	TreeView.OnPreRender (see below). Fixes bug #492307

	* TreeView.cs: RaiseCallbackEvent needs to recreate the event
	target's parental tree all the way from the root to the node and
	populate only the leaf (requested) node. This avoids calling the
	TreeNodePopulate handler more times than needed. Fixes bug #492307
	OnPreRender: moved the script code to constants and the script
	body is now generated using StringBuilder instead of a series of
	String.Format calls.
	GetClientExpandEvent: adjusted code for new TreeView JavaScript
	API.

2009-03-17  Marek Habersack  <mhabersack@novell.com>

	* Unit.cs: introduced a field to tell the difference between empty
	(as in Unit.Empty) and 0px units.

2009-03-06  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: if savedState is not an instance of Pair in
	LoadViewState, do not attempt to load from it.

2009-02-10  Marek Habersack  <mhabersack@novell.com>

	* ImageButton.cs: AddAttributesToRender renders the onclick
	attribute only if any of the following is true:
	  - OnClientClick is not empty
	  - Validation is enabled for the control
	  - PostBackUrl is used
	PostBackOptions now indicate that control requires the javascript
	protocol for the handler.
	RaisePostBackEvent passes String.Empty as the argument.
	Fixes bug #463939

2009-02-09  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: ExecuteSelect returns a single-item
	array of objects containing the result, if the result isn't one of
	DataSet, DataTable or IEnumerable. Fixes bug #471767

2009-02-06  Marek Habersack  <mhabersack@novell.com>

	* Style.cs: if CssClass is null, return String.Empty. Fixes bug
	#473303
	Added a range check to the BorderStyle property.

2009-02-05  Marek Habersack  <mhabersack@novell.com>

	* Login.cs: check the value of DisplayRememberMe when creating
	the child controls. Fixes #468359

2009-01-20  Marek Habersack  <mhabersack@novell.com>

	* Substitution.cs: added. Fixes bug #467460

2009-01-13  Marek Habersack  <mhabersack@novell.com>

	* XmlBuilder.cs: updates related to ControlBuilder cleanup.

2008-12-01  Marek Habersack  <mhabersack@novell.com>

	* Style.cs: WriteStyleAttributes must not use the fontinfo field
	directly, it has to be done via the Font property. Fixes bug
	#449793

2008-11-15  Marek Habersack  <mhabersack@novell.com>

	* ContentPlaceHolder.cs, Content.cs, FormViewPagerRow.cs,
	ChangePassword.cs, DetailsViewPagerRow.cs: implements
	INonBindingContainer interface.

	* Wizard.cs: implement INonBindingContainer interface for several
	private/internal classes.

2008-10-24 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* ImageButton.cs: clicking an image causes a postback.
	Bug #439004 fixed.

2008-10-24  Marek Habersack  <mhabersack@novell.com>

	* CheckBox.cs: register for event validation in Render ().

2008-10-21  Marek Habersack  <mhabersack@novell.com>

	* XmlDataSource.cs: DataFile may be an URL.

2008-10-17  Marek Habersack  <mhabersack@novell.com>

	* ImageMap.cs: added the SupportsEventValidation attribute to the
	class.
	Validate the event in RaisePostBackEvent ().
	Register for event validation in Render ().

	* DropDownList.cs, ListBox.cs: validate the event in LoadPostData ().

	* TextBox.cs: validate the event in LoadPostData ().
	Register for event validation in AddAttributesToRender ().

	* HiddenField.cs: validate the event in RaisePostDataChangedEvent.
	Register for event validation in Render ().

	* RadioButton.cs: validate the event in LoadPostData ().
	Register for event validation in InternalAddAttributesToRender.

	* CheckBox.cs, RadioButtonList.cs: validate the event in
	RaisePostDataChangedEvent.

	* Menu.cs: added the SupportsEventValidation attribute to the
	class.
	Validate the event in RaisePostBackEvent ().
	Register for event validation in GetClientEvent ().

	* DetailsView.cs, GridView.cs: validate the event in
	RaisePostBackEvent ().
	Register for validation in GetCallbackScript () and in OnPreRender

	* Button.cs, Table.cs, BulletedList.cs, Calendar.cs, LinkButton.cs,
	ImageButton.cs, TreeView.cs: validate the event in RaisePostBackEvent ().

2008-10-14  Marek Habersack  <mhabersack@novell.com>

	* CompositeDataBoundControl.cs: renamed the itemcount ViewState
	item from "_ItemCount" to "_!ItemCount" for .NET
	compatibility. This item is accessed and used by some commercial
	ASP.NET controls.

	* DataBoundControl.cs: OnPagePreLoad must force databinding also
	when the request is not a postback.

2008-10-13  Marek Habersack  <mhabersack@novell.com>

	* Table.cs, TableRowCollection.cs, TableRow.cs: render table
	sections when necessary. Fixes bug #434555

2008-10-08  Marek Habersack  <mhabersack@novell.com>

	* ControlParameter.cs: Evaluate calls DataBinder.Eval to do the
	evaluation now. This makes it support complex expressions.

2008-09-30  Sebastien Pouliot  <sebastien@ximian.com> 

	* RoleGroupCollection.cs: Fix recursive calls (wrong target)
	[Found using Gendarme's BadRecursiveInvocationRule]

2008-09-28  Sebastien Pouliot  <sebastien@ximian.com>

	* XmlDataSource.cs: Make sure the result of the multiplication is a
	long (not an integer casted into a long since it could overflow).
	[Found using Gendarme's ReviewCastOnIntegerMultiplicationRule]

2008-09-17  Juraj Skripsky  <js@hotfeet.ch>

	* RadioButton.cs (ValueAttribute, LoadPostData): Fixes bug #426959.

2008-09-13  Atsushi Enomoto  <atsushi@ximian.com>

	* IPersistedSelector.cs : new in 3.5 SP1.

2008-09-13  Atsushi Enomoto  <atsushi@ximian.com>

	* DataBoundControlMode.cs : new 3.5 SP1 type.

2008-08-25  Marek Habersack  <mhabersack@novell.com>

	* DataBoundControl.cs: set RequiresDataBinding to true in
	Initialize only if not in a postback, if not data bound and if the
	view state is enabled. Fixes bug #398318
	UpdateViewData removes the OnDataSourceViewChanged handler before
	connecting to the datasource and restores it before returning to
	the caller.
	OnLoad gets the data source before initialization, to avoid
	premature OnDataSourceViewChanged triggers. Fixes bug #398318
	Do not reconnect to the data source if we already have a valid one.

2008-08-18  Marek Habersack  <mhabersack@novell.com>

	* Unit.cs: rewrote the unit parser in a slightly slower, but more
	correct, way. Fixes bug #417502

2008-07-28  Marek Habersack  <mhabersack@novell.com>

	* TreeView.cs: when TreeView is displaying a site map and there is
	no node selected by the user, select the node corresponding to the
	current page, if any.

2008-07-24  Marek Habersack  <mhabersack@novell.com>

	* DataGrid.cs: removed the private class TableID and moved its
	code to ChildTable.cs (see below). 2.0 instantiates teh ChildTable
	with the owner parameter now. Fixes bug #400377

	* ChildTable.cs: refactoring - moved code from TableID previously
	defined in DataGrid.cs to here and made the class available under
	different names for both 1.x and 2.x profiles. Fixes bug #400377

	* MailDefinition.cs: look for the mail body file in the correct
	path. Patch from Jackson Harper <jaharper@novell.com>,
	thanks! Fixes bug #408699

	* PasswordRecovery.cs: do not ask password recovery question if
	it's disabled. Patch from Jackson Harper <jaharper@novell.com>,
	thanks! Fixes bug #408696

2008-07-16  Marek Habersack  <mhabersack@novell.com>

	* XmlDataSource.cs: check if Page isn't null before stringifying
	it in GetDataKey (), fixes bug #409492

2008-07-13  Roei Erez  <roeie@mainsoft.com>

	* GridView.cs: When the RowDataBound event is invoked, the value
	of GridView1.DataKeys should contains all the keys up untill the
	current row, and not be empty.
	I only changed the order of the user event invocation and the addition
	to the collection.

2008-07-13  Roei Erez  <roeie@mainsoft.com>

	* TreeView.cs: In case of multiple tree node bingings, select 
	The first one and not the last one.

2008-07-10  Roei Erez  <roeie@mainsoft.com>

	* HyperlinkField.cs: Changed behavior of HyperLinkField bound field key 
	to be case insensitive.

2008-07-03  Marek Habersack  <mhabersack@novell.com>

	* CheckBox.cs: do not render the language="javascript" attribute
	in the 2.0 profile.

2008-07-02  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: minor optimizations (removed a foreach loop,
	replaced calls to Array.Length with a variable containing the
	length).

2008-06-30  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs, Menu.cs, DataList.cs,
	CustomValidator.cs: hush the warnings

2008-06-10  Noam Lampert  <noaml@mainsoft.com>

	* ListItemCollection.cs: Provide viewstate for dirty collection even if it is empty.

2008-05-30  Marek Habersack  <mhabersack@novell.com>

	* BaseDataBoundControl.cs, ChangePassword.cs, CustomValidator.cs,
	DataControlFieldCollection.cs, DataControlField.cs,
	PasswordRecovery.cs, PagerSettings.cs: do not use synthetized
	event accessors (to avoid locks).

2008-05-18  Marek Habersack  <mhabersack@novell.com>

	* HierarchicalDataBoundControl.cs: Modified GetData method to check if
	DataSource implements IHierarchicalEnumerable and if so constructs and
	returns a new instance of ReadOnlyDataSourceView. This provides functional
	compatibility with the Microsoft.NET framework. Fixes bug
	#395209. Patch contributed by James Fitzsimons
	<james.fitzsimons@gmail.com>, thanks!

2008-05-06  Marek Habersack  <mhabersack@novell.com>

	* Calendar.cs: do not create dateInfo in the constructor - culture
	might be not set yet at this point. Fixes bug #323566
	Added a private property, DateInfo, which creates the dateInfo
	when requested.

2008-05-05  Sebastien Pouliot  <sebastien@ximian.com>

	* BulletedList.cs: Avoid calling ToString on a string.
	* ButtonField.cs: Throw, not just create, the exceptions. 
	* HyperLinkField.cs: Throw, not just create, the exceptions. 
	* ImageField.cs: Throw, not just create, the exception. Avoid calling
	ToString on a string.
	* ListControl.cs: Avoid calling ToString on a string.
	[All issues were found using Gendarme]

2008-04-30  Marek Habersack  <mhabersack@novell.com>

	* SiteMapDataSource.cs: when no starting node is found, return
	null instead of Provider.RootNode. Fixes bug #323994

2008-04-24  Marek Habersack  <mhabersack@novell.com>

	* SqlDataSource.cs: raise the DataSourceChangedEvent when setting
	ConnectionString, ProviderName or DataSourceMode properties only
	when the new value differs from the old one. Fixes bug #359392

2008-04-16  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: ExecuteSelect should return an empty
	aray when no data has been retrieved from the specified source
	type. Fixes bug #380106

2008-04-15  Marek Habersack  <mhabersack@novell.com>

	* MailDefinition.cs: dispose of streams the way it should
	be done.

2008-04-10  Marek Habersack  <mhabersack@novell.com>
	
	* RadioButton.cs: adjust 'name' and 'value' attribute values to
	match MS.NET. Fixes bug #378024
	
	* CheckBoxList.cs: set the Selected property to the value in POST
	data only if the item in question was enabled before postback
	occurred. Fixes bug #377703

	* ListControl.cs: make sure the owned items' Enabled property is
	set to the same value what ListControl's. Fixes bug #377703

	* ListItemCollection.cs: fixed SetDirty to store the index of the
	last dirtied item properly. Fixes bug #377703
	For the 2.0 profile, set the ListItem instances Enabled property
	to the value of the owning ListControl (internal ItemsEnabled
	property was added to make it possible). Fixes bug #377703

2008-04-08  Dean Brettle <dean@brettle.com>

	* DataBoundControl.cs (InternalPerformDataBinding), 
	HierarchicalDataBoundControl.cs (InternalPerformDataBinding),
	WebControl.cs (Render): fixed cast errors when a ControlAdapter
	that wasn't of the type corresponding to the control was used.

2008-04-03  Marek Habersack  <mhabersack@novell.com>

	* DataList.cs: use the value of SelectedIndex, not selectedIndex,
	to return the key value in the SelectedValue property. Fixes bug
	#376519. Patch from Sergey Kuleshov <svyatogor@gmail.com>, thanks!

2008-03-12  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* AutoGeneratedField.cs, CheckBoxField.cs: fixed OnDataBindField,
	should hide checkbox only if DataItem is not defined

2008-03-09  Dean Brettle <dean@brettle.com> 

	* DetailsView.cs, ListControl.cs, DataBoundControl.cs, 
	FormView.cs, HierarchicalDataBoundControl.cs, WebControl.cs: 
	added support for using ControlAdapters when present.
	
	* WebControl.cs: fixed implementation of IsEnabled to match 
	documentation.

	* Menu.cs (RenderMenuBody): call Adapter.RenderItem() instead of 
	RenderMenuItem() if an adapter is present.  MenuAdapter.RenderItem() 
	calls back to new Menu.RenderItem() internal method which calls
	RenderMenuItem() with the appropriate parameters.

2008-02-25 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs:
	at Update and Delete use not read only coppies of dictionaries
	in event argumens, that allows user to change them before corresponding
	DataSource's method is called.

2008-02-20 Igor Zelmanovich <igorz@mainsoft.com>

	* Login.cs: render id attribute of root element correctly.

2008-02-18  Marek Habersack  <mhabersack@novell.com>

	* FormView.cs: the ItemCreated must be fired before data is bound
	to the FormView. Fixes bug #360434

2008-02-07 Igor Zelmanovich <igorz@mainsoft.com>

	* Login.cs: render id attribute of root element correctly.

2008-02-05  Marek Habersack  <mhabersack@novell.com>

	* FileUpload.cs: make sure FileContent always returns the input
	stream positioned at the beginning. Fixes bug #356846

2008-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* Calendar.cs: resolve Next/Prev. month link date correctly.

2008-01-29 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: add XPFileExplorer icon set.

2008-01-28 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.js: dynamic nodes are positioned after hover style of 
	parent node is applied.

2008-01-24  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataSourceCacheManager.cs: fixed GetKeyFromParameters, incase more
	than one datasource using the same object with the same select method

2008-01-23 Igor Zelmanovich <igorz@mainsoft.com>

	* ValidationSummary.cs:
	refactoring: If page contents instance of IScriptManager, it calls 
	it's API instead Page.ClientScript.									

2008-01-23 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed rendering.

2008-01-16 Igor Zelmanovich <igorz@mainsoft.com>

	* Wizard.cs:
	manage history state on "MovePrevious" action.	

2008-01-16 Igor Zelmanovich <igorz@mainsoft.com>

	* BulletedList.cs:
	resolve BulletImageUrl,
	register for event validation.	

2008-01-13 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs:
	* TreeView.js:
	upgrade client side script due to changes in webform.js.		

2008-01-07 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseCompareValidator.cs:
	* BaseValidator.cs:
	* CompareValidator.cs:
	* CustomValidator.cs:
	* RangeValidator.cs:
	* RegularExpressionValidator.cs:
	* RequiredFieldValidator.cs:
	refactoring: If page contents instance of IScriptManager, validators call 
	it's API instead Page.ClientScript.									

2008-01-07 Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs:
	* ImageButton.cs:
	* LinkButton.cs:
	for TARGET_J2EE used CreateActionUrl instead ResolveClientUrl
	in GetPostBackOptions.			

2008-01-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: render invisible rows correct.

2008-01-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DataControlField.cs: prevent infinite recursion

2008-01-01  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataSourceCacheManager.cs: fixed SetCachedObject. fixed sliding
	expiration timespan

2007-12-31  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataSourceCacheManager.cs: fixed SetCachedObject, fixed
	CacheDependency keys

2007-12-24 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: revert changes from r91230

2007-12-18  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListControl.cs: fixed Load/SaveViewState, removed selected indices
	storing
	* ListItem.cs: fixed Load/SaveViewState, added selected state storing
	* ListItemCollection.cs: fixed Load/SaveViewState, added flag to not
	rebuild the collection if was'nt changed

2007-12-13  Marek Habersack  <mhabersack@novell.com>

	* Menu.cs, TreeView.cs: optimize use of String.Format in
	OnPreRender.
	Speed optimization - use String.Concat instead of String.Format in
	some cases.

	* GridView.cs, DetailsView.cs: optimize use of String.Format in
	OnPreRender.

	* CheckBox.cs, AccessDataSource.cs, WebColorConverter.cs,
	WebControl.cs,TextBox.cs, DropDownList.cs, ValidationSummary.cs,
	ListBox.cs, Panel.cs, BaseValidator.cs, LinkButton.cs: speed
	optimization - use String.Concat instead of String.Format in some cases.

2007-12-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Menu.cs: fixed rendering without head tag on page

2007-11-19  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Calendar.cs: performance optimizations:
	BuildLink fixed, StringBuilder used.
	TodaysDate DateTime.Today call cahced.

2007-11-19  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Unit.cs: performance optimization: ToString fixed, string.Concat used
	instead of string.Format

2007-11-19  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Style.cs: performance optimization: suppress finalizer added

2007-11-08 Igor Zelmanovich <igorz@mainsoft.com>

	* BoundField.cs:
	* ImageField.cs:
	evaluate bound value using ThisExpession ("!") properly	

2007-11-07 Igor Zelmanovich <igorz@mainsoft.com>

	* WebControl.cs: enabled state restored properly.

2007-11-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TextBox.cs:
	refactoring for NET_2_0:
	Text is removed from view state in case of need at SaveViewState phase. 	 

2007-11-06 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs:
	SelectedValue/SelectedIndex is set during DataBinding always. 	 

2007-11-06  Marek Habersack  <mhabersack@novell.com>

	* DataGrid.cs: add RenderTable before the DataGridItems, so that
	numbering of children is the same what on MS.NET.
	If there are any data items, require a postback script.
	Fixes bug #319449
	
	* ChildTable.cs: removed DOS EOLs.

2007-10-31 Igor Zelmanovich <igorz@mainsoft.com>

	* Login.cs: 
	does not perform authentication if Page.IsValid returns false;
	the fix makes control works with disabled client side validation.

2007-10-31 Igor Zelmanovich <igorz@mainsoft.com>

	* DataList.cs: 
	state of DataList.Items are restored correct on PostBack
	such Items.Count and ItemType.

2007-10-31 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: 
	validator is rendered correct if EnabledClientClient is false.

2007-10-30 Igor Zelmanovich <igorz@mainsoft.com>

	* Image.cs: fixed management state of Enabled property.
	* WebControl.cs: refactoring in management state of Enabled property.

2007-10-23  Marek Habersack  <mhabersack@novell.com>

	* ListBox.cs, Table.cs: use Render{Begin,End}Tag
	instead of the Write* counterparts when	rendering contents.

2007-10-18  Marek Habersack  <mhabersack@novell.com>

	* Menu.js: a workaround for an IE bug. IE recalculates element's
	 offsetWidth when the element's _height_ is set - which in case of
	 elements with overflowing content results in a value that's just
	 slightly smaller than the client window width. In effect, a long
	 submenu will also be very wide, which isn't desirable. Fixes bug
	 #322809

2007-10-15  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: use HttpApplication.LoadType instead of
	Type.GetType.

	* BulletedList.cs: html encode the item text. Fixes bug #333550.

2007-10-01  Marek Habersack  <mhabersack@novell.com>

	* ListItem.cs: make HasAttributes available for the 1.1 profile as
	well.

	* DropDownList.cs: render custom ListItem attributes in the 1.1
	profile. Fixes bug #326288

2007-09-27  Marek Habersack  <mhabersack@novell.com>

	* Button.cs: added missing OnPreRender method.

2007-09-25  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: added an internal method, BuildScriptAttribute,
	which merges the specified JavaScript code in an attribute, with
	the value of that attribute specified by the user.

	* CheckBox.cs, DropDownList.cs: AutoPostBack handling makes sure to
	preserve user-specified attribute value, if present.

	* ListBox.cs, TextBox.cs: AddAttributesToRender calls the base
	after doing its job. AutoPostBack handling makes sure to preserve
	user-specified attribute value, if present. Fixes bug #327816.

2007-09-21  Marek Habersack  <mhabersack@novell.com>

	* ListItem.cs: don't save StateBag in the control state - the
	class is not serializable and therefore ObjectStateFormatter
	cannot convert it. Instead have the sb object save its own state
	and store the returned value. Fixes bug #326288.

2007-09-20  Marek Habersack  <mhabersack@novell.com>

	* LoginView.cs: implemented RoleGroups support. Fixes bug
	#324633.

2007-09-19  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: copy attributes from GridView to the child table,
	as this is where the rendering takes place. Fixes bug #326309.

2007-09-18  Marek Habersack  <mhabersack@novell.com>

	* Calendar.cs: correctly apply day cell style. Fixes bug #315903

2007-09-17  Marek Habersack  <mhabersack@novell.com>

	* Calendar.cs: style attribute value must be enclosed in quotes.

	* TableStyle.cs: do not capitalize the align styles. Fixes bug
	#313766.

2007-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: partially restored r85314
	whenever a property that can affect data binding
	is set, make sure to set RequiresDataBinding.

2007-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed DataBind flow:
	prevent double binding when not necessary.
	fixed bug #81146	

2007-08-31  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: instead of not adding hidden fields to the rows,
	mark the cells they would contain as invisible. Fixes bug #82615.

2007-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs:
	* Menu.js:
	make Menu work in multi form environment.

2007-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed selected items state management.

2007-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseCompareValidator.cs:
	* BaseValidator.cs:
	* CompareValidator.cs:
	* CustomValidator.cs:
	* RangeValidator.cs:
	* RegularExpressionValidator.cs:
	* RequiredFieldValidator.cs:
	all Validators use RegisterExpandoAttribute for 
	not XHTML compliant attributes.

2007-08-23 Igor Zelmanovich <igorz@mainsoft.com>

	* Panel.cs: client script consider MultiForm environment.

2007-08-21  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: get rid of PrivateBinPath property,
	it's unused.

2007-08-20  Marek Habersack  <mhabersack@novell.com>

	* ContentPlaceHolderBuilder.cs: store place holder id in the
	parser's internal place holder id list for later reference. Fixes
	bug #82485.

2007-08-19  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* BoundField.cs: FormatDataValue, refactored multiple use of ToString

2007-08-14  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: remove unused variable.

	* ChangePassword.cs: remove unused variable.
	The change password button id changed to
	"ChangePasswordPushButton", the cancel button id changed to
	"CancelPushButton". The change makes the generated ids the same
	what on MS.NET. Fixes bug #82418.

	* RoleGroupCollection.cs: OnValidate shouldn't be overridden.

2007-08-14  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ParameterCollection.cs: fixed IndexOfString, should use ordinal
	compare

2007-08-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Menu.cs: performance refactoring, used AddAttribute overload without
	encoding on known attribute values, optimized DynamicMenu rendering

2007-08-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TreeView.cs: refactoring, used AddAttribute overload without encoding
	on known attribute values,
	used Page.ClientScript.GetWebResourceUrl call instead of
	AssemblyResourceLoader.GetResourceUrl

2007-08-06 Igor Zelmanovich <igorz@mainsoft.com>

	* AccessDataSource.cs: does not subscribed on view changed event.
	* ObjectDataSource.cs: fixed state management.
	* SqlDataSource.cs:	fixed state management.	 

2007-08-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Button.cs, 
	DataControlFieldHeaderCell.cs, FileUpload.cs, Table.cs, 
	RegularExpressionValidator.cs, CheckBox.cs, HiddenField.cs, 
	TableStyle.cs, Image.cs, BulletedList.cs, RangeValidator.cs, 
	BaseValidator.cs, CustomValidator.cs, RepeatInfo.cs, TextBox.cs, 
	RequiredFieldValidator.cs, AdRotator.cs, TableHeaderCell.cs, 
	ImageMap.cs, Panel.cs, CompareValidator.cs, Calendar.cs, ListBox.cs, 
	TableCell.cs, WebControl.cs, ImageButton.cs, TableItemStyle.cs: 
	refactoring, used AddAttribute overload without encoding on known attribute 
	values

2007-08-01 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs: fixed onchange attibute.

2007-07-26  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListItemCollection.cs: fixed LoadViewState, items restored from
	viewstate were not saved, fixes bug #82192

2007-07-24 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: All client scripts are rendered 
	according IsMultiForm property.

2007-07-24 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: refactoring:
	* TreeView.js:
	used ClientScriptManager.GetCallbackEventReference API instead calling 
	WebForm_DoCallback explicit.
		
2007-07-15 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: for NET_2_0: fixed client side validation.
	validation is performed in WebForm_DoPostback, 
	and there is no need to do it twice in ValidatorOnSubmit.

2007-07-15 Igor Zelmanovich <igorz@mainsoft.com>

	* Calendar.cs: fixed: correct 'id' attribute is rendered.

2007-07-10  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListItemCollection.cs: optimized SetDirty method

2007-07-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListControl.cs:
	* ListItem.cs:
	* ListItemCollection.cs: controls based on ListControl should not save
	view state before than TrackViewState called

2007-07-04  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* WebControl.cs: fixed AddDisplayStyleAttribute, returns if
	ControlStyle is not created

2007-07-02  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: Revert r80368, as it wasn't the correct
	fix. Fixes bug #81945.

	* ListControl.cs: if there are no items in the collection, do not
	return an empty ArrayList from GetSelectedIndicesInternal. Fixes
	bug #81945 and properly fixes bug #78533.

	* ListItemCollection.cs: if there are no items in collection,
	return null.

2007-07-01 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs:
	the Pager is created but unvisible for only one page. 
	the Patch submitted by Dumitru Ban [dban@dako.ro]	

2007-07-01 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	* DetailView.cs:
	* GridView.cs:
	does not requires data binding if any ITemplate property is set.

2007-06-24  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* CheckBox.cs: fixed Render, HasAttributes called instead
	Attributes.Count

2007-06-24 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed AllowPaging feature:
	When the AllowPaging is true the GridView control should automatically 
	hide the pager row when the data source contains fewer than 2 records.	
	patch Patch submitted by Dumitru Ban [dban@dako.ro]	

2007-06-20  Marek Habersack  <mhabersack@novell.com>

	* WebControl.cs: if savedState is a Triplet, take the actual state
	data from savedState.First. Also make sure that the data is a
	Pair. Fixes bug #78533.

	* DataSourceCacheManager.cs: use HttpContext.Current.InternalCache
	to keep private entries.
	* XmlDataSource.cs: as above
	
2007-05-31  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* BaseValidator.cs: RegisterValidatorCommonScript, fixed type passed
	to ClientScriptManager

2007-05-29 Igor Zelmanovich <igorz@mainsoft.com>

	* ObjectDataSourceView.cs:
	* SiteMapDataSource.cs:
	* SqlDataSource.cs:
	* SqlDataSourceView.cs:
	DataSourceChanged and DataSourceViewChanged are raised in right case, when
	different properties changed their value.				

2007-05-27 Igor Zelmanovich <igorz@mainsoft.com>

	* ObjectDataSourceView.cs: fixed SelectMethod and SelectCountMethod properties:
	when changed, DataSourceViewChanged event is raised.
	
	* SqlDataSourceView: fixed SelectCommand property:
	when changed, DataSourceViewChanged event is raised.

2007-05-25  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: CreateDataObject must pay attention to
	TypeConverter attributes on the property being converted.

2007-05-24 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: alt attribute is rendered as well.

2007-05-16  Marek Habersack  <mhabersack@novell.com>

	* CompareValidator.cs: formatting changes

2007-05-15  Marek Habersack  <mhabersack@novell.com>

	* ObjectDataSourceView.cs: refactoring - use
	HttpApplication.LoadType to look up types.

2007-05-10  Marek Habersack  <mhabersack@novell.com>

	* Table.cs: render rows, not controls

	* HyperLink.cs: RenderContents must check if the render method
	delegate is present and, if yes, call the base RenderContents.

	* LinkButton.cs: as above.

	* Label.cs: as above.

	* TableCell.cs: as above.
	This change makes the HeaderTemplate in the Wizard control work.
	
	* Wizard.cs: if a next/previous step handler modifies
	ActiveStepIndex do not, respectively, increase/decrease the
	current step, but use whatever was set in the handler.

2007-05-09  Marek Habersack  <mhabersack@novell.com>

	* TreeNodeStyleCollection.cs: do not set font's underline flag to
	false, set it to its own value instead.

	* TreeView.cs: if level style exists and has ChildNodesPadding
	set, it takes precedence over the node style setting (if any).

2007-05-08  Marek Habersack  <mhabersack@novell.com>

	* TreeView.cs: children padding is rendered only before and after
	the children are rendered, not between them. Also, render padding
	only if there are any nodes to follow the current one.

2007-05-07  Marek Habersack  <mhabersack@novell.com>

	* Wizard.cs: additional checks to see whether the wizard needs to
	move to a next step or not. Fixes bug #81532. Patch sent by Mike
	Morano <mmorano@mikeandwan.us>, thanks!

2007-05-07 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed:
	avoid NullReferenceException when used EditTemplate w/o binding 
	directive such Eval or Bind.	 

2007-05-07 Igor Zelmanovich <igorz@mainsoft.com>

	* MenuItem.cs: fixed: 
	when 'Value' property is not set, value of 'Text' property is used 
	instead and vice versa.

2007-05-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNode.cs: fixed: 
	when 'Value' property is not set, value of 'Text' property is used 
	instead and vice versa.

2007-05-04  Marek Habersack  <mhabersack@novell.com>

	* AdRotator.cs: use the new GetPhysicalFilePath method to look up
	the physical path of the ad file.

2007-05-03  Marek Habersack  <mhabersack@novell.com>

	* TreeView.cs: honor ChildNodesPadding of the NodeStyle.

2007-05-03 Igor Zelmanovich <igorz@mainsoft.com>

	* ControlPropertyNameConverter.css:
	* FontUnitConverter.cs:
	* UnitConverter.cs:
	* ValidatedControlConverter.cs:			
	added missing API.	

2007-05-03  Marek Habersack  <mhabersack@novell.com>

	* TreeNode.cs: correct version of the fix in r76488. Nodes
	retrieved from a navigation data source which have empty URL will
	not be selectable.

	* TreeView.cs: revert r76488, it wasn't entirely correct. I need
	to investigate the special cases it solved a bit more.

2007-05-02 Igor Zelmanovich <igorz@mainsoft.com>

	* SqlDataSourceView.cs:
	make CancelSelectOnNullParameter property works.

2007-05-01  Marek Habersack  <mhabersack@novell.com>

	* BaseValidator.cs: do not use User-Agent directly, we must take
	ClientTarget into account.

2007-04-30  Marek Habersack  <mhabersack@novell.com>

	* TreeView.cs: bring rendering closer to the MS.NET rendering.

	* SqlDataSource.cs: do not catch the exception if ProviderName is
	not null or empty (as per docs and what MS.NET does).

2007-04-19 Igor Zelmanovich <igorz@mainsoft.com>

	* ChangePassword.cs:
	does not accept invalid new password.	

2007-04-18  Igor Zelmanovich  <igorz@mainsoft.com>

	* Xml.cs:
	* XmlDataSource.cs:
	added MonoLimitation attributes		

2007-04-18  Igor Zelmanovich  <igorz@mainsoft.com>

	* BaseValidator.cs: for TARGET_J2EE: 
	used Page.Request.Browser to determine RenderUplevel

2007-04-12 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs:
	when databound with AutoGenerateColumns = true, 
	data source enumerator created only once.	

2007-04-18  Marek Habersack  <mhabersack@novell.com>

	* SiteMapDataSource.cs: query the site map for the current node
	when configured to use it as the start point. Fixes bug #81376,
	patch from Mike Morano <mmorano@mikeandwan.us>.

	* Calendar.cs: change year/month format to be culture aware. Fix
	for bug #81390. Patch submitted by Atsushi Enomoto
	<atsushi@ximian.com>

2007-04-17  Daniel Nauck  <dna@mono-project.de>

	* PasswordRecovery.cs: fixed typo (AnswerLabel.Text).

2007-04-17  Marek Habersack  <mhabersack@novell.com>

	* BaseValidator.cs: use the new uplevel browser detection code.

2007-04-12 Igor Zelmanovich <igorz@mainsoft.com>

	* SqlDataSourceView.cs: fixed: InitializeParameters:
	restored flow, broken in r75137.

2007-04-12 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: popup menu is posed correctly if menu is placed within 
	container with position=relative

2007-04-12  Marek Habersack  <mhabersack@novell.com>

	* LoginView.cs: do not call CreateChildControls directly from the
	IsAuthenticated setter since that would destroy the controls the
	user might've configured from their Page_PreRender method.
	Do not use IsAuthenticated in CreateChildControls since that
	prevents the _correct_ template from being instantiated before the
	control is transferred to the user's OnPreRender handler. Fixes
	bug #81344.

2007-04-11  Marek Habersack  <mhabersack@novell.com>

	* ImageButton.cs: implement the Enable property and do not
	register for post back if the control isn't enabled.

2007-04-06  Marek Habersack  <mhabersack@novell.com>

	* GridView.cs: don't render invisible fields. Fixes bug #80061.

	* DetailsView.cs: don't render invisible fields.

2007-04-05 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: resolve selected MenuItem if bounded with SiteMapeDataSource.

2007-04-05  Marek Habersack  <mhabersack@novell.com>

	* BaseDataBoundControl.cs: restore the LAMESPEC note and code it
	describes - tests show this is what's happening on MS.NET as
	well.

2007-04-05 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs:
	* BaseDataBoundControl.cs:
	Break recursion when the property is set from within the OnSelect handler 
	in user's code. fixes bug #81175.	

2007-04-05  Marek Habersack  <mhabersack@novell.com>

	* SiteMapDataSource.cs: fix GetStartNode for situations when the
	current URL is not defined in the sitemap file. Fixes bug
	#81314. Patch from Mike Morano <mmorano@mikeandwan.us>.

2007-04-03  Marek Habersack  <mhabersack@novell.com>

	* BaseDataBoundControl.cs: adjust for lame specs on MSDN.

2007-04-02 Gert Driesen <drieseng@users.sourceforge.net>

	* MenuItem.cs: Use INavigateUIData.Description as ToolTip. Fixed line
	endings.

2007-03-29 Adar Wesley <adarw@mainsoft.com>

	* ObjectDataSourceView.cs: fixed events so they are raized at the
	right times.  Added many tests to verify the correct time.
	* SqlDataSourceView.cs: fixed events so they are raized at the right
	times.  Added many tests to verify the correct time.

2007-03-28 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs:
	* TreeView:
	avoid Exception if HierarchicalDataSourceView.Select() returns null.

2007-03-22 Igor Zelmanovich <igorz@mainsoft.com>

	* ObjectDataSource.cs:
	* ObjectDataSourceView.cs:
	* SqlDataSource.cs:
	* SqlDataSourceView.cs:
	fixed flow: changes in Insert/Update/DeleteParameters does not 
	cause DataSourceViewChanged event.				

2007-03-20 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataBoundControl.cs: fix as per MSDN - the property is set
	only if data binding doesn't occur.

2007-03-20 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: PageIndex considers PageCount.	

2007-03-20  Marek Habersack  <mhabersack@novell.com>

	* DataBoundControl.cs: avoid endless recursion here. Fixes bug #81175

	* LoginStatus.cs: render login/logout controls with the CssClass
	set from the parent control. Fixes bug #81196

2007-03-19 Igor Zelmanovich <igorz@mainsoft.com>

	* DataGrid.cs: fixed Save/Load view state, applying styles.	

2007-03-12 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: optimization: used CssStyleCollection .ctor w/o parameters.	

2007-03-09  Marek Habersack  <mhabersack@novell.com>

	* Login.cs: Make command name comparison case-insensitive in
	OnBubbleEvent. Patch from Mike Morano <mmorano@mikeandwan.us>

2007-03-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DataGrid.cs: fixed: 
	Auto-generated columns are restored properly on postback from view state.

2007-03-06 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: fixed:
	when AddAttributesToRender(System.Web.UI.HtmlTextWriter, WebControl) 
	is called, WebControl parameter is passed as argument to 
	FillStyleAttributes (CssStyleCollection, IUrlResolutionService) method.

2007-03-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DataList.cs:
	* DataListItem.cs:
	fixed applying styles if ExtractTemplateRows=true.

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs: in 2.0 first item is rendered with selected attribute
	is Enabled=false and no selected items.

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBoxList.cs: in 2.0 access key attribute is rendered in 'input' tags.

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBoxList.cs:
	* BulletedList.cs:
	* ListControl.cs:
	* ListItem.cs:
	* RadioButtonList.cs:
	fixed: list controls consider ListItem.Attributes property on render. 

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBox.cs: fixed: 'span' tag is not rendered if all attributes 
	are rendered in 'input' tag. 

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs:
	* ListBox.cs:
	used "ONLY_1_1" instead "!NET_2_0"	

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataBoundControl.cs:
	* DataBoundControl.cs:
	* HierarchicalDataBoundControl.cs:
	refactoring: DataBoundControl and HierarchicalDataBoundControl use internal
	method in BaseDataBoundControl to find a data source control.

2007-03-05  Marek Habersack  <mhabersack@novell.com>

	* Unit.cs: Support parsing of units in the form ".9em" etc.

2007-03-05 Igor Zelmanovich <igorz@mainsoft.com>

	* TemplateColumn.cs: fixed: if ItemTemplate is null, "&nbsp;" is rendered.

2007-03-05  Marek Habersack  <mhabersack@novell.com>

	* BaseValidator.cs: make validators work correctly with
	ListItems. Patch from Daniel Nauck <dna@informatik.uni-kiel.de>
	
2007-03-04  Marek Habersack  <mhabersack@novell.com>

	* HierarchicalDataBoundControl.cs: Use the method described below
	to get the data source named in DataSourceID.

	* BaseDataBoundControl.cs: add an internal method to find a data
	source control within all the naming containers above a given
	control. The method makes it possible to find controls that reside
	in master pages.

2007-03-01 Igor Zelmanovich <igorz@mainsoft.com>

	* Repeater.cs: fixed: data-binding flow for 2.0 features.

2007-03-01 Igor Zelmanovich <igorz@mainsoft.com>

	* Parameter.cs:
	* ParameterCollection.cs:	
	fixed GetValue/s  and UpdateValue/s. 

2007-02-28 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeCollection.cs:
	fixed Save/Load viewstate. 

2007-02-28 Igor Zelmanovich <igorz@mainsoft.com>

	* MenuItemCollection.cs:
	fixed Save/Load viewstate. 

2007-02-28 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs:
	* Wizard.cs:
	fixed CausesValidaion and ValidationGroup for navigation buttons. 

2007-02-27 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNode.cs:
	* TreeView.cs:
	fixed LoadPostData to restore checked state for node's checkboxes. 

2007-02-27 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeCollection.cs: 'dirty' flag is assigned if 'marked' only 

2007-02-27 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataBoundControl.cs: setting DataSource to null does not 
	call ValidateDataSource.
	* HierarchicalDataBoundControl.cs: ValidateDataSource does not 
	throw exception if argument is null. 

2007-02-27 Igor Zelmanovich <igorz@mainsoft.com>

	* WebControl.cs: implemented IsEnabled and HasAttributes.

2007-02-27 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataList.cs: fixed: data-binding flow for 2.0 features.

2007-02-27  Marek Habersack  <grendello@gmail.com>

	* FileUpload.cs: HasFile is true only if PostedFile is not null
	and it actually has an associated file.

2007-02-26 Igor Zelmanovich <igorz@mainsoft.com>

	* LoginView.cs: fixed: 
	ViewChanging and ViewChanged are fired.
	optimized Save/Load control state. 	

2007-02-26 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: fixed: does not attempt to send email if 
	MailDefinition is not defined.

2007-02-26 Igor Zelmanovich <igorz@mainsoft.com>

	* Login.cs: fixed:
	considers FormsAuthentication.ReturnUrl only if is placed in 
	the login page defined in web.config. 

2007-02-23  Marek Habersack  <grendello@gmail.com>

	* ObjectDataSourceView.cs: Fix saving/restoring the view state.

	* CreateUserWizard.cs: support for sending mail when a new user is
	created. Patch from dban@dako.ro.

2007-02-22  Marek Habersack  <grendello@gmail.com>

	* LoginStatus.cs: Handle OnLoggedOut properly. Patch from
	dban@dako.ro.

2007-02-20  Adar Wesley <adarw@mainsoft.com>

	* ObjectDataSourceView.cs: fixed ViewState behavior to match MS.  Added relevant tests.

2007-02-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* Calendar.cs: Fixed bug #80881 by using Thread's CurrentCulture
	instead of CurrentUICulture for DateFormatInfo.

2007-02-20 Adar Wesley <adarw@mainsoft.com>

	* SqlDataSource.cs: fixed ViewState behavior to conform to MS.  Added relevant tests.
	* SqlDataSourceView.cs: fixed ViewState behavior to conform to MS. Added relevant tests.

2007-02-20 Igor Zelmanovich <igorz@mainsoft.com>

	* ChangePassword.cs: fixed:
	ChangePasswordContainer and SuccessContainer cannot be BindingContainer.		

2007-02-20 Adar Wesley <adarw@mainsoft.com>

	* SqlDataSourceView.cs: Fixed parameter merging logic and some bug fixing.
	Added more tests.

2007-02-19 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBox.cs:
	* ListControl.cs:
	* TextBox.cs:
	implemented Form.SubmitDisabledControls feature.			

2007-02-18 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: IsBindableType for decimal returns true.

2007-02-18 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.js: client script: support IE6.

2007-02-18 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: considers item.ToolTip, render image inside 'a' tag.

2007-02-18  Eyal Alaluf <eyala@mainsoft.com>

	* Button.cs, ImageButton.cs, LinkButton.cs: Hanlding of PostbackOptions for
	  TARGET_J2EE is now centralized in ClientScriptManager.
	* TreeView.cs, DetailsView.cs, GridView.cs, TreeView.js, DetailsView.js,
	  GridView.js: Added a field to the controls JavaScript 'data' object. The
	  form is initialized to the page 'theForm'. This is used for J2EE portlets
	  callback support.

2006-02-18 Igor Zelmanovich <igorz@mainsoft.com>

	* Wizard: fixed:
	first step is recognized as 'finish' if only two steps 
	and last step is 'complete'

2006-02-15 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator: ControlPropertiesValid is called on PreRender
	* CompareValidator.cs:
	* RangeValidator.cs: fixed ControlPropertiesValid, EvaluateIsValid.

2006-02-15 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseCompareValidator.cs: fixed: support for type=Currency on client side.

2007-02-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ParameterCollection.cs: fixed IndexOfString, this indexer should be
	case insensitive

2007-02-13 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.js: refactoring:
	removed TreeView_ErrorCallback, used TreeView_PopulateCallback instead.
	
2007-02-13 Adar Wesley <adarw@mainsoft.com>

	* ObjectDataSourceView.cs: fixed parameter merging and added more tests

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* Literal.cs: implemented 2.0 feature - Mode.
	
2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* ViewCollection.cs: fixed public API.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* RepeaterItem.cs: implemented IDataItemContainer interface.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeStyle.cs: fixed public API.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* MenuItemStyle.cs: fixed public API.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* Calendar.cs:
	* DayRenderEventArgs.cs:
	implemented 2.0 feature - SelectUrl.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* GridViewRowCollection.cs: implemented IsReadOnly property.

2007-02-12 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: implemented SetFocusOnError feature.

2007-02-11 Igor Zelmanovich <igorz@mainsoft.com>

	* Wizard.cs: refactoring:
	used ContainedTable for ID attribute is rendered properly.	 

2007-02-11 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: 
	* Wizard.cs: 
	fixed SideBar.

2007-02-11 Igor Zelmanovich <igorz@mainsoft.com>

	* DataList.cs: fixed: OnBubbleEvent() will return true if event is handled 

2007-02-09  Gert Driesen  <drieseng@users.sourceforge.net>

	* FontUnit.cs: Fixed ToString () to use current locale.

2007-02-07 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: fixed render, works in static mode properly 
	* CreateUserWizard.cs: fixed display mode for validators.		

2007-02-07 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	* FormViewPagerRow:		
	implemented FormViewPagerRow class	

2007-02-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: 
	header and footer visibility is set at creation.	

2007-02-06 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: 
	header and footer are not created with empty row.	

2007-02-06 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: 
	works properly with not ICollection data source.	

2007-02-06 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: 
	PageIndex, CreateChildControls, 
	works properly with not ICollection data source.	

2007-02-06 Eyal Alaluf <eyala@mainsoft.com>

	* Menu.cs ImageMap.cs Panel.cs TreeView.cs: Ensure that the NavigateUrl
	  property is rendered as a RenderURL for J2EE portlets.

2007-02-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* BaseValidator.cs: refactored RegisterValidatorCommonScript to use
	RegisterClientScriptInclude instead of RegisterClientScriptBlock

2007-02-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs:
	* DetailsView.cs:
	* FormView.cs:
	PerformDataBinding is called with RequiresDataBinding was set false

2007-02-05 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	fixed validation flow.	

2007-02-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs:
	fixed validation flow.	

2007-02-04 Igor Zelmanovich <igorz@mainsoft.com>

	* CustomValidator.cs:
	ValidateEmptyText is considered on client side.	

2007-02-04 Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs:
	* ButtonField.cs:
	* CommandField.cs:
	* DataControlButton.cs:
	* DataControlField.cs:
	* ImageButton.cs:
	* PagerSettings.cs:						
	Internal classes are used in databound controls for buttons 
	are derived from right types. It allows to have access to them by casting
	to public types. This trick is used in one of starter kits of MS.

2007-02-04 Igor Zelmanovich <igorz@mainsoft.com>

	* Panel.cs: fixed: reverted r71441.
	* TreeView.cs: used internal RegisterWebFormClientScript API 
	to cause the relevant script be included.	

2007-02-01 Adar Wesley <adarw@mainsoft.com>

	* FormView.cs: fixed events ModeChanging and ModeChanged 
	to be raized in all relevant situations.

2007-02-01 Igor Zelmanovich <igorz@mainsoft.com>

	* ValidationSammary.cs: fixed:
	control is rendered even if there is no validators on the page.
	important if the page contain a client side script that refer to the 
	id of the validation summary div.	 

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBoxList.cs:
	* DropDownList.cs:
	* ListBox.cs:
	* RadioButtonList.cs:
	EnsureDataBound is called when PostData is processed to restore 
	'state' of control if EnableViewState is false				 

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: 
	RowDataBound is fired for PagerRow.
	Styles are applied using MergeWith instead CopyFrom 
	to allow using custom styles for rows in code-behind.

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: RowCommand event is fired properly.

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: created rows are added in table after initialization.
	* BoundField.cs: 	

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* Panel.cs: fixed 'background-image' attribute.

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataBoundControl.cs:
	* DataBoundControl.cs:
	fixed DataBinding flow: RequiresDataBinding is set to false in 
	PerformSelect().			
	* HierarchicalDataBoundControl.cs: implemented MarkAsDataBound().

2007-01-31 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs:
	* FormView.cs:
	fixed DataBinding flow for Insert mode.

2007-01-30 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBox.cs:
	does not RegisterRequiresPostBack if is not enabled.

2007-01-30 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs:
	* TreeView.js:
	fixed PopulateOnDemand: used UniqueID to call WebForms_DoCallBack().

2007-01-29 Igor Zelmanovich <igorz@mainsoft.com>

	* MultyView.cs: OnActiveViewChanged is called.

2007-01-29  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Panel.cs: fixed AddAttributesToRender for 2.0, text align should be
	style attribute

2007-01-29  Adar Wesley <adarw@mainsoft.com>

        * EditCommandColumn.cs: implemented CausesValidation and
        ValidationGroup and coresponding tests.
        * DataGrid.cs: fixed generated table to be compatible with MS 2.0

2007-01-28  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* WebControl.cs: added internal method AddDisplayStyleAttribute for
	display:inline-block style attribute
	* LinkButton.cs
	* HyperLink.cs
	* CheckBox.cs: added call to AddDisplayStyleAttribute on rendering

2007-01-14 Eyal Alaluf <eyala@mainsoft.com>

	* TreeView.js: Used WebForm_GetFormFromCtrl to lookup the form.

2007-01-24  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TextBox.cs: implemented AutoCompleteType property, fixed
	AddAttributesToRender

2007-01-24  Ilya Kharmatsky <ilya -at- decode-systems.com>
	
	* DetailsView.cs: fixed problems with rendering of control, when
	  empty data source is provided. Respective tests are provided 
	  in DetailsViewTest.cs
	  
2007-01-21  Konstantin Triger <kostat@mainsoft.com>

	* TreeView.js, DetailsView.js, Menu.js, GridView.js:
		suppress exception if eval() fails.

2007-01-20  Miguel de Icaza  <miguel@novell.com>

	* DataControlFieldCollection.cs (RemoveAt): remove unused
	variable. 

	* RoleGroupCollection.cs (OnValidate): Flag as protected, as it
	should not show up.

	* RadioButton.cs (RaisePostDataChangedEvent): This method was not
	used in 1.0, so put the whole method in 2.0

2007-01-18  Adar Wesley <adarw@mainsoft.com>

	* Xml.cs: added support for XPathNavigator, fixed DocumentContent
	to be compatible with MS 2.0, implemented EnableTheming, implemented
	SkinID, fixed Focus behavior.

2007-01-18  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Menu.js, Menu.js: added null reference checking for every getTree or
	getMenu call

2007-01-18  Adar Wesley <adarw@mainsoft.com>

        * SiteMapDataSource.cs: implemented logic of GetStartNode when
        StartingNodeOffset is positive.

2007-01-17  Konstantin Triger <kostat@mainsoft.com>

	* BaseValidator.cs: ToString the validating property value or
		if null return an empty string.

2007-01-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TreeView.cs: fixed RegisterStyle, style names should be without
	leading underscore. fixed RenderNode, node icons should be taken also
	from level styles

2007-01-17  Adar Wesley <adarw@mainsoft.com>

	* Repeater.cs: refactored GetData to return data both from DataSource
	and DataSrouceID, Implemented EnableTheming, updated initialization of
	DataBinding according to the pattern of BaseDataBoundControl, fixed
	SelectArguments implementation to call the virtual 
	CreateDataSourceSelectArguments method.

2007-01-17  Konstantin Triger <kostat@mainsoft.com>

	* GridView.cs: don't force creating rows collection when SelectedIndex
		changes; EnsureDatabound on select.

2007-01-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TreeNode.cs: fixed Bind, fixed Value updating

2007-01-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataList.cs: fixed OnBubbleEvent, added SelectedIndex updating

2007-01-17  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DetailsView.cs: fixed CreateChildControls, PageIndex cannot be less
	than zero

2007-01-15  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DetailsView.cs: fixed CreateChildControls, PageIndex should be less
	or equal to PageCount

2007-01-15 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: added z-index attribute to popup div's.

2007-01-15  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* FileUpload.cs: fixed FileName property, should return filename
	without full path on client side

2007-01-15 Ilya Kharmatsky  <ilya -at- decode-systems.com>

	* ListControl.cs
	* CheckBoxList.cs
	* ListBox.cs
	Implemented the protected net_2_0 method 'VerifyMultiSelect' with
	proper overloading in derived types.
 
2007-01-15 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNode.cs
	considers INavigateUIData.NavigateUrl when bound.	

2007-01-15 Igor Zelmanovich <igorz@mainsoft.com>

	* CompleteWizardStep.cs
	* CreateUserWizard.cs
	* CreateUserWizardStep.cs
	* TemplatedWizardStep.cs
	* Wizard.cs
	make the design complied to .NET	
	build all possible controls at once and manage render by Visible property

2007-01-14 Eyal Alaluf <eyala@mainsoft.com>
	* Button.cs, HyperLink.cs, DataGrid.cs, ImageButton.cs, LinkButton.cs,
	  PagedDataSource.cs: Added J2EE Portal support for TARGET_J2EE.

2007-01-14  Ilya Kharmatsky <ilyak-at-mainsoft.com>
	* BaseCompareValidator
	* CompareValidator
	Added support for CultureInvariantValues property, which should be 
	counted in new 2.0 methods such as - Compare, Convert etc. The code
	has been changed in such way, that the old - 1.1 method implementation 
	could use the new methods defined for 2.0 version.

2007-01-10 Konstantin Triger <kostat@mainsoft.com>

	* XmlDataSource.cs: refactored to use cached collection.
	* SqlDataSource.cs: refactored to use cached collection;
		don't throw exception on 'DefaultView'.
	* ObjectDataSource.cs: refactored to use cached collection.

2007-01-10 Konstantin Triger <kostat@mainsoft.com>

        * ObjectDataSourceView.cs: consider parameter names and
			DataObjectMethodAttribute during method resolution.

2007-01-11  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs: fixed OnUpdating, OnInserting call with
	SqlDataSourceCommandEventArgs

2007-01-10 Konstantin Triger <kostat@mainsoft.com>

	* ObjectDataSourceView.cs: use case unsensitive comparer for
	 	parameters collection.

2007-01-10 Igor Zelmanovich <igorz@mainsoft.com>

	* LoginStatus.cs: fixed: not causes page validation.

2007-01-10 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: fixed: resolves ErrorMessage control correct.
	* CreateUserWizardStep.cs:

2007-01-10 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: SelectedNode, CheckedNodes.
	* TreeNode.cs:
	* TreeNodeCollection.cs:		

2007-01-10 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: header and footer does not appear in no items.
	* CompositeDataBoundControl.cs:

2007-01-09 Konstantin Triger <kostat@mainsoft.com>

	* AdRotator.cs: Backport the fix for AdRotator AbsoluteUri to 1.1.

2007-01-09 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: SelectedDataKey.

2007-01-09 Igor Zelmanovich <igorz@mainsoft.com>

	* Panel.cs:
	* PanelStyle.cs:
	implemented 2.0 features.	

2007-01-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs: fixed parameters init for ExecuteUpdate

2007-01-08 Igor Zelmanovich <igorz@mainsoft.com>

	* DataSourceCacheManager.cs:
	* ObjectDataSource.cs:
	* SqlDataSource.cs:
	fixed: cache considers parameters values changes.				

2007-01-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DetailsView.cs: fixed DeleteItem, excluded keys for new values
	* SqlDataSourceView.cs: fixed ExecuteDelete, check cancel in
	OnDeleting event

2007-01-08 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: show all rows when AllowPaging=false

2007-01-08 Igor Zelmanovich <igorz@mainsoft.com>

	* SqlDataSourceView.cs: fixed CreateDbParameter, used DBNull for value=null.

2007-01-08 Igor Zelmanovich <igorz@mainsoft.com>

	* ButtonField.cs: fixed: consider its CausesValidation property.

2007-01-08 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed:
	ReadOnly property is false for AutoGeneratedColumn if field is DataKey.
	causesValidation parameter is considered properly in UpdateRow.
	OldValues contains readonly fields values

2007-01-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs: fixed InitializeParameters, added
	ParameterPrefix when check that param is already in collection

2007-01-07 Igor Zelmanovich <igorz@mainsoft.com>

	* AdRotator.cs: fixed: considers absolute uri such html://......	 

2007-01-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs: fixed insert, delete, update methods, added
	calls to OnDataSourceViewChanged

2007-01-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* added ProfileParameter.cs

2007-01-07 Igor Zelmanovich <igorz@mainsoft.com>

	* Label.cs: fixed: according MSDN OnPreRender is not overridden.	 

2007-01-04 Adar Wesley <adarw@mainsoft.com>

	* ImageButton.cs: implemented GenerateEmptyAlternateText

2007-01-04 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed data binding flow considers Insert mode.	 

2007-01-04 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed Init flow.	 

2007-01-4   Adar Wesley <adarw@mainsoft.com>

	* RadioButtonList.cs: Implemented properties of IRepeatInfoUser as public virtual

2007-01-03  Marek Habersack  <grendello@gmail.com>

	* ObjectDataSourceView.cs: Look for unqualified type also in the top-level assemblies.

2006-01-03 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed PageIndex property.

2006-01-03 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed SelectedValue and SelectedIndex properties.
	set accessor works differently in 2.0.		 

2007-01-02  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs,ObjectDataSourceView.cs: fixed parameter merge
	when values and old values are null

2006-01-02 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: reverted r70112, fixed in r70319.	 

2007-01-02 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed CreateAutoGeneratedRows.			

2007-01-01 Igor Zelmanovich <igorz@mainsoft.com>

	* AutoGeneratedField.cs: is editable in Insest mode.
	* BoundField.cs: is editable in Insest mode.
	* CheckBoxField.cs: is editable in Insest mode.
	* DetailsView.cs: fixed DataBinding flow.			

2007-01-01 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseDataBoundControl.cs:
	* CompositeDataBoundControl.cs: fixed DataBinding flow.

2006-12-31 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* LinkButton.cs: show the validation summary when client validation
	and linkbuttons are used. Patch by Juraj Skripsky.

2006-12-31 Igor Zelmanovich <igorz@mainsoft.com>

	* TextBox.cs: consider ToolTip property

2006-12-31 Igor Zelmanovich <igorz@mainsoft.com>

	* ContainedTable.cs:
	* DataControlButton.cs:
	* DetailsView.cs: fixed EnablePagingCallbacks
	* DetailsView.js:
	* GridView.cs:
	* GridView.js: fixed EnableSortingAndPagingCallbacks

2006-12-28 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: 
	ResolveClientUrl used with LineImagesFolder, ExpandImageUrl, 
	CollapseImageUrl and NoExpandImageUrl properties.

2006-12-28  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSource.cs: Added parameters update on OnInit

2006-12-28  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* LoginView.cs: fixed rendering LoggedInTemplate even after user
	logged out

2006-12-28 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs:
	* GridView.cs:
	* FormView.cs:
	control's behavior depends on using DataSource or DataSourceID 
	property for binding	

2006-12-27 Igor Zelmanovich <igorz@mainsoft.com>

	* CommandField.cs: fixed: 
	when ShowEditButton=false Update/Cancel button doesn't appear.	 
	when ShowInsertButton=false Insert/Cancel button doesn't appear.	 

2006-12-27  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Login.cs: fixed AuthenticateUser, should redirect to ReturnUrl when

2006-12-27  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Parameter.cs: fixed ConvertValue to coorect handle TypeCode.Empty
	* ObjectDataSourceView.cs: fixed MergeParameterValues,
	call Parameter.ConvertValue
	fixed ConvertParameter to hanlde TypeCode.Empty
	* SqlDataSourceView.cs: fixed InitializeParameters,
	call Parameter.ConvertValue
	fixed ParameterPrefix property
	fixed CreateDbParameter, added usege of ParameterPrefix

2006-12-27 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed: when is used with DataSourceID data bind is not 
	perfomed on PostBack because Items collection is restored from View state.	 

2006-12-26 Igor Zelmanovich <igorz@mainsoft.com>

	* DataGridPagerStyle.cs:
	* DataList.cs:
	* DetailsView.cs:
	* FontInfo.cs:
	* Style.cs:
	* TableItemStyle.cs:
	* TableStyle.cs:
	* TreeNodeStyle.cs:
	* WebControl.cs:
	* Wizard.cs:				
	fixed: Load/Save viewstate of WebControl does not call Load/Save viewstate 
	for it's ControlStyle, but the shared ViewState is used to manage style's 
	viewstate instead.

2006-12-21 Igor Zelmanovich <igorz@mainsoft.com>

	* CompleteWizardStep.cs:
	* CreateUserWizard.cs:
	* CreateUserWizardStep.cs:
	* TemplatedWizardStep.cs:
	* Wizard.cs:
	fixed: 	CreateUserWizard works properly in advanced scenarios 
	such being used with additional steps or/and with custom templates.
	Styles are aplied  properly.

2006-12-21  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* SqlDataSourceView.cs: fixed InitializeParameters, parameters order
	parameters case insensetive search
	* ObjectDataSourceView.cs: fixed MergeParameterValues, parameters
	case insensetive search

2006-12-19 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: ResolveClientUrl used with src and href attributes

2006-12-19 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs:
	* TreeNode.cs:
	TreeNodeCollapsed is not raised for leaf node.		

2006-12-14  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataGrid.cs, RepeatInfo.cs: fixed accessibility features

2006-12-17 Igor Zelmanovich <igorz@mainsoft.com>

	* Calendar.cs: support DayNameFormat.Shortest

2006-12-17 Igor Zelmanovich <igorz@mainsoft.com>

	* HiddenField.cs: implemented

2006-12-17 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: FillRowDataKey
	* DetailsView.cs: fixed: FillRowDataKey

2006-12-17 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: ResolveClientUrl used with ImageUrl and NavigateUrl

2006-12-14  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Login.cs: refactored rendering, fixed OnAuthenticate event

2006-12-11 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: Update works not only for EditRow
	* TemplateField.cs:
	* CompositeDataBoundControl.cs:		

2006-12-11 Igor Zelmanovich <igorz@mainsoft.com>

	* RadioButton.cs: fixed:
	When GroupName is not defined UniqueID is used instead for name attribute.
	CheckedChanged is raised only when control is checked.

2006-12-10 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: rendering.

2006-12-10 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: rendering.

2006-12-10 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs:
	* ListBox.cs:
	* DropDownList.cs:
	fixed rendering for 2.0			

2006-12-07 Igor Zelmanovich <igorz@mainsoft.com>

	* DetaisView.cs: fixed: rendering.
	* DataControlButton.cs:
	* PagerSettings.cs:		

2006-12-07 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: avoid empty row rendering.

2006-12-06 Igor Zelmanovich <igorz@mainsoft.com>

	* AdRotator.cs: fixed: 
	MSDN: The ImageUrl and NavigateUrl attributes can be a full URL, a 
	root-relative path, or a relative path. If you use a root-relative path, 
	the path is relative to the same Web site. If you use a relative path, 
	the path is relative to the directory that contains the advertisement file.

2006-12-06 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseCompareValidator.cs: fixed: support for type=Date on client side.

2006-12-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: support for event validation.

2006-12-04 Igor Zelmanovich <igorz@mainsoft.com>

	* DataGridPagerStyle.cs: chenged values of DataGridPagerStyles flags.

2006-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CreateUserWizard.cs: implement GeneratePassword based on Membership.

2006-11-27  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Wizard.cs: fixed GetStepType method that returned wrong type if the
	last step type is Complete.
	fixed ProcessEvent method, corrected FinishButtonClick behavior

2006-11-26  Marek Habersack  <grendello@gmail.com>

	* Calendar.cs: Fixed event validation registration. Now it
	registers all the arguments that can be passed by this control to
	the application.

2006-11-25  Marek Habersack  <grendello@gmail.com>

	* FileUpload.cs: Implementation of SaveAs

	* TreeView.cs: A few optimizations for empty style collections.

	* Menu.cs: A few optimizations for empty style collections. 

2006-11-23 Igor Zelmanovich <igorz@mainsoft.com>

	* BoundField.cs: fixed: GetDesignTimeValue()

2006-11-23 Igor Zelmanovich <igorz@mainsoft.com>

	* SiteMapDataSource.cs: fixed: GetViewNames()

2006-11-23  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ChangePassword.cs: implemented functionality
	* MailDefinition.cs: implemented CreateMailMessage method
	* PasswordRecovery.cs: implemented functionality

2006-11-22 Igor Zelmanovich <igorz@mainsoft.com>

	* CircleHotSpot.cs: fixed: 
	setting Radius with value <0 throws ArgumentOutOfRangeException.

2006-11-22 Igor Zelmanovich <igorz@mainsoft.com>

	* CookieParameter.cs: fixed Evaluate method.

2006-11-22 Igor Zelmanovich <igorz@mainsoft.com>

	* Parameter.cs: fixed Evaluate, ToString methods.
	* QueryStringParameter.cs: fixed Evaluate method.
	* SessionParameter.cs: fixed Evaluate method.

2006-11-21 Igor Zelmanovich <igorz@mainsoft.com>

	* ImageMap.cs: fixed rendering.

2006-11-21 Igor Zelmanovich <igorz@mainsoft.com>

	* HotSpot.cs: fixed: AccessKey and HotSpotMode 
	throw ArgumentOutOfRangeException.

2006-11-21 Igor Zelmanovich <igorz@mainsoft.com>

	* ControlParameter.cs: fixed: Evaluate method 
	throws exceptions correctly.

2006-11-21 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBox.cs: fixed: new 2.0 features such 
	LabelAttributes and InputAttributes.

2006-11-20 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: header, footer and empty rows are databound.

2006-11-20 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: added internal helper method RemoveTextStyles.

2006-11-20  Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs: fixed: support for event validation.
	* CheckBox.cs: fixed: support for event validation.
	* FormView.cs: fixed: support for event validation.
	* ImageButton.cs: fixed: support for event validation.
	* ListBox.cs: fixed: support for event validation.
	* TextBox.cs: fixed: support for event validation.

2006-11-19 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs: fixed: support for event validation.

2006-11-19 Igor Zelmanovich <igorz@mainsoft.com>

	* LinkButton.cs: optimized: support for event validation.
	* DataControlButton.cs: Added support for event validation.
	* DetailsView.cs: fixed: RowIndex for DetailsViewRow.	

2006-11-19 Igor Zelmanovich <igorz@mainsoft.com>

	* LinkButton.cs: Added support for event validation.

2006-11-17  Marek Habersack  <grendello@gmail.com>

	* ImageButton.cs: Added support for event validation.

	* ListBox.cs: Added support for event validation.

	* Calendar.cs: Added support for event validation.

	* DropDownList.cs: Added support for event validation.

	* FormView.cs: Added support for event validation.

	* RadioButtonList.cs: Added support for event validation.

	* TextBox.cs: Added support for event validation.

	* BulletedList.cs: Added support for event validation.

	* CheckBox.cs: Added support for event validation.

	* Button.cs: Added support for event validation.

2006-11-16 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: fixed: ActiveStepIndex property.

2006-11-15 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed: DataBinding for 2.0, for 1.x - refactoring only.

2006-11-14 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: Rows property, DataBinding flow.
	* DataBoundControl.cs:
	* BaseDataBoundControl.cs:		
	
2006-11-14 Igor Zelmanovich <igorz@mainsoft.com>

	* CompositeDataBoundControl.cs: fixed: 
	DataBind call Controls.Clear().

2006-11-13 Igor Zelmanovich <igorz@mainsoft.com>

	* CompositeDataBoundControl.cs: fixed: 
	DataBind sets ChildControlsCreated=true.

2006-11-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Login.cs: fixed CreateChildControls, throws exception if needed
	control not found
	* LoginView.cs: fixed CreateChildControls, check templates for null

2006-11-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Wizard.cs: fixed ActiveStepIndex property, fixed SideBar button
	rendering, fixed history updating
	* WizardStepCollection.cs: fixed implemented interfaces

2006-11-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* XmlDataSource.cs: CacheKeyDependency fixed

2006-11-12 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed:  DataKeys, PageCount, DataBinding flow.

2006-11-09 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsViewPagerRow.cs: fixed: must be not resolved as BindingContainer.

2006-11-09  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ParameterCollection.cs: fixed SetDirtyObject method
	* ObjectDataSource.cs, ObjectDataSourceView.cs: removed VievState
	utilization for control's properties, implemented caching
	* SqlDataSource.cs, SqlDataSourceView.cs: implemented caching

2006-11-09 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: DataKeys, PageCount, DataBinding flow.

2006-11-09 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed: 
	ConfirmInitState method s called by 
	the DataBoundControl class in its OnLoad method.

2006-11-06 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: DataBinding flow.

2006-11-02 Igor Zelmanovich <igorz@mainsoft.com>

	* CustomValidator.cs: implemented ValidateEmptyText fixture.

2006-11-02 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseCompareValidator.cs: fixed: CultureInvariantValues, Type properties.

2006-11-01 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: RenderEndTag.
	Dynamic menu is rendered when StaticDisplayLevels=1	

2006-11-01 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: UpdateRow, DeleteRow, RowCreated.

2006-11-01 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: UpdateItem, DeleteItem.

2006-10-31 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: PageIndex, UpdateItem, InsertItem.

2006-10-29 Igor Zelmanovich <igorz@mainsoft.com>

	* RadioButtonList.cs: fixed: has no html output when Items.Count=0.

2006-10-29 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed: setting SelectedVolue for 2.0.

2006-10-29 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl: fixed: ValidateDataSource allows null as dataSource.

2006-10-29 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed: assigning SelectedIndex with too hight value.

2006-10-29 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: fixed: DataBinding for 2.0.
	for 1.x refactoring only.	

2006-10-25 Igor Zelmanovich <igorz@mainsoft.com>

	* ChangePassword.cs: new class was implemented.

2006-10-25 Igor Zelmanovich <igorz@mainsoft.com>

	* EmbeddedMailObject.cs: new class was implemented.
	* EmbeddedMailObjectsCollection.cs: new class was implemented.
	* MailDefinition.cs: new class was implemented.

2006-10-24 Igor Zelmanovich <igorz@mainsoft.com>

	* PagerSettings.cs: fixed: CreatePagerControl.

2006-10-24 Igor Zelmanovich <igorz@mainsoft.com>

	* CommandField.cs: fixed: 
	considers CaseValidation, ValidationGroup, ButtonType.
	* DataControlButton.cs: refactoring:

2006-10-24 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: implemented: GetCallbackScript method.

2006-10-23 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: IPostBackContainer.GetPostBackOptions method.

2006-10-30 Igor Zelmanovich <igorz@mainsoft.com>

	* FormFiew.cs: fixed: UpdateItem, InsertItem.

2006-10-30 Igor Zelmanovich <igorz@mainsoft.com>

	* FormFiew.cs: fixed: PageIndex, rendering.

2006-10-30 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs: fixed: rendering "name" attribute".

2006-10-23 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: IPostBackContainer.GetPostBackOptions method.
	* DataControlButton.cs:	
	* CommandField.cs: CausesValidation feature must be implemented other way

2006-10-23 Igor Zelmanovich <igorz@mainsoft.com>

	* CompositeDataBoundControl.cs: fixed: CreateChildControls flow.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: OnBubbleEvent returns true when event is handled.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: OnBubbleEvent works properly.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: considers DataControlField.InsertVisible.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: CurrentMode property.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: current state are not changed during paging.

2006-10-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: 
	in Insert mode Select not invoked from DataSource
		
2006-10-18 Konstantin Triger <kostat@mainsoft.com>

	* ObjectDataSourceView.cs: use Type.GetType for loading full qualified types.

2006-10-17 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: CreateDataSourceSelectArguments method.
	(corresponding test does not work because bug in ObjectDataSourceView)

2006-10-17 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed: DataBind calls
	CreateDataSourceSelectArguments() and stores result in 	SelectArguments

2006-10-17 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: 
	* DetailsView.js: 
	fixed: EnablePagingCallbacks feature.
	when postback is invoked after callback control state is restored
	properly. 

2006-10-17 Vladimir Krasnov <vladimirk@mainsoft.com>

	* SqlDataSource.cs, SqlDataSourceView.cs: redesign and bug fixes

2006-10-17 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: fixed: CreateDataSourceSelectArguments method.
	(corresponding test does not work because bug in ObjectDataSourceView)

2006-10-12 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: EnableSortingAndPagingCallbacks feature.
	when postback is invoked after callback control state is restored
	properly. 

2006-10-12 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: Sorting feature.
	When sorting EditIndex and PageIndex are reseted

2006-10-12 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: Sorting feature.
	CreateDataSourceSelectArguments considers SortExpression and SortDirection.
	(corresponding test does not work because bug in ObjectDataSourceView)

2006-10-11 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: fixed: 
	CreateDataSourceSelectArguments works according to MSDN.
	(corresponding test does not work because bug in ObjectDataSourceView)

2006-10-11 Igor Zelmanovich <igorz@mainsoft.com>

	* ObjectDataSourceView.cs: fixed: 
	CanRetrieveTotalRowCount returns true if EnablePaging = false

2006-10-10 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed: DataBind flow
	CreateDataSourceSelectArguments() is called 
	each time as DataBind() is called	

2006-10-09 Igor Zelmanovich <igorz@mainsoft.com>

	* BoundField.cs: implemented ValidateSupportsCallback().

2006-10-09 Igor Zelmanovich <igorz@mainsoft.com>

	* CommandField.cs: ValidateSupportsCallback(): exception's message.

2006-10-08 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: CurrentMode property.

2006-10-08 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	* GridView.cs:
	* DetailsView.cs: 
	* PagerSettings.cs: 
	reverted r66222, problem solved in r66283: command buttons inherit ForeColor
		
2006-10-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Image.cs: write 'alt' after 'src' so that the HyperLink test do not
	fail.

2006-10-05 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HyperLink.cs: don't render the img tag 'by hand' but use an Image
	instead, which takes care of the 0/0px case. Also set the ToolTip
	property. Fixes bug #79585.

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs: optimization for previous patch

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: optimization for previous patch

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* DetailsView.cs:
	* DetailsViewRow.cs:
	implemented PrepareControlHierarchy()
	styles are applied correct

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	implemented PrepareControlHierarchy()
	styles are applied correct

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs:
	* DataControlButton.cs:
	* DataControlField.cs:
	implemented PrepareControlHierarchy()
	styles are applied correct
	command buttons inherit ForeColor

2006-10-05 Igor Zelmanovich <igorz@mainsoft.com>

	* WebControl.cs: fixed: CreateControlStyle()

2006-10-04 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs:
	* GridView.cs:
	* DetailsView.cs: 
	* PagerSettings.cs: 
	corrected pager rendering: Color style applied to A tag,
	Input type="image" used if ImageUrl is not empty.
		
2006-10-04 Igor Zelmanovich <igorz@mainsoft.com>

	* GridView.cs: corrected rendering 
	* ContainedTable.cs: added new helper class 
		
2006-10-03 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: 
	in Insert mode Select not invoked from DataSource
		
2006-10-03 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: 
	Pager is not shown when page count < 1
	in Edit mode use EmptyDataTemplate if there is no DataItem
	when page changed FormView stays in current state. 
		
2006-09-28 Igor Zelmanovich <igorz@mainsoft.com>

	* FormView.cs: fixed: OnBubbleEvent works properly
		
2006-09-25 Igor Zelmanovich <igorz@mainsoft.com>

	* DataBoundControl.cs: fixed: DataBind flow
	GetData return "empty" DataSourceView when no DataSource and DataSourceID
	was assigned to cause PerformDataBinding be called. 	
		
2006-09-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: use ExtractTemplateRows to determine if the style is
	applied to the Table in a template or to its rows. Fixes bug #78058.

2006-09-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListBox.cs: if the list is not enabled, don't require a postback.
	Fixes bug #79445.

2006-09-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* HyperLink.cs: don't output the nabvigate url if disabled.
	* LinkButton.cs: always call base.AddAttributesToRender(). Don't output
	the link URL if disabled.
	Fixes bug #79443.

2006-09-19 Igor Zelmanovich <igorz@mainsoft.com>

	* RadioButtonList.cs: 
	make it to consider CausesValidation and ValidationGroup properties
		
2006-09-19 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBoxList.cs: 
	make it to consider CausesValidation and ValidationGroup properties
		
2006-09-19 Igor Zelmanovich <igorz@mainsoft.com>

	* RadioButton.cs: 
	Page.Validate() is called when CausesValidation=true
		
2006-09-19 Igor Zelmanovich <igorz@mainsoft.com>

	* CheckBox.cs: 
	make onclick attribute to consider ValidationGroup property.
	
2006-09-18 Igor Zelmanovich <igorz@mainsoft.com>

	* BulletedLis.cs: 
	make rendering of the href attribute to consider ValidationGroup property.
	Page.Validate() is called when CausesValidation=true
	
2006-09-18 Igor Zelmanovich <igorz@mainsoft.com>

	* ListBox.cs: 
	make rendering of the onchange attribute to consider ValidationGroup 
	property.
	Page.Validate() is called when CausesValidation=true
	
2006-09-18 Igor Zelmanovich <igorz@mainsoft.com>

	* DropDownList.cs: 
	make rendering of the onclick attribute to consider ValidationGroup property
	Page.Validate() is called when CausesValidation=true
	
2006-09-18 Igor Zelmanovich <igorz@mainsoft.com>

	* ListControl.cs: 
	VewState saving and restoring rolled back to 1.1 implementation 
	(fixed corresponding test), corrected public interface (there are no 
	overriden methods SaveControlState, LoadControlState and OnInit), 
	implemented CausesValidation and ValidationGroup properties.
	
2006-09-18 Igor Zelmanovich <igorz@mainsoft.com>

	* TextBox.cs: 
	make rendering of the onclick attribute to consider ValidationGroup property
	Page.Validate() is called when CausesValidation=true
	
2006-09-14 Igor Zelmanovich <igorz@mainsoft.com>

	* LinkButton.cs: 
	implemented: RaisePostBackEvent, 
	refactoring: GetPostBackOptions used to build onclick client event

2006-09-14 Igor Zelmanovich <igorz@mainsoft.com>

	* ImageButton.cs: implemented IButtonControl.Click, RaisePostBackEvent

2006-09-14 Igor Zelmanovich <igorz@mainsoft.com>

	* BaseValidator.cs: implemented ValidationGroup feature on client side
	* ValidationSummary.cs:	

2006-09-12 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: corrected rendering
	* TreeNode.cs:	

2006-09-11  Konstantin Triger <kostat@mainsoft.com>

	* Login.cs: ensure the urls are correctly resolved.

2006-09-10 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: corrected rendering: styles are applied correct
	* TreeNode.cs:	
	* TreeNodeStyle.cs:	

2006-09-10 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: corrected rendering: HoverNodeStyle works
	* TreeNode.cs:	
	* TreeView.js:	

2006-09-10 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeStyle.cs: fixed: ViewState restored properly	

2006-09-10 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs:
	* TableStyle.cs:	
	* TableItemStyle.cs:	
	* DataGridPagerStyle.cs:	
	refactoring: makes Style class more flexible for inheriting and reuse	

2006-09-10 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: for PopulateOnDemand nodes expanded and checked 
	state restored correct on PostBack.
	* TreeView.js	

2006-09-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ObjectDataSourceView.cs: correctly find the type when it is not in the
	executing assembly. Fixes bug #78321. Patch by Marek Habersack.

2006-09-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ControlParameter.cs: fix search for controls so that they use their
	NamingContainer, not the Page. Patch by Marek Habersack that fixes
	bug #78320.

2006-09-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Login.cs: fix problem with the login control and master pages.
	Patch by Marek Habersack that fixes bug #78219.

2006-09-07 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: populating nodes.
	* TreeView.js	

2006-09-07 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNode.cs: fixed: ToggleExpandState.

2006-09-07 Andrew Skiba <andrews@mainsoft.com>

	* SqlDataSourceView.cs: return DataView from ExecuteSelect when
	DataSourceMode is DataSet.

2006-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: populating nodes flow.
	* TreeNodeCollection.cs
	* TreeNode.cs

2006-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeCollection.cs: fixed: ViewState saved and restored correct.	 

2006-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: corrected rendering: RenderBeginTag, RenderEndTag.	 

2006-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: when specified value is not one of 
	the TreeNodeTypes values exception is threw.	 

2006-09-06 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed: when specified image set is not one of 
	the TreeViewImageSet values exception is threw.	 

2006-09-05 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeStyleCollection.cs: fixed: ViewState saved and restored correct.	 

2006-09-04 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: implemented SetBit().	 

2006-09-03 Igor Zelmanovich <igorz@mainsoft.com>

	* CompareValidator.cs: fixed controltocompare attribute.	 

2006-09-03 Igor Zelmanovich <igorz@mainsoft.com>

	* Login.cs: fixed:
	when login attempt was not successful FailureText is shown.	 

2006-08-31 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: fixed: InvalidPasswordErrorMessage 
	is formatted correct. 

2006-08-31 Igor Zelmanovich <igorz@mainsoft.com>

	* CreateUserWizard.cs: 
	* CompleteWizardStep.cs: 
	* CreateUserWizardStep.cs: 
	* Wizard.cs:
	 fixed: ContinueButtonClick occurs when the user clicks 
	 the Continue button in the final user account creation step.
	 ContinueDestinationPageUrl - redirected after clicking 
	 the Continue button on the success page.	

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* Wizard.cs: refactoring: Button, ImageButton and LinkButton are used
	insted internal DataControlButton. 

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs: implemented GetPostBackOptions + refactoring

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* ImageButton.cs: implemented 2.0 features
	OnClientClick attached to onclick attribute.
	PostBackUrl, CausesValidation, ValidationGroup - used PostBackOptions
	generate onclick attribute.

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* LinkButton.cs: typo fix

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs: refactoring

2006-08-30 Igor Zelmanovich <igorz@mainsoft.com>

	* LinkButton.cs: implemented 2.0 features
	OnClientClick attached to onclick attribute.
	PostBackUrl, CausesValidation, ValidationGroup - used PostBackOptions
	for href attribute.

2006-08-29 Igor Zelmanovich <igorz@mainsoft.com>

	* Button.cs: implemented 2.0 features

2006-08-28 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: refactoring
	* Style.cs:

2006-08-27 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeView.cs: fixed data binding

2006-08-27 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeBinding.cs: fixed ToString method

2006-08-27 Igor Zelmanovich <igorz@mainsoft.com>

	* MenuItem.cs: typo fix

2006-08-27 Vladimir Krasnov <vladimirk@mainsoft.com>

	* CreateUserWizardStep.cs: fixed validators message display

2006-08-25  Kornél Pál  <kornelpal@gmail.com>

	* FileUpload.cs: Use assembly name constants.

2006-08-08 Vladimir Krasnov <vladimirk@mainsoft.com>

	* TemplateField.cs: fixed ExtractValuesFromCell, .net aspx parser not
	always creates ExtractTemplateValuesMethod delegate

2006-08-24 Igor Zelmanovich <igorz@mainsoft.com>

	* TreeNodeBinding.cs: corrected public interface
	* TreeNodeStyle.cs: 

2006-08-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TextBox.cs: fix for bugs #76771 and #79020. A test breaks for the 2.0
	case, but there are many others.

2006-08-23 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: corrected rendering of static and dynamic items
	* Menu.js: 

2006-08-23 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs:
	* FontInfo.cs: 
	fixed: AddAttributesToRender method calls FillStyleAttributes,
	text styles applied correct.

2006-08-23 Igor Zelmanovich <igorz@mainsoft.com>

	* FontInfo.cs: 
	fixed: when removed the names from the bag also removed FontStyles.Names flag from fontstyles.
	refactoring: Name and Names properties has same source in bag.

2006-08-23 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: restored r63894: for 1.x is refactoring only

2006-08-22 Igor Zelmanovich <igorz@mainsoft.com>

	* FontInfo.cs: 
	fixed: CopyFrom and MergeWith behave differently between 1.1 and 2.0.
	added ClearDefaults method for 2.0.

2006-08-08 Vladimir Krasnov <vladimirk@mainsoft.com>

	* ObjectDataSourceStatusEventArgs.cs: ExceptionHandled default value
	should be false

2006-08-22 Igor Zelmanovich <igorz@mainsoft.com>

	* SubMenuStyle.cs: fixed:
	Unit.ToString() already include unit (e.g. "3px")

2006-08-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs:
	* ChangeLog: revert r63894. It modified the 1.x profile, it wasn't
	submitted for review and it only added tests for the 2.0 profile.

2006-08-08 Vladimir Krasnov <vladimirk@mainsoft.com>

	* FormView.cs: added explicit implementation of
	IDataItemContainer.DataItemIndex, as documented

2006-08-17 Igor Zelmanovich <igorz@mainsoft.com>

	* Style.cs: fixed:
	When style is registered with StyleSheet AddAttributesToRender method
	adds class attribute but not style to writer 

2006-08-15 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed: 
	OnBubleEvent works properly - controls like Button, LinkButton nested into template
	can raise MenuItemClick event,
	ViewState of Items saved and restored properly.

2006-08-14 Andrew Skiba <andrews@mainsoft.com>

	* TableStyle.cs: replace ResolveUrl with ResolveClientUrl to match
	MS.NET's behaviour.

2006-08-14 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs: fixed databinding feature:
	ensure that items initialization occurs only once

2006-08-10 Igor Zelmanovich <igorz@mainsoft.com>

	* Menu.cs, MenuItem.cs: fixed databinding feature

2006-08-09  Robert Jordan  <robertj@gmx.net>

	* DataControlButton.cs, Image.cs, AdRotator.cs, HyperLink.cs:
	replace ResolveUrl with ResolveClientUrl to match MS.NET's
	behaviour. Fixes bug #77539.

2006-08-09 Igor Zelmanovich <igorz@mainsoft.com>

	* HierarchicalDataBoundControl.cs: fixed DataBind flow

2006-08-08 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Content.cs:
	* Label.cs:
	* ListControl.cs:
	* MultiView.cs:
	* WebControl.cs: fixed ParseChildren attribute to be compliant
	to .net

2006-08-03 Vladimir Krasnov <vladimirk@mainsoft.com>

	* MultiView.cs: fixed: EnableTheming property

2006-08-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs:
	* Label.cs:
	* TreeView.cs: Patch by Marek Habersack that fixes bug #78968 take 2.

2006-08-03 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Style.cs: fixed restoring FontInfo from ViewState

2006-08-03 Vladimir Krasnov <vladimirk@mainsoft.com>

	* XmlDataSource.cs: implemented caching functionality

2006-07-31 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagerSettings.cs: Fixed the pager range calculation formula. The old
	one didn't work with more than 20 pages. Patch by Marek Habersack that
	closes bug #78328.

2006-07-30 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: fixes to make Render more similar to dotnet.

2006-07-30 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Wizard.cs: fixed return value of OnBubbleEvent

2006-07-30 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: init BottomPagerRow.ItemIndex with 0; gracefully
	handle null result of GetData().

2006-07-30 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: use TableStyle for ControlStyle.

2006-07-30 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: save DataKeyNames and DefaultMode in ControlState.

2006-07-30 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: init DataKeys and fix null reference.

2006-07-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TreeView.cs: several changes to improve compatibility with MS.
	Patch by Marek Habersack that fixes bug #77551.

2006-07-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs: output the text-decoration value even when it is 'none'.
	Patch by Marek Habersack that fixes bug #78968.

2006-07-27 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: initialize PageCount with 0; fix IsBindableType to
	include Decimal.

2006-07-27 Andrew Skiba <andrews@mainsoft.com>

	* DetailsViewRowCollection.cs: returns this in SyncRoot.

2006-07-27 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: throw ArgumentOutOfRange exception on bad CellSpacing
	and CellPadding.

2006-07-27 Andrew Skiba <andrews@mainsoft.com>

	* ObjectDataSource.cs: add doc and fix usage of MergeParameterValues

2006-07-27 Andrew Skiba <andrews@mainsoft.com>

	* AutoGeneratedField.cs: fix the internal constructor according to test
	DetailsView_CreateAutoGenerateRow.

2006-07-26 Vladimir Krasnov <vladimirk@mainsoft.com>

	* XmlDataSource.cs: implemented XSLT, removed properties from
	view state
	* XmlDataSourceView.cs: fixed default xpath

2006-07-26 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: fix IsBindableType in accordance with MSDN and tests.

2006-07-25 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Wizard.cs: fixed ActiveStep property
	fixed templated side bar

2006-07-25 Andrew Skiba <andrews@mainsoft.com>

	* ImageField.cs: fix null reference bug.

2006-07-25 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: init DataKey property with empty collection.
	* DataKey.cs: fix unexpected exception bug.
	* DataControlField.cs: override ToString according to MSDN.

2006-07-24 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: create table style in CreateControlStyle.

2006-07-24 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: don't throw the exception which .Net does not throw.

2006-07-24 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: save DefaultMode and DataKeyNames in control state,
	to match .Net; fix PageCount to match record count.

2006-07-24 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Menu.cs: fixed properties default values, fixed rendering
	SkipLinkText

2006-07-23 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Wizard.cs: implemented SkipLinkText, TagKey
	fixed rendering bugs, fixed templated button bar rendering
	fixed side bar rendering
	* WizardStepBase.cs: fixed Name property

2006-07-23 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: fix the regressions, caused by the previous commit.

2006-07-23 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: correct handling the different default values of
	DetailsView.CellSpacing and Table.CellSpacing.

2006-07-23 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: create a pager row when needed.

2006-07-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DetailsView.cs:
	* GridView.cs:
	* PagedDataSource.cs:
	* FormView.cs:
	* ImageButton.cs:
	* LinkButton.cs: implement GetPostBackOptions for the 2.0 controls that
	support it. The GridView control will no longer throw an exception when
	rendered in the paging mode. Patch by Marek Habersack. Fixes bug #78288.

2006-07-20 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: many fixes: initialize PageCount with 0; initialize
	Rows with empty collection; call EnsureChildControls from get Row;
	NullReference in DeleteItem; fix RenderGrid (ideas from GridView);
	implemented IPostBackContainer.GetPostBackOptions.

2006-07-20 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: create HeaderRow and FooterRow even when HeaderText
	and FooterText are empty, to match .NET. Otherwise we have NullReference
	when .NET does not.

2006-07-20 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: Render fix.

2006-07-20 Andrew Skiba <andrews@mainsoft.com>

	* BoundField.cs: don't call DataBinder.GetPropertyValue with empty
	property name.

2006-07-20 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: NullReferenceException fix

2006-07-20 Vladimir Krasnov <vladimirk@mainsoft.com>

	* PagerSettings.cs: implemented PropertyGhanged event

2006-07-18 Andrew Skiba <andrews@mainsoft.com>

	* DetailsView.cs: throw ArgumentOutOfRangeException for compatibility
	with .Net; don't throw NotImplemented when base class implementation
	is available.

2006-07-18 Andrew Skiba <andrews@mainsoft.com>

	* DetailsViewPagerRow.cs: add a stub for this class

2006-07-17 Vladimir Krasnov <vladimirk@mainsoft.com>

	* GridView: fixed DataKeyNames property, moved to ControlState
	fixed PageCount property, initial PageCount ahould be zero
	fixed SelectedDataKey, should throw exception if not initialized
	fixed CreateColumns, wrong order of columns
	fixed CreateControlStyle,
	fixed InitializePager, no columnspan attrib on only one column
	fixed LoadControlState, SaveControlState added DataKeyNames
	fixed Render, RenderGrid should render within div tag
	implemented GetPostBackOptions
	* DataControlButton.cs: fixed Render, fixed style for img button

2006-07-17 Vladimir Krasnov <vladimirk@mainsoft.com>

	* CheckBoxField.cs: fixed InitializeDataCell, tooltip only in edit
	mode

2006-07-17 Andrew Skiba <andrews@mainsoft.com>

	* CommandField.cs: fixed ValidateSupportsCallback

2006-07-17 Andrew Skiba <andrews@mainsoft.com>

	* Image.cs: prepare to use HttpBrowserCapabilities. Does not
	affect the flow yet.

2006-07-17 Andrew Skiba <andrews@mainsoft.com>

	* SiteMapPath.cs: fixes for SiteMapPathTest.Render_xxx tests.

2006-07-16 Andrew Skiba <andrews@mainsoft.com>

	* WebControl.cs: fix for AddAttributesToRender - add display
	style when appropriate

2006-07-16 Vladimir Krasnov <vladimirk@mainsoft.com>

	* CommandField.cs: fixed InitializeCell, wrong order of command 
	buttons
	* ImageField.cs: image field with null src and ConvertEmptyStringToNull
	should be rendered as label
	* BoundField.cs: empty null value should be rendered as nbsp
	* GridViewRowCollection.cs: fixed SyncRoot

2006-07-16 Andrew Skiba <andrews@mainsoft.com>

	* SiteMapPath.cs: create Literal instead of Label according to the
	MSDN and test SiteMapPath_InitializeItem.

2006-07-16 Vladimir Krasnov <vladimirk@mainsoft.com>

	* Style.cs: BorderStyle should be added if BorderWidth greater than 0
	* Image.cs: in 2.0 there is no border attribute, but border-width
	style attribute

2006-07-14 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Button.cs: always render the 'name' attribute. Fixes bug #78746.

2006-07-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: correctly initialize editable items when there's an
	EditItemTemplate. Patch by Jarosław Pawlak.

2006-07-13  Juraj Skripsky <js@hotfeet.ch>

	* CheckBox.cs (LoadPostData): the value of a disabled checkbox remains
	unchanged.

2006-07-13 Vladimir Krasnov <vladimirk@mainsoft.com>

	* BulletedList.cs: fixed Render, RenderBulletText, various properties
	* ListItem.cs, ListItemCollection.cs: added Enabled property that is 
	new in 2.0

2006-07-12 Vladimir Krasnov <vladimirk@mainsoft.com>

	* MultiView.cs: 'initied' state variable was changed to views count in
	the views collection.

2006-07-11 Vladimir Krasnov <vladimirk@mainsoft.com>

	* AutoGeneratedField.cs: fixed InitializeDataCell, autogenerated
	checkbox should have tooltip
	* HyperLinkField.cs: fixed InitializeCell, should create link control
	only in data cell (not in header or footer), initialization of 
	ControlStyle
	* ImageField.cs: fixed InitializeDataCell, initialization of 
	ControlStyle

2006-07-11 Vladimir Krasnov <vladimirk@mainsoft.com>

	* MultiView.cs: removed exception throwing from ActiveViewIndex

2006-07-11 Konstantin Triger <kostat@mainsoft.com>

	* DataControlFieldCollection.cs: added OnClearComplete override;
		refactor to eliminate null reference exception.

2006-07-11 Vladimir Krasnov <vladimirk@mainsoft.com>

	* MultiView.cs: fixed ActiveViewIndex, AddParsedSubObject
	* View.cs: fixed Visible property

2006-07-09 Konstantin Triger <kostat@mainsoft.com>

	* ImageField.cs: fixing .net compliancy.

2006-07-10 Andrew Skiba <andrews@mainsoft.com>

	* SiteMapPath.cs: fix the default PathSeparator value.

2006-07-06 Konstantin Triger <kostat@mainsoft.com>

	* GridView.cs: always create Header/Fotter rows, but render only when
	ShowHeader/Footer is true. Compute Header/Footer rows from rows
	collection.
	* CheckBoxField.cs: add override to ApplyFormatInEditMode,
	add ToolTip and Text to the created CheckBox,
	wrap exception thrown in OnDataBindField in httpException.

2006-07-06 Konstantin Triger <kostat@mainsoft.com>

	* DataControlField.cs,BoundField.cs: bug fixes found by BoundFieldTest.

2006-07-05 Konstantin Triger <kostat@mainsoft.com>

	* DataControlField.cs: correct handling empty header/footer text.
	* TemplateField.cs: correct initialization according to
	DataControlRowState.

2006-07-05  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Wizard.cs: added functionality for Templated WizardStep
	and CreateUserWizard
	* added CompleteWizardStep.cs,	CreateUserWizard.cs, 
	CreateUserWizardStep.cs, TemplatedWizardStep.cs

2006-07-05 Konstantin Triger <kostat@mainsoft.com>

	* AutoGeneratedField.cs: correcting default dataType.

2006-07-03  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataControlField.cs: fixed Initialize, should always return false

2006-07-03  Lluis Sanchez  <lluis@novell.com>

	* BoundField.cs: Fix setter for HtmlEncode (it was setting always True).

2006-07-03 Konstantin Triger <kostat@mainsoft.com>

	* DataBoundControl.cs: implement MarkAsDataBound and consider it while
	setting RequiresDataBinding in OnLoad event.
	* GridView.cs: DataBind rows before other control can access the data.
	* BoundField.cs: add unique ID to control for postback parameters.

2006-07-03 Konstantin Triger <kostat@mainsoft.com>

	* WebControl.cs: fix typo in EnableTheming.

2006-07-02 Konstantin Triger <kostat@mainsoft.com>

	* MenuItemCollection.cs: save items if the collection is dirty.
	* MenuItem.cs: During data binding: initialize Text and invoke binding recoursively.
	Add item to collection before binding to let the state be correctly tracked.
	* Menu.cs: Add item to collection before binding to let the state be correctly
	tracked.

2006-06-28 Juraj Skripsky <js@hotfeet.ch>

	* RegularExpressionValidator.cs (EvaluateIsValid): wrap regex to
	test against with "^...$" if necessary. MS.NET does this too.

2006-06-28  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* WizardStepCollection.cs: Fixed Add methods to initialize
	WizardStep.Wizard property
	* Wizard.cs: Fixed ActiveStepIndex, it should be -1 if there no steps
	Fixed GetStepType, if only one step present, it should be FinishStep
	Fixed styles of tables for more accurate rendering, fixed Wizard 
	buttons order

2006-06-28 Konstantin Triger <kostat@mainsoft.com>

	* FormView.cs: instantiate correct template when the bounding data source is
	empty.

2006-06-25 Konstantin Triger <kostat@mainsoft.com>

	* FormView.cs: disabling setting out of range FormView.PageIndex.

2006-06-21 Andrew Skiba <andrews@mainsoft.com>

	* FileUpload.cs: added

2006-06-20 Andrew Skiba <andrews@mainsoft.com>

	* FormView.cs: handle CssClass attribute

2006-06-14 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Button.cs: do something in PostBackUrl.
	* Repeater.cs: when creating the RepeaterItemCollection, initialize
	'items' if it hasn't been done yet. Fixes bug #78417.

2006-06-14  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* BaseDataList.cs: added ConnectToDataSource method that called from 
	OnLoad, fixed GetData method
	* Wizard.cs: fixed bug when called MoveTo after that control hierarchy
	has been created

2006-06-14  Andrew Skiba <andrews@mainsoft.com>

	* Menu.cs: add CssStyle value to the rendered class attribute

2006-06-13 Juraj Skripsky <js@hotfeet.ch>

	* Calendar.cs: Make sure WebControls.Enabled is respected.
	* SelectedDatesCollection.cs: Set time for all DateTime object passed in
	to 12:00am as MS.NET does the same.
	Fixes bug #71251.

2006-06-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Repeater.cs: fixed ConnectToDataSource method, subscribed to
	DataSourceViewChanged, looks for a datasource in its parent control
	fixed GetData method, should not get data if datasource is null

2006-06-13  Konstantin Triger  <kostat@mainsoft.com>

	* ObjectDataSourceView.cs: raise OnDataSourceViewChanged events when data changes.

2006-06-11  Konstantin Triger  <kostat@mainsoft.com>

	* GridView.cs: set the row index from GridRowView if CommandArgument does not contain this information.

2006-06-11  Konstantin Triger  <kostat@mainsoft.com>

	* ObjectDataSourceViewTest.cs: return documented default for OldValuesParameterFormatString.

2006-05-24  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataList.cs: Fixed LoadViewState method

2006-05-04  Lluis Sanchez  <lluis@novell.com>

	* BoundField.cs: Added missing throw kyword. Patch by Marek Habersack.

2006-04-25  Konstantin Triger  <kostat@mainsoft.com>

	* BaseDataBoundControl.cs: ensure the control is bound if ViewState is disabled.

2006-04-25 Konstantin Triger <kostat@mainsoft.com>

	* FormView.cs: fix FormView.PageCount after data binding.

2006-04-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CheckBox.cs: certain attributes have to be rendered in the input tag,
	not the <span>. Fixes bug #71251.

2006-04-20  Konstantin Triger  <kostat@mainsoft.com>

	* BaseDataBoundControl.cs: RequiresDataBinding rebinds if the control prerendered.
	* FormView.cs: 
		enable binding.
		ensure rebinding when FormView.PageIndex is called.
		and bind to the correct PageIndex.

2006-04-20  Konstantin Triger  <kostat@mainsoft.com>

	* MenuItem.cs: when binding to IHierarchyData, check whether 
		it implements INavigateUIData and retrieve NavigateUrl.
	* CompositeDataBoundControl.cs: ensures data is bound before creating child controls.
	* Menu.cs:
		Enable DataBinding by not throwing NotImplementedException in OnDataBound event. 
		Provide basic CreateChildControls implementation by ensuring the control is bound. 
		Ensure the child controls are created when the postback event is raised. 
		Provide default implementation for SkipLinkText to let the default functionality to work.

2006-04-11  Lluis Sanchez  <lluis@novell.com>

	* TreeNodeBinding.cs: Added HasPropertyValue property
	  to check if some properties have a value in the
	  state bag.
	* TreeNode.cs: Lazily get the dataPath. Instead of getting
	  bound properties when they are requested, get all of
	  them when the node is bound and store their values in
	  the state bag. In this way it won't be necessary to
	  query every time the datasource to get the values.
	* XmlHierarchyData.cs: Implemented IHierarchyData.Path.
	* TreeView.cs: Call base in OnInit(). Bind nodes after
	  adding them to the list, to properly keep track of
	  changes. Don't databind in postbacks.

2006-04-11  Chris Toshok  <toshok@ximian.com>

	* Login.cs (OnLoggingIn): use Events[loggingInEvent].

2006-04-06	Konstantin Triger <kostat@mainsoft.com>

	* BaseDataList.cs: Fix searching control by DataSourceID.
	* DataList.cs: Enable binding using DataSourceID for NET_2_0.

	
2006-04-06	Konstantin Triger <kostat@mainsoft.com>

	* Login.cs: Added LayoutTemplate property support.
	* LoginView.cs: Added LoggedInTemplate, AnonymousTemplate support.
		DataBind: correctly bind child controls.
		Implemented OnViewChanged, OnViewChanging, Render, Save/LoadControlState.

2006-03-29  Robert Jordan  <robertj@gmx.net>
 
	* DataGrid.cs: if custom paging is enabled the persisted item count
	must be the count of the rendered items, otherwise paging from the
	last to a previous page won't work correctly. Fixes bug #77556.
 
2006-03-29  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* RepeatInfo.cs: fixed RenderBeginTag to set enabled value of table
	when rendering disabled list control

2006-03-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Panel.cs: render the image url inside 'url()'. Fixes bug #77811.

2006-03-28  Alexandre Miguel Pedro Gomes  <alexmipego@gmail.com>

	* FontInfo.cs: Implemented ShouldSerializeNames

2006-03-23  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataGrid.cs, DataList.cs, RepeatInfo.cs: added accessablity features

2006-03-23  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataGrid.cs: fixed CreateControlHierarchy, added CurrentPageIndex
	validation
	in PrepareControlHierarchy fixed style applying to AlternatingItem

2006-03-22  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataList.cs: fixed RepeatColumns property, added value validation
	in PrepareControlHierarchy method fixed style applying for
	AlternatingItem, EditItem and Separator item
	fixed RenderContents method, if no items exist, no nned to
	render emty table strructure.

2006-03-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CompareValidator.cs: when searching for the control to compare, use
	NamingContainer instead of Page. Fixes bug #77793.

2006-03-15  Chris Toshok  <toshok@ximian.com>

	* SiteMapPath.cs (InitializeItem): in the Current and Root node
	cases, apply the NodeTemplate if it exists and there isn't a
	CurrentNodeTemplate or RootNodeTemplate, respectively.

2006-03-15  Chris Toshok  <toshok@ximian.com>

	* SiteMapDataSourceView.cs (OnDataSourceViewChanged): override.

	* SiteMapDataSource.cs (StartingNodeOffset): new property.
	(GetStartNode): add code to handle StartNodeOffset < 0.

	* CompositeControl.cs
	(ICompositeControlDesignerAccessor.RecreateChildControls): just
	call the non-iface method.

	* DataBoundControl.cs (GetDataSource): this is likely wrong, but
	traverse up the naming container tree looking for our datasource
	if we're bound using a DataSourceID.  This fixes things in the
	sitemap1 test, which uses a mixture of templates and
	ContentPlaceholders with the sitemapdatasource and sitemappath at
	different levels in the naming container tree (let along the
	itemnode template.)

	* SiteMapPath.cs (DataBind): implement this by chaining up to
	base.DataBind, then by looping over our children, emitting
	OnItemDataBound for each SiteMapNodeItem.
	(AddAttributesToRender): remove.
	(CreateChildControls): call DataBind as the final step here..  I
	have, of course, no idea if this is right.
	(CreateControlHierarchy): don't databind our children here, as
	they need to be in the Controls collection before we do.
	(RenderContents): render our accessibility/screenreader stuff
	here, if SkipLinkText != "".

2006-03-15  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataGridPagerStyle.cs: fixed PrevPageText property

2006-03-13  Chris Toshok  <toshok@ximian.com>

	* BaseCompareValidator.cs (Convert): make the
	ValidationDataType.String case a bit more compact.

2006-03-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListBox.cs:
	(RenderContents): don't call base.RenderContents. Fixes bug #77740.
	Patch by Hubert Fongarnand.

2006-03-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* FontInfo.cs: fixed CopyFrom, this method should not reset the 
	received fontinfo if it is the same instance
	fixed ToString, corrected output where only font size specified

2006-03-13  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Style.cs: fixed WriteStyleAttributes to set border style to solid,
	if it not set but the border has width
	fixes in CopyFrom, MergeWith correct unit compare when it has zero 
	value

2006-03-12  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataGrid.cs: in AddColumnsFromSource method fixed columns from
	properties of custom class
	fixed InitializeNumericPager, pager numbers should be a Label control
	fixed CreateControlHierarchy, corrected dataset index of items if
	paging is enabled

2006-03-09  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataList.cs: fixed DoItemInLoop method that fixes itemIndex
	of separator item.
	fixed CreateControlStyle to set correct cellspacing of table style
	fixed InitializeItem to correct applying template to selected and
	edit items.

2006-03-08  Chris Toshok  <toshok@ximian.com>

	* SiteMapNodeType.cs: nuke.

	* BorderStyle.cs, ButtonColumnType.cs, CalendarSelectionMode.cs,
	DayNameFormat.cs, ListItemType.cs, ListSelectionMode.cs,
	NextPrevFormat.cs, PagerMode.cs, PagerPosition.cs,
	RepeatDirection.cs, RepeatLayout.cs, TableRowSection.cs,
	TextAlign.cs, TextBoxMode.cs, TitleFormat.cs,
	ValidationCompareOperator.cs, ValidationDataType.cs,
	ValidationSummaryDisplayMode.cs, ValidatorDisplay.cs: remove
	[Serializable] in 2.0.

	* DayNameFormat.cs: add "Shortest".

2006-03-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* LinkButton.cs: fixed AddAttributesToRender, removed not needed 
	language attribute

2006-03-08  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TextBox.cs: fixed missing value validations, fixed rendering
	of empty value attribute

2006-03-07  Chris Toshok  <toshok@ximian.com>

	* WebControl.cs (EnableTheming): leave the MonoTODO, but implement
	by chaining up to base.EnableTheming.

2006-03-07  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* DataList.cs: fixed CreateControlHierarchy, fixes 77693

2006-03-06  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* RadioButton.cs: added ValueAttribute property to store the button
	value when in list
	* RadioButtonList.cs: fixed tab index when rendering.

2006-03-02  Chris Toshok  <toshok@ximian.com>

	* WebControl.cs (SkinID): implement setter/getter, and have them
	just chain up to base.SkinID.

2006-02-27  Chris Toshok  <toshok@ximian.com>

	* SqlDataSource.cs: track change to DataSourceControl's protected
	methods.

	* AccessDataSource.cs: same.

2006-02-27  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListControl.cs: fixed SelectedIndex property, fixed selection
	reset on incorrect value

2006-02-27  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* TableStyle.cs: fixed AddAttributesToRender function, style
	BorderCollapse:Collapse was added if table's CellSpacing is zero

2006-02-23  Chris Toshok  <toshok@ximian.com>

	* CheckBox.cs, ContentControlBuilderInternal.cs, Content.cs,
	ContentPlaceHolderBuilder.cs, ContentPlaceHolder.cs,
	DataControlFieldHeaderCell.cs, DataGridColumn.cs,
	HierarchicalDataBoundControl.cs, HyperLinkField.cs,
	ImageButton.cs, ImageField.cs, Literal.cs,
	ObjectDataSourceView.cs, TextBox.cs: more corcompare work.

	* BaseCompareValidator.cs, BaseValidator.cs, Button.cs,
	DataControlField.cs, DetailsView.cs, FormView.cs, GridView.cs,
	HotSpot.cs, LinkButton.cs, Login.cs, SiteMapDataSource.cs,
	SqlDataSourceCommandType.cs, TableSectionStyle.cs,
	TemplateField.cs, TreeNodeCollection.cs, TreeNode.cs, TreeView.cs,
	ValidationSummary.cs, WizardStepBase.cs: fix tons of corcompare
	errors.  most were caused by a property/method being virtual when
	it shouldn't be, or vice versa.

2006-02-22  Chris Toshok  <toshok@ximian.com>

	* ObjectDataSource.cs: corcompare work.

2006-02-22  Chris Toshok  <toshok@ximian.com>

	* ParameterCollection.cs: add an EditorAttribute to the class.

	* Parameter.cs: cleanup, fix the Value property, and implement the
	Size property.

	* SqlDataSourceView.cs: clean things up a bit, and add handling
	for parameters.

2006-02-22  Chris Toshok  <toshok@ximian.com>

	* SqlDataSourceFilteringEventArgs.cs: formatting.

	* SqlDataSourceSelectingEventArgs.cs: remove ExecutingSelectCount,
	both the property and ctor arg.

	* AccessDataSourceView.cs (ExecuteSelect): use SelectingEventArgs,
	not CommandEventArgs.  Also, cast the return value of
	oleCommand.ExecuteReader.

	* AccessDataSource.cs (.ctor): fix the ctors and remove FIXME
	comments.
	(GetDbProviderFactory): implement naively, and leave a MonoTODO.
	(GetPhysicalDataFilePath): implement, again naively.  this is
	where the NRE is generated when we access ConnectionString in a
	testcase on .net.
	(ConnectionString): dynamically generate this based on our
	DataFile attribute.
	(DataFile): clear the ConnectionString in the setter so we'll
	regenerate it.
	(ProviderName): use base.ProviderName in the getter, not
	this.ProviderName, so we don't recurse infinitely.
	
	* SqlDataSourceView.cs: start reworking this class.

	* SqlDataSource.cs (GetDbProviderFactory): implement this,
	following the MS docs on the matter (if ProviderName is null/"",
	return SqlClientFactory.Instance.)
	(GetDbProviderFactoryInternal): add an internal method for use by
	SqlDataSourceView.
	(TrackViewState): don't invoke View.TrackViewState unless we have
	one.
	(Selecting): change event handler type to match MS.
	(Filtering): add missing event.
	(View): call CreateDataSourceView, don't just create an
	SqlDataSourceView.
	
2006-02-21  Chris Toshok  <toshok@ximian.com>

	* BoundField.cs: ues the ViewState.Get* pattern with default
	instead of the explicit ViewState lookup + null check, and fix the
	scope of InitializeDataCell.

	* ButtonField.cs: ues the ViewState.Get* pattern with default
	instead of the explicit ViewState lookup + null check.

	* CommandField.cs: same.

	* CheckBox.cs: same.

	* AutoGeneratedFieldProperties.cs: same.

	* BaseDataList.cs: same.

	* CircleHotSpot.cs: same.

	* BulletedList.cs: same.

	* DataBoundControl.cs: same.

	* CookieParameter.cs: same.

	* ControlParameter.cs: same.

	* CustomValidator.cs: same.

	* ButtonFieldBase.cs: same.

	* CheckBoxField.cs: same, and fix the scope of InitializeDataCell.

	* AutoGeneratedField.cs: fix scope of InitializeDataCell.

	* BaseValidator.cs: same, and clean up the getter/setter formatting.

	* CompareValidator.cs: same.
	
2006-02-20  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* ListControl.cs: fixed DataSource property, to throw 
	ArgumentException on incorrect value

2006-02-20  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* Image.cs: fixed missing border="0" attribute, when image has style, 
	but border width is not specified.

2006-02-20  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* CheckBox.cs: fixed InternalAddAttributesToRender, Render to
	correct the "disabled" attribute in CheckBoxList
	* CheckBoxList.cs: fixed RenderItem, to correct the "disabled" 
	attribute in CheckBoxList

2006-02-20  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* CheckBox.cs: fixed Render function, removed rendering of empty 
	<span> element if ControlStyleCreated but it's empty.
	fixed "disabled" attribute, it should be placed into span element

2006-02-20  Vladimir Krasnov  <vladimirk@mainsoft.com>

	* BoundColumn.cs: fixed InitializeCell function, if DataField is 
	null or empty string, the cell should not be bound.

2006-02-08  Chris Toshok  <toshok@ximian.com>

	* ListControl.cs (OnDataBinding): in 2.0, only clear our items if
	AppendDataBoundItems != false.  Also, split all the databinding
	logic out to DoDataBinding, which we call from here only if
	!NET_2_0.
	(DoDataBinding): new function. actually perform the binding.
	(PerformDataBinding): implement.
	(PerformSelect): chain up to base class.

2006-02-07  Chris Toshok  <toshok@ximian.com>

	* ContentPlaceHolder.cs: fix ToolboxDataAttribute.

	* Content.cs: use ContentControlBuilderInternal, and add a bunch
	of unused (for now) EventHandler's here.

	* ContentControlBuilderInternal.cs: rename ContentControlBuilder
	to this.

2006-01-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListControl.cs: bound checking for Items when loading the control
	state, as the number might have been changed on the fly. Patch by
	Elliott Draper.

2006-01-22  Chris Toshok  <toshok@ximian.com>

	* CheckBox.cs: s/GetPostBackClientEvent/GetPostBackEventReference.

	* MultiView.cs (OnBubbleEvent): case the rhs to a string to get
	the intended comparison right and quiet mcs.

2006-01-15 Konstantin Triger <kostat@mainsoft.com>

	* Button.cs: Add semicolon after client script if does not exist.

2006-01-15 Konstantin Triger <kostat@mainsoft.com>

	* Button.cs: preserve user logic when adding client validation.

2006-01-15 Konstantin Triger <kostat@mainsoft.com>

	* BaseValidator.cs: fixing visibility bahavior

2006-01-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* RangeValidator.cs: allow empty data from the control. Patch from Marek
	Habersack that fixes bug #77239.

2006-01-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: use the DateTimeFormatInfo from the current thread. Patch
	by Cyrille Colin. Closes bug #77184.

2006-01-08  Konstantin Triger <kostat@mainsoft.com>

	* PagedDataSource.cs, DataGrid.cs: TARGET_JVM changes to let the
	 compilation pass with csc 1.1.

2005-12-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DropDownList.cs: HtmlEncode the item text. Fixes bug #76949.

2005-12-07  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: in the uplevel rendering case, don't render
	the text if the validator's Display attribute is "None".  Should
	fix bug #76924.

2005-11-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* RadioButton.cs: if the 'value' attribute is set explicitly (as
	RadioButtonList does now), use that as the 'name' attribute.
	* RadioButtonList.cs: set the AutoPostBack and Enabled properties of
	the radiobuttons.

	Fixes bug #76706.

2005-11-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CheckBox.cs: add possible 'internal' attributes to the input tag. Fix
	the 'name' attribute when not aligninng to the right.
	* RadioButton.cs: use NameAttribute instead of GroupName when indexing
	the collection. Raise the OnCheckedChanged event. Fixes bug #76710.

2005-11-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: clear the control collection on every call to
	CreateControlHierarchy. Fixes bug #76732.

2005-11-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListBox.cs: Rows and SelectionMode are virtual in 1.1

2005-11-21 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CheckBox.cs: use the NameAttribute property for setting 'name'.
	* RadioButton.cs: get a UniqueID based identifier for 'name'.
	Fixes bug #76710.

2005-11-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* LinkButton.cs: don't output any javascript when the linkbutton is
	disabled. Fixes bug #76713.

2005-11-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: use TableHeaderCell instead of TableCell for headers when
	UseAccesibleHeader property is true. Patch by Robert Jordan.

2005-11-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseValidator.cs: 'controltovalidate' must be the ClientID of the
	control to validate. Fixes bug #76641.

2005-11-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BoundColumn.cs: when the column is readonly and we're in edit mode,
	keep it as a TextBox. Fixes bug #76714.

2005-11-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListBox.cs: render the 'onchange' attribute when AutoPostback is
	enabled. Fixes bug #76608.

2005-11-03 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CheckBox.cs: AddAttributesToRender was extra in 1.1, so moved all
	the logic to Render and make it render the ID, which fixes bug #76596.

2005-10-25 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Repeater.cs: someone forgot the curly brackets. Fixes bug 76537.

2005-10-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Literal.cs: allow LiteralControl as child, but instead of adding it
	to the control collection, it just gets the Text out of it.

2005-10-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagedDataSource.cs: fix range when we're at the last page.
	* DataGrid.cs: only need to keep the item count in the viewstate.
	Fixes bug #76503.

2005-10-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListControl.cs: made GetSelectedIndices() internal.
	* ListBox.cs: html-encode the item text. Fixed single and multiple
	selection handling. All the tests pass now. Closes bug #76478.

2005-10-18 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListControl.cs: throw when the selected value is not in the
	items collection. Fixes bug #76415.

2005-10-17 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseDataList.cs: Type.GetTypeCode was fixed and now does not
	throw a nullref, so we have to do it by ourselves here to make
	the test happy.

	* BaseValidator.cs: render the text of the error message even if
	we set IsValid programatically. Don't use 'valid' directly, as
	IsValid is virtual.

	Fixes bug #76299.

2005-10-17 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CustomValidator.cs: an empty ControlToValidate is valid.

2005-10-17  Sebastien Pouliot  <sebastien@ximian.com> 

	* RequiredFieldValidator.cs: Added missing permissions.

2005-10-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: copied and adapted PrepareControlHierarchy from DataGrid.
	Now the items get the attributes from the styles in datalist.  Add the
	separators after each item, not before. GetItemStyle returns the actual
	item style, not the styles in the datalist. Fixes bug #76384 and all
	new tests pass.

2005-10-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs: add a 'border-style: solid' to make IE happy. Fixes bug
	76373.

2005-10-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TemplateColumn.cs: SelectedItem was missing from the select (). Fixes
	bug #76359.

2005-10-06  Sebastien Pouliot  <sebastien@ximian.com> 

	* FontInfo.cs: Gendarme strikes again. Sealed class have no need for 
	inheritance demands.
	* FontUnit.cs: Structs are sealed so there's no need for inheritance 
	demands.
	* Unit.cs: Structs are sealed so there's no need for inheritance 
	demands.

2005-10-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagedDataSource.cs: fix the upper bound for collection and ilist
	enumarators.

2005-10-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: change the ListItemType for the item selected, set
	SelectedIndex before calling OnSelectedIndexChanged and set the selected
	item type correctly when creating the columns. Fixes bug #76334.

	* ButtonColumn.cs:
	* EditCommandColumn.cs: use a ForeColorLinkbutton, otherwise when
	selecting the row, the button keep the regular link color.

	* DataGridColumn.cs: made the class internal.

2005-10-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: fix breakaga of alternating item style in one of my
	last patches.

2005-10-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: remove Console.
	* ListBox.cs: the name is the UniqueID, not the ClientID.
	* WebControl.cs: Attributes is case insensitive.

2005-10-04 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ImageButton.cs: use UniqueID in LoadPostData and also try just the
	UniqueID without appending a ".x" or ".y". Fixes several issues in
	mojoPortal. Thanks to Joe Audetter for his patience.

2005-10-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ButtonColumn.cs: it was lacking databinding, so copied most of it
	from BoundColumn.

2005-10-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* FontInfo.cs: removed useless ctor.
	* Style.cs: keep here some commented out debugging code.
	* DataGrid.cs: the Items property does not create a new arraylist if
	the items_list was already initialized. Add case for Separator.
	* DataGridColumn.cs: when sorting is enabled, the linkbutton rendered
	in the header columns has a special ForeColor handling.

2005-10-02 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: PageCount must persist in ViewState too and returns the
	number of pages in the paged data source once we set that. Fix checks
	for visibility of the pager: no more 2 pagers when custom paging is
	enabled.

2005-09-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ImageButton.cs: fix a bug reported on the list. We were triggering the
	command event on every POST. And the 'name' attribute was not being
	rendered, so the 'x,y' coordinates didn't have 'uniqueid.' prepended
	and we couldn't find the values.

2005-09-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: fix the links for the numeric pager.

2005-09-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: when paging is enable, the actual number of items is not
	the number of items rendered before the postback, but that number times
	the number of pages. Now we store the page count in the viewstate. Also,
	as the number might be big, don't allocate an array of objects to fake
	the collection for the PagedDataSource, but use the new NCollection
	class instead, which provides cheap (memory wise) enumerator for an
	arbitrary number of items. Thanks to "Adriano" for the test case.

2005-09-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Xml.cs: the show must go on. Removed a few NotImplemented.

2005-09-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Button.cs: implemented 2.0 RaisePostBackEvent in terms of the
	existing code in 1.1 (or viceversa). RenderContents() does nothing.

	* DataGrid.cs: changed autoid api.

	* EditCommandColumn.cs: only 'Update' causes validation.

	* TableCell.cs: changed autoid api.  RenderContents checks the number
	of controls to decide what to do, not the value of Text in the
	viewstate.

	* TableRow.cs: changed autoid api.

	* BoundColumn.cs: SelectedItem was missing when attaching a DataBind
	event. When we get an EditItem, we need a TextBox to be created and
	this one will be the one that gets the event.  Changed
	ItemDataBinding to deal with a TextBox too.

2005-09-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagedDataSource.cs: fix IsLastPage. All tests pass.
	* DataGrid.cs: InitializePager always add a cell and it's brand new. No
	need to keep the old one in a field. Now all tests pass here too.

2005-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagedDataSource.cs: don't use the properties when they just return a
	field. Fixed Count when paging is enabled. In GetEnumerator, IList goes
	before ICollection (otherwise, an IList will always fall under the
	ICollection case). The enumerator for lists will be empty if 'start'
	is beyond the list size. All existing tests pass, but one in
	DataGridTest that fails because of some problem with the paging.

2005-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs: fix the 2.0 build.

2005-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs: avoid unnecesary creation of a CssStyleCollection and
	instead write the style attributes directly to the HtmlTextWriter.

	* CheckBox.cs: adapted to new API.

	* DataGrid.cs: handle null data sources. Fixed the contions that make
	the table to be added to the Controls collection.

	* Calendar.cs: the table needed an ID and the attributes from the
	parent. Also don't create the ControlStyleCollection if it has not
	already been created.

2005-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: handle null data sources. Fixed the contions that make
	the table to be added to the Controls collection.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: TrackViewState should be called upon creation, not on
	every get_XXX call. Cleanup.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: fix another test. The ID of the table generated by the
	datagrid is set to the one on the datagrid if no one set the ID for the
	table.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListControl.cs: this fixes TestValueFieldAndTextFormat from
	DropDownListTest.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* FontUnit.cs: use a table for FontSize names, as the X{1,2}.* ones are
	converted to string as X{1,2}-.*. All FontUnitTests pass now.
	* Unit.cs: throw a format exception when there's not number or minus
	sign in the first non-whitespace character.

2005-09-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListControl.cs: SelectedIndex/SelectedValue can be set before
	DataBinding () is called on the control, so we have to keep this values
	around and use them after the data is read. If both properties are
	used, they must refer to the same item.

2005-09-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: fill in the data keys from BaseDataList so that the
	events can see them. Only assign DataItem when using data binding and
	nullify it after all events are raised.

2005-09-24 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: OnItemCommand() is raised any time OnBubbleEvent is
	called.

2005-09-23  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* Button.cs: For 2.0 don't add the "name" attribute unless there's an 
	id.
	* DataGrid.cs: Fix TagKey (table) for 2.0.
	* DataList.cs: Revert 2.0 specific stuff that was changed in RC.
	* DropDownList.cs: For 2.0 don't add the "name" attribute unless 
	there's an id.
	* ListBox.cs: For 2.0 don't add the "name" attribute unless there's an
	id.
	* RoleGroupCollection.cs: Fix "extra" exception in Remove method.
	* Style.cs: Fixed (2.0) RegisteredCssClass to returns String.Empty 
	(i.e. not null).
	* TextBox.cs: For 2.0 don't add the "name" attribute unless there's an
	id.
	* TreeView.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* XmlDataSource.cs: Added declarative security (Link and Inheritance
	demands) for Minimal.

2005-09-23  Sebastien Pouliot  <sebastien@ximian.com>

	* FontUnit.cs: Added, but only for 1.x, declarative security (Link and
	Inheritance demands) for Minimal.
	* Label.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal.
	* ListItem.cs: Added declarative security (LinkDemands) for Minimal.
	* ListItemCollection.cs: Added declarative security (LinkDemands) for 
	Minimal.
	* MonthChangedEventArgs.cs: Added declarative security (Link and, for 
	2.0, Inheritance demands) for Minimal.
	* PagedDataSource.cs: Added declarative security (LinkDemands) for 
	Minimal.
	* Panel.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal.
	* Repeater.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* RepeatInfo.cs: Added declarative security (LinkDemands) for Minimal.
	* SelectedDatesCollection.cs: Added declarative security (LinkDemands)
	for Minimal.
	* TargetConverter.cs: Added declarative security (Link and Inheritance
	demands) for Minimal.
	* Unit.cs: Added, but only for 1.x, declarative security (Link and 
	Inheritance demands) for Minimal.
	* ValidatedControlConverter.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* WebColorConverter.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* Xml.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal.
	* ValidationSummary.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.

2005-09-23  Sebastien Pouliot  <sebastien@ximian.com> 

	* UnitConverter.cs: Remove conversion from Unit (see unit tests).

2005-09-22  Ben Maurer  <bmaurer@ximian.com>

	* BulletedList.cs: Remove the cacheEnabled thing. I was thinking
	it took O(height) time, not O(1).

2005-09-21  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* CheckBoxList.cs: Fix unit test failure (which matched bug #48802).

2005-09-21  Sebastien Pouliot  <sebastien@ximian.com>

	* AdCreatedEventArgs.cs: Added declarative security (Link and, for 
	2.0, Inheritance demands) for Minimal.
	* BaseCompareValidator.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* BaseDataBoundControl.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* BaseValidator.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* BoundColumn.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* ButtonColumn.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* CalendarDay.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* CheckBoxList.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* CompareValidator.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* CustomValidator.cs: Added declarative security (Link and Inheritance
	demands) for Minimal.
	* DataBoundControl.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* DataGridItemCollection.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* DataKeyCollection.cs: Added declarative security (LinkDemands) for 
	Minimal.
 	* DataListItemCollection.cs: Added declarative security (LinkDemands) 
	for Minimal.
	* DataListItem.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* FontNamesConverter.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal.
	* HyperLink.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* HyperLinkColumn.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal.
	* Image.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal.

2005-09-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseDataList.cs: it's the DataKeysArray what is stored in "DataKeys",
	not the DataKeys.
	* DataGrid.cs: add the keys to BaseDataList.DataKeysArray. When using
	a data source, first try reflection, then componentmodel. If we get
	an enumerator, keep it around, as MS only calls GetEnumerator once.
	Throw an exception if no columns can be created from the given data
	source. Tested with DbDataRecord, DataTable, ArrayList and
	ICustomTypeDescriptor.

2005-09-20  Sebastien Pouliot  <sebastien@ximian.com>

	* AccessDataSource.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [ToolboxBitmap] on class.
	* AdRotator.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Removed extra Page and ViewState properties.
	* BulletedList.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* Button.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Added [SupportsEventValidation] on class (2.0).
	* Calendar.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* CheckBox.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* CompositeControl.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added new protected RecreateChildControls method.
	* DataControlCommands.cs: Added declarative security (LinkDemands) for 
	Minimal. Added private ctor.
	* DataGrid.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Fixed properties for 2.0 (mostly removing 
	[Bindable]). Added override for TagKey property.
	* DataGridColumn.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [UrlProperty] on HeaderImageUrl (2.0).
	* DataGridItem.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added IDataItemContainer interface for 2.0.
	* DataGridPagerStyle.cs: Added declarative security (LinkDemands) for 
	Minimal. Remove [Bindable] from 2.0 and add [Localizable].
	* DataList.cs: Removed [Load|Save]ControlState methods.
	* DropDownList.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* EditCommandColumn.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal. Added missing attributes, 
	[DefaultValue] and [Localize] for 2.0.
	* FontInfo.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Remove [Bindable] and added [RefreshProperties] 
	for 2.0.
	* Login.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Fixed IsStyleEmpty. Removed extra [Themeable] attributes.
	* ImageButton.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* LinkButton.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* ListBox.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Added [SupportsEventValidation] on class (2.0).
	* Literal.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Removed [EditorBrowsable] on CreateControlCollection method.
	* LoginStatus.cs: Added missing [Themeable] attributes on properties.
	* MenuItemStyle.cs: Changed IsEmpty to public (required to compile - 
	but will be shown as extra).
	* RadioButton.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* RadioButtonList.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added [SupportsEventValidation] on class (2.0).
	* RangeValidator.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Added missing [Themeable] attributes.
	* RegularExpressionValidator.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal. Remove [Bindable] from 2.0 and add 
	[Localizable].
	* RoleGroupCollection.cs: Added declarative security (Link and 
	Inheritance demands) for Minimal. Fixed base class (changed in RC). 
	Re-implemented CopyTo. Removed some methods.
	* Style.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Remove static IsStyleEmpty and ToString (from 2.0). IsEmpty
	is now public in 2.0.
	* Table.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Added [SupportsEventValidation] on class (2.0).
	* TableCell.cs: Fixed PersistenceMode for 2.0.
	* TextBox.cs: Added declarative security (Link and Inheritance demands) 
	for Minimal. Added [SupportsEventValidation] on class (2.0).
	* TreeNodeStyle.cs: Changed IsEmpty to public (required to compile - 
	but will be shown as extra).
	* WebControl.cs: Added declarative security (Link and Inheritance 
	demands) for Minimal. Removed [EditorBrowsable] on ControlStyleCreated 
	property.

2005-09-19 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TableStyle.cs: fixed typo that prevented restoring GridLines from
	a saved viewstate.

	* DataGrid.cs: the table does not get an auto ID. When restoring from
	viewstate, use all the saved columns, not just that data bound ones. Set
	the owner of the BoundColumns created. Save/restore columns.
	OnItemCreated happens after the item is initialized and the data item is
	set before the event and nullified after OnItemDataBound.
	Add the render_table to the Controls immediately, otherwise we might get
	errors from child controls such as "must be rendered inside a form".
	Keep the items created in the list waiting for them.
	The table uses the attributes from the DataGrid and ControlStyle.
	Raise OnItemCommand on all bubble events and don't propagate bubble
	event up in the hierarchy

	* TableCell.cs: it does not get an automatic ID.
	* BoundColumn.cs: FormatDataValue returns an empty string on null input
	(there was already a test for this).

	Fixes bug #76117.

2005-09-17 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGridColumnCollection.cs: track the view state in the newly added
	items.

2005-09-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: merge column styles too. Fixes bug #76106.
	* DataGridColumn.cs: new internal method to retrieve the styles without
	creating an instance for them.

2005-09-15  Sebastien Pouliot  <sebastien@ximian.com>

	* DataControlField.cs, HotSpot.cs, MenuItem.cs, Parameter.cs, 
	Style.cs, TreeNode.cs: Replace _empty_ StateBag.SetDirty () with 
	StateBag.SetDirty (true).

2005-09-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Menu.cs: Fixed parameter orders for CreateStyleRule.

2005-09-13  Chris Toshok  <toshok@ximian.com>

	* Style.cs: corcompare stuff.

	* RequiredFieldValidator.cs: more corcompare stuff.

	* CheckBoxList.cs: clean up some of the interface methods vs
	protected virtual 2.0 calls.

	* SubMenuStyle.cs: corcompare says this should implement
	ICustomTypeDescriptor... sooo, make it.

2005-09-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TableCell.cs: do the same as HyperLink and others in
	AddParsedSubobject so that adding a literal control does not remove the
	existing controls if any. Fixes bug #76078.

2005-09-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* GridView.cs: don't duplicate class attribute. Fixes bug #75936.

2005-09-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ImageButton.cs: fix invalid cast exception.

2005-09-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListItem.cs: throw in AddParsedSubObject if the object is not a
	LiteralControl.
	* RadioButtonList.cs: implemented LoadPostData and
	RaisePostDataChangedEvent.

2005-09-09  Chris Toshok  <toshok@ximian.com>

	* CheckBox.cs, CheckBoxList.cs, DropDownList.cs, ImageButton.cs,
	ListBox.cs, RadioButton.cs, RadioButtonList.cs, TextBox.cs: fix up
	LoadPostData/RaisePostDataChangedEvent.

2005-09-09  Chris Toshok  <toshok@ximian.com>

	* FontInfo.cs (IsEmpty): new internal property, used by
	Style.IsEmpty.

	* Style.cs (IsEmpty): make sure the fontinfo is null or empty as
	well.

2005-09-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListItemCollection.cs: remove obsoleted methods.
	* ListBox.cs: use IStateManager on the item collection.

2005-09-08  Eyal Alaluf  <eyala@mainsoft.com>

	* Use C# 1.0 style of delegate instantiating. Needed to compile
	Grasshopper (TARGET_J2EE) which uses MS C# 1.0 compiler and not msc.

2005-09-07  Chris Toshok  <toshok@ximian.com>

	* Calendar.cs (WriteDay): always add BackColor=Silver,
	ForeColor=White to selected day cells, before copying over the
	selectedDayStyle, if it exists.
	(WriteDays): fix nunit test - if the first day of the month falls
	on the first day of the week, go back one week (effectively adding
	a row of dates from the previous month.)
	(WriteTitle): don't copy the control style to the tableTitle,
	since it might have height specifications, which would make the
	title look rather off.

2005-09-07  Chris Toshok  <toshok@ximian.com>

	* ValidationSummary.cs (AddAttributesToRender): we only set
	display=none if there are no errors.

	* BaseValidator.cs (OnPreRender): fix a JS error - on submit we
	call ValidatorOnSubmit, not ValidatorCommonOnSubmit.

2005-09-07  Chris Toshok  <toshok@ximian.com>

	* ListControl.cs (SelectedIndex): add comment about how you'd
	think OnSelectedIndexChanged would be called.. and you'd be wrong.
	(Text): implement in terms of SelectedValue.
	(TagKey): do the HAVE_CONTROL_ADAPTERS two-step.
	(LoadControlState): implement - this is where the selected index
	ArrayList gets stuffed in 2.0.
	(OnInit): call Page.RegisterRequiresControlState.
	(OnTextChanged): implement.
	(RenderContents): for now just chain up to base.RenderContents.
	(SaveControlState): save our control state properly.
	(GetSelectedIndices): split this out from SaveViewState to it can
	be used by both that and SaveControlState.
	(SaveViewState): mangle this function so it works in both 2.0 and
	1.0.
	(LoadViewState): same.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (AddAttributesToRender): render our ClientID if
	we weren't assigned an ID.

	* ValidationSummary.cs (AddAttributesToRender): same.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* WebControl.cs: revert the last change.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* WebControl.cs (AddAttributesToRender): always render ClientID.

	* ValidationSummary.cs (Render): same.

	* BaseValidator.cs (RegisterValidatorDeclaration): use ClientID
	here.

2005-09-06  Chris Toshok  <toshok@ximian.com>

	* ValidationSummary.cs (Render): only do the JS stuff when the
	validators on the page are uplevel.

	* BaseValidator.cs (Render): remove unnecessary comment.

2005-09-05  Chris Toshok  <toshok@ximian.com>

	* BaseDataBoundControl.cs (DataSourceID): testing reveals this is
	stored in the ViewState.

2005-09-02  Chris Toshok  <toshok@ximian.com>

	* Repeater.cs (GetData): change this slightly so the Repeater
	doesn't keep a ref to the return value of GetData.

2005-09-01  Chris Toshok  <toshok@ximian.com>

	* ListControl.cs (AppendDataBoundItems): implement (2.0)
	(TagKey): same.

2005-09-01  Chris Toshok  <toshok@ximian.com>

	* System.Web.UI.WebControls/MonthChangedEventArgs.cs,
	System.Web.UI.WebControls/ValidatedControlConverter.cs,
	System.Web.UI.WebControls/Xml.cs,
	System.Web.UI.WebControls/RegularExpressionValidator.cs,
	System.Web.UI.WebControls/ServerValidateEventArgs.cs,
	System.Web.UI.WebControls/Menu.cs,
	System.Web.UI.WebControls/MailMessageEventArgs.cs,
	System.Web.UI.WebControls/MenuItemStyle.cs,
	System.Web.UI.WebControls/RangeValidator.cs,
	System.Web.UI.WebControls/RepeaterItemEventArgs.cs,
	System.Web.UI.WebControls/MenuItem.cs,
	System.Web.UI.WebControls/RepeaterCommandEventArgs.cs,
	System.Web.UI.WebControls/DataGridSortCommandEventArgs.cs,
	System.Web.UI.WebControls/DataGridCommandEventArgs.cs,
	System.Web.UI.WebControls/DataGridPageChangedEventArgs.cs,
	System.Web.UI.WebControls/XmlBuilder.cs,
	System.Web.UI.WebControls/ImageButton.cs: someone stop me.  more
	corcompare work.

2005-09-01  Chris Toshok  <toshok@ximian.com>

	* System.Web.UI.WebControls/Button.cs,
	System.Web.UI.WebControls/ButtonField.cs,
	System.Web.UI.WebControls/DataControlField.cs,
	System.Web.UI.WebControls/BaseCompareValidator.cs,
	System.Web.UI.WebControls/AutoGeneratedField.cs,
	System.Web.UI.WebControls/CustomValidator.cs,
	System.Web.UI.WebControls/Content.cs,
	System.Web.UI.WebControls/BoundField.cs,
	System.Web.UI.WebControls/AdRotator.cs,
	System.Web.UI.WebControls/ButtonColumn.cs,
	System.Web.UI.WebControls/CompareValidator.cs,
	System.Web.UI.WebControls/AdCreatedEventArgs.cs: More corcompare
	work.  Stub things out, and add attributes.

2005-09-01  Chris Toshok  <toshok@ximian.com>

	* Button.cs, ButtonField.cs, FontInfo.cs, Style.cs, Xml.cs,
	CommandField.cs, HyperLinkColumn.cs, Table.cs,
	RegularExpressionValidator.cs, DataGridPagerStyle.cs, Label.cs,
	CheckBox.cs, RadioButton.cs, TableStyle.cs, ListControl.cs,
	Image.cs, BaseCompareValidator.cs, BaseDataList.cs, DataList.cs,
	TemplateColumn.cs, RangeValidator.cs, ImageField.cs,
	BaseValidator.cs, CustomValidator.cs, TextBox.cs,
	ButtonFieldBase.cs, BoundField.cs, CheckBoxList.cs,
	RadioButtonList.cs, RequiredFieldValidator.cs, AdRotator.cs,
	Repeater.cs, DropDownList.cs, CheckBoxField.cs, HyperLink.cs,
	XmlDataSource.cs, Panel.cs, DataGrid.cs, ButtonColumn.cs,
	CompareValidator.cs, Calendar.cs, ListBox.cs, TableCell.cs,
	WebControl.cs, Literal.cs, ValidationSummary.cs, ImageButton.cs,
	TableRow.cs, LinkButton.cs, DataGridColumn.cs, BoundColumn.cs,
	TableItemStyle.cs: Add some WebCategory and WebSysDescription
	attributes.

2005-09-01  Chris Toshok  <toshok@ximian.com>

	* AccessDataSource.cs: corcompare work.

	* SqlDataSource.cs: same.
	
2005-09-01  Miguel de Icaza  <miguel@novell.com>

	* Various places: make sure that the DefaultValue matches the
	type.  Thanks to Michael for pointing this out.

	In future audits, you might want to use the following awk command:

	awk '/DefaultValue/ { v=$0; looking = 1; } /public/ && looking &&
	!/string/ && !/ int / && !/ bool / { print FILENAME; print v;
	print $0; looking = 0; } /public/ && looking { looking = 0; } '
	*.cs

	The above skips bools, strings and ints as those were fine as we
	set them.  The bug was on the other ones.

2005-08-31 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Repeater.cs: fix the build.

2005-08-31  Chris Toshok  <toshok@ximian.com>

	* Repeater.cs: lots of 2.0 work, much of it c&p'ed from
	{Base}DataList, and also from debug spew garnered from some
	Repeater subclass tests on MS.
	(CreateControlHierarchy): in 2.0 if IsBonudUsingDataSourceID get
	the IEnumerable by calling GetData().
	(DataBind): reset RequiresDataBinding to false (2.0).
	(DataMember): copy the set implementation from DataList, and add
	2.0 code to call OnDataPropertyChanged if we're !Initialiezd.
	(DataSource): more c&p.
	(DataSourceID); implement (2.0)
	(Initialized): implement (2.0)
	(IsBoundUsingDataSource): implement (2.0)
	(RequiresDataBinding): implement (2.0)
	(SelectArguments): implement (2.0)
	(CreateDataSourceSelectArguments): implement (2.0)
	(EnsureDataBound): implement (2.0)
	(GetData): implement.
	(OnDataPropertyChanged): remove the NIE, but leave the MonoTODO
	(2.0)
	(OnDataSourceViewChanged): set RequiresDataBinding to true, but
	leave the MonoTODO. (2.0)
	(OnInit): call base.OnInit instead of throwing NIE, but leave the
	MonoTODO (2.0)
	(OnLoad): implement.
	(OnPreRender): implement.
	(ConnectToDataSource): new method - look for the right control.

2005-08-31  Chris Toshok  <toshok@ximian.com>

	* XmlDataSourceView.cs: fix the scope of our select.  Don't use
	call SelectNodes on the XmlDocument, not on
	XmlDocument.DocumentElement.

2005-08-31  Chris Toshok  <toshok@ximian.com>

	* XmlDataSourceView.cs (.ctor): remove the nodelist parameter.
	(DoXPathSelect): put the xpath selection stuff here.
	(ExecuteSelect): call DoXPathSelect if we need to (if nodes ==
	null).

	* XmlDataSource.cs (IDataSource.GetView): don't do the XPath
	select here, the view does it.

2005-08-31  Jackson Harper  <jackson@ximian.com>

	* DataList.cs: Remove some debugging code that was starting to bug
	me (tee hee).

2005-08-31  Chris Toshok  <toshok@ximian.com>

	* XmlDataSourceNodeDescriptor.cs: implement IXPathNavigable, and
	create our Navigator by calling node.CreateNavigator().

2005-08-31  Chris Toshok  <toshok@ximian.com>

	* XmlDataSource.cs (GetXmlDataDocument): rename this to
	GetXmlDocument, and change the return value from XmlDataDocument
	to XmlDocument.
	(LoadXmlDataDocument): similar change.
	(Save): xmlDataDocument -> xmlDocument.
	(CanBeSaved): there's no ReadOnly attribute.
	(LoadViewState, SaveViewState, TrackViewState): nuke.
	(GetHierarchicalView): xmlDataDocument -> xmlDocument.
	(CacheDuration): stub out with NIE.
	(CacheExpirationPolocy): same.
	(CacheKeyDependency): same.
	(EnableCaching): same.
	(ReadOnly): nuke.
	(Data, DataFile): xmlDataDocument -> xmlDocument.
	(Schema, SchemaFile): nuke.
	(Transform, TransformFile): xmlDataDocument -> xmlDocument.
	
2005-08-30  Lluis Sanchez Gual  <lluis@novell.com> 

	* SubMenuStyle.cs, MenuItemStyle.cs, TreeNodeStyle.cs:
	  Don't use the obsolete IsSet method.
	* Menu.cs: Implement IPostBackEventHandler.RaisePostBackEvent.
	* CheckBox.cs: Implement some 2.0 methods.
	* GridView.cs: Removed some "throw new NotImplementedException"

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* TreeView.cs: Use the StateBag accessors Ben added, and implement
	SkipLinkText and Visible.

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* TreeView.cs: fix typo in an attribute.

2005-08-29  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: If it's not a list or collection we don't
	use a bounded enumerator.

2005-08-29  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs: fix some 2.0 Page/ClientScript obsolete warnings.

	* CheckBox.cs: same.
	
	* BaseValidator.cs: same.
	
	* DropDownList.cs: same.
	
	* ValidationSummary.cs: same.

2005-08-28  Chris Toshok  <toshok@ximian.com>

	* XmlHierarchyData.cs: fix IHierarchyData.GetParent.

2005-08-26  Chris Toshok  <toshok@ximian.com>

	* TextBox.cs: implement ValidationGroup and CausesValidation
	properties.

2005-08-26  Lluis Sanchez Gual  <lluis@novell.com> 

	* Style.cs: Implemented FillStyleAttributes, GetStyleAttributes and
	SetDirty.

2005-08-26  Chris Toshok  <toshok@ximian.com>

	* Unit.cs: implement the 2.0 ToString(IFormatProvider) method.

	* FontUnit.cs: add two 2.0 ctors, and the 2.0
	ToString(IFormatProvider) method.

2005-08-26  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* CheckListBox.cs: Nothing is rendered (i.e. no empty table) in 2.0 if
	no items are present in the list.
	* RoleGroup.cs: Added missing attributes.
	* RoleGroupCollection.cs: Added missing attributes and some (yet-to-be-
	documented) methods.
	* TableStyle.cs: *for 2.0* adding a "url({0})" to background image 
	must be done in the HtmlTextWriter (not in the TableStyle).

2005-08-26  Chris Toshok  <toshok@ximian.com>

	* Calendar.cs (UseAccessibleHeader): implement.
	(RaisePostBackEvent): some #ifdef ugliness to get this all working
	propertly between 1.x and 2.0
	(WriteDayHeader): if UseAccessibleHeader == true, render header
	cells as th's, not td's, and add abbr and scope attributes.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* Calendar.cs (Caption, CaptionAlign): implement these properties.
	(Render): if we have a non-empty caption, show it.
	(WriteCaption): new method, output the caption.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* Calendar.cs (Render): Copy the entire style from the Calendar to
	the Table, not just the font.
	(WriteDay): don't just write the link/text/etc.  Create a
	LiteralControl as a child of the cell, before the call to
	OnDayRender, with its text set to the day number.  After
	OnDayRender, set the literal's text to either the number again (if
	it's not selectable) or the full text of the js __doPostBack
	hyperlink (if it is.)  Also, use cell.RenderControl here so we can
	render child controls with the id's listed properly (and arguably
	incorrectly).
	(ApplyTitleStyleCell): remove.
	(WriteTitle): apply the titleStyle to the enclosing table, not the
	table cell containing the month name.  Also, copy from the
	Calendar's ControlStyle to populate tableTitle's style initially.
	We end up with more (superfluous) style attributes than MS, but
	it's better than having less.

2005-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* HyperLink.cs: Fixed 2.0 rendering for Alt and Border|BorderWidth when
	an image is used.

2005-08-25  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs: Implemented 2.0 CopyTextStylesFrom(), SetRegisteredCssClass()
	  and RegisteredCssClass property

2005-08-25  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* LoginView.cs: Fixed attributes.
	* Style.cs: Change SetRegisteredCssClass to internal and not to throw
	an exception to allow pages to work on 2.x.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs (PostBackUrl): correct the UrlProperty attribute.

	* Unit.cs: add [Serializable] and the 2.0 specific ToString(), not
	yet implemented.

	* HiddenField.cs: stub out this class and label everything
	MonoTODO.

2005-08-25  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Disable the pager row if there no paging enabled
	or available.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* SqlDataSourceFilteringEventArgs.cs: add some usings, and fix a
	typo.

	* SqlDataSourceSelectingEventArgs.cs: IDbCommand -> DbCommand, and
	add a using statement.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* SqlDataSourceFilteringEventArgs.cs: new 2.0 class, as per
	corcompare.

	* SqlDataSourceFilteringEventHandler.cs: new 2.0 delegate, as per
	corcompare.

2005-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* Login.cs: Added rendering and fixed parts of the authentication.
	Now using IStateManager to allow compilation in another assembly (e.g.
	to test the control under IIS). Needs more tests (error conditions) 
	once we get a "real" Membership provider running.
	* Style.cs: Fixed IsStyleEmpty (name ;-) and when null is provided 
	(returns true).

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* SqlDataSourceCommandType.cs: new 2.0 enum, as per corcompare.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* AdRotator.cs: stub out enough of the 2.0 methods/properties by
	calling base.Foo to get the standalone adrotator (1.0) tests to
	run without throwing exceptions.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* ValidationSummary.cs (ValidationGroup): implement.
	(Render): use Page.GetValidators in .net 2.0, so we can support
	ValidationGroups.  Also, <br>'s get rendered as <br /> in .net
	2.0.

2005-08-25  Chris Toshok  <toshok@ximian.com>

	* ImageButton.cs (TagKey): disable (but flag) the "virtual new"
	2.0 attribute modifiers, and revert back to "override".

	* ListBox.cs (BorderColor): disable (but flag) the "virtual new"
	2.0 attribute modifiers, and revert back to "override".
	(BorderStyle): same.
	(BorderWidth): same.

	* TextBox.cs (SaveViewState): implement naively, calling
	base.SaveViewState.
	(TagKey): disable (but flag) the "virtual new" 2.0 attribute
	modifiers, and revert back to "override".

2005-08-25  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs, TableStyle.cs, TableItemStyle.cs, DataGridPagerStyle.cs:
	  Load ViewState for derived classes; no public LoadViewState override 
	  exists in those classes
	* Style.cs: Added 2.0 IsStyleEmpty method

2005-08-25  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: The number of pages set in the pager is specified
	by PageButtonCount.

2005-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* LoginView.cs: New (2.0). Work in progress.

2005-08-24  Chris Toshok  <toshok@ximian.com>

	* Button.cs, DetailsView.cs, FontInfo.cs, Style.cs, Xml.cs,
	Menu.cs, ObjectDataSource.cs, CheckBox.cs, RadioButton.cs,
	ListControl.cs, SiteMapPath.cs, BulletedList.cs,
	DataBoundControl.cs, ListItemCollection.cs, GridView.cs,
	Wizard.cs, TextBox.cs, CheckBoxList.cs, RadioButtonList.cs,
	PagedDataSource.cs, FormView.cs, AdRotator.cs, Repeater.cs,
	DropDownList.cs, MultiView.cs, HierarchicalDataBoundControl.cs,
	Calendar.cs, ListBox.cs, WebControl.cs, Literal.cs,
	ValidationSummary.cs, ImageButton.cs, LinkButton.cs, TreeView.cs:
	Add MonoTODO's for all things that throw NotImplementException.

2005-08-24  Sebastien Pouliot  <sebastien@ximian.com>

	* RoleGroup.cs: New (2.0). Complete implementation.
	* RoleGroupCollection.cs: New (2.0). Mostly complete implementation.

2005-08-23  Chris Toshok  <toshok@ximian.com>

	* BaseCompareValidator.cs (GetFullYear): it turns out the docs up
	on msdn.microsoft.com tell exactly how the .net 2.0 stuff works,
	even though they were written for the 1.0 stuff.

2005-08-23  Chris Toshok  <toshok@ximian.com>

	* RepeatInfo.cs: some massaging to support both the 1.x and 2.0
	output.  Our tests now pass on both mono and ms, with both 1.x and
	2.0 profiles.

2005-08-23  Sebastien Pouliot  <sebastien@ximian.com>

	* Login.cs: Throw exception if the specified provider doesn't exists.
	* LoginStatus.cs: Complete events.

2005-08-22  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs (CreateControlHierarchy): Clear out the old pager after creating the
	controls.
	(InitializeNumericPager): Now that the pager actually renders
	properly I can see that I was computing it incorrectly.

2005-08-22  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs (RenderTable): Make sure the new table gets the
	correct style.
	(CreateColumnSet): Clear the data source columnbs before adding
	new ones regardless of whether or not a property descriptor was
	found.
	(InitializePager): pager_cell needs to be a member so it isn't
	created more then once per a render.
	(InitializeNumericPager): Compute start and end more
	correctly.
	- Link commands are 1 indexed.
	(CreateControlHierarchy): Clear the table before we begin
	rendering.
	- Revert patch that made adding the pagers conditional. This is
	incorrect, the pagers are always added. Only their visibility is
	affected by the pager style.
	- Save the entire count in the viewstate, not just the rendered
	count. So when paging is enabled the pager's count isn't broken by
	postback.

2005-08-22  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs (ValidationGroup): implement.
	(IPostBackEventHandler.RaisePostBackEvent): in the 2.0 profile,
	pass ValidationGroup to Page.Validate.

2005-08-22  Chris Toshok  <toshok@ximian.com>

	* ImageButton.cs (ValidationGroup): implement.
	(IPostBackEventHandler.RaisePostBackEvent): if we cause
	validation, call Page.Validate properly (in both profiles).

2005-08-22  Chris Toshok  <toshok@ximian.com>

	* Button.cs (IPostBackEventHandler.RaisePostBackEvent): in the 2.0
	case, pass ValidationGroup to Page.Validate.
	(ValidationGroup): implement using ViewState.

2005-08-22  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (Text): 2.0 only.  implement naively, just
	get/set base.Text.
	(OnInit): add 2.0 support for validation groups.
	(OnUnload): same.

2005-08-22  Sebastien Pouliot  <sebastien@ximian.com>

	* LoginName.cs: New (2.0) web control.
	* LoginStatus.cs: New (2.0) web control.

2005-08-19  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs (ValidationGroup): implement getter/setter.
	(RaisePostBackEvent): implement naively, by c&p'ing the old
	implementation of IPostBackEventHandler.RaisePostBackEvent, but
	making use of the ValidationGroup in the call to Page.Validate.

	* Button.cs: same.

	* Style.cs (LoadViewState): set our style flags for all the things
	we have flags for.  Seems like the subclass flags should be
	handled in overridden LoadViewState methods, but none of the Style
	subclasses seem to override this method.

2005-08-19  Chris Toshok  <toshok@ximian.com>

	* TableStyle.cs (Merge, MergeWith): make these look a bit more
	like Copy/CopyFrom, with the styles checks instead of just
	ViewState checks.

	* TableItemStyle.cs: same, only also make Copy/CopyFrom work as in
	TableStyle.cs.

2005-08-19  Chris Toshok  <toshok@ximian.com>

	* DataGrid.cs (InitializePager): don't unconditionally set
	pager_cell to the numeric pager (especially after setting it
	conditionally to the nextprev pager.)
	(InitializeNumericPager): the link buttons don't participate in
	validation.
	(InitializeNextPrevPager): same.
	(CreateControlHierarchy): create the top/bottom pagers only if the
	PagerStyle says too.

2005-08-19  Sebastien Pouliot  <sebastien@ximian.com> 

	* TableCell.cs: Added AssociatedHeaderCellID property for 2.0.

2005-08-18  Chris Toshok  <toshok@ximian.com>

	* DataList.cs (CreateControlHierarchy): Call Controls.Clear() at
	the start of this method so templates are created properly.

2005-08-18  Dick Porter  <dick@ximian.com>

	* Button.cs, DetailsView.cs, Xml.cs, Table.cs, Menu.cs,
	DataControlButton.cs, Label.cs, ObjectDataSource.cs, CheckBox.cs,
	RadioButton.cs, ListControl.cs, Image.cs, SiteMapPath.cs,
	BaseDataList.cs, DataList.cs, BulletedList.cs,
	DataBoundControl.cs, Login.cs, GridView.cs,
	CompositeDataBoundControl.cs, Wizard.cs, BaseValidator.cs,
	TextBox.cs, CheckBoxList.cs, RadioButtonList.cs, FormView.cs,
	AdRotator.cs, Repeater.cs, MenuItemTemplateContainer.cs,
	DropDownList.cs, HyperLink.cs, ImageMap.cs, MultiView.cs,
	CompositeControl.cs, HierarchicalDataBoundControl.cs, Calendar.cs,
	ListBox.cs, TableCell.cs, WebControl.cs, Literal.cs,
	BaseDataBoundControl.cs, ValidationSummary.cs, ImageButton.cs,
	LinkButton.cs, TreeView.cs: 2.0 API fixes and stubs, and attribute
	fixes

2005-08-18  Sebastien Pouliot  <sebastien@ximian.com> 

	* BaseDataList.cs: Added a TODO for DataKeyField as we're not using it
	anywhere...
	* DataList.cs: Reworked CreateControlHierarchy to avoid allocating an
	empty array of objects just to get the number of items.
	* Login.cs: Implemented OnBubbleEvent and parts of the authentication
	but we're missing some bits from the class lib to complete all this...

2005-08-17  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Only create one pager and add it to both the top
	and bottom of the grid, this way all the id numbers stay the same
	and we save a bunch of cycles.

2005-08-17  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: The top and bottom pagers are always created. Just
	the visibility is changed by the PagerStyle::Position.

2005-08-17  Chris Toshok  <toshok@ximian.com>

	* CompositeControl.cs (RecreateChildControls): implement naively -
	just call CreateChildControls.  We might need to call
	Controls.Clear() as well, but for the time being, this is ok.

2005-08-17  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: Completed implementation for 2.0.

2005-08-16  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: Added missing properties/methods/attributes for 2.0.
	* DataList.cs: Added missing [Browseable] attribute on SelectedValue.

2005-08-16  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: Removed old internal ctor as DataList TagKey was 
	fixed for 2.0.
	* DataList.cs: Implemented {Load|Save}ControlState and OnInit (2.0).
	Adjusted size and ordering of the ViewState (new element #0 is still
	unknown). Properly fixed the TagKey in 2.0.
	* Login.cs: Implemented {Load|Save|Track}ViewState. Added checks for 
	all properties using enums.
	* Panel.cs: Fixed NoWrap rendering unit test (for 2.0).
	* TableItemStyle.cs: Fixed attribute rendering to use style to render
	"nowrap" in 2.0 (it used the HTML nowrap attribute in 1.x).

2005-08-15  Jackson Harper  <jackson@ximian.com>

	* EditCommandColumn.cs: Use a normal LinkButton.

2005-08-15  Sebastien Pouliot  <sebastien@ximian.com>

	* Image.cs: Don't remove GenerateEmptyAlternateText (2.0) from the 
	viewstate (even if assigned to the default value).
	* TableRow.cs: Implement TableSection property (2.0). It has no effect
	on the rendering of the table row.

2005-08-15  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: Added new [Themeable] and [Localizable] attributes
	and removed [Bindable] attributes for 2.0.
	* DataList.cs: Added new 2.0 attributes on class and removed [Bindable] 
	attributes (for 2.0).
	* DataListCommandEventArgs.cs: Not sealed in 2.0.
	* DataListItemEventArgs.cs: Not sealed in 2.0.
	* Image.cs: Fixed [Designer] attribute on class and all [Editor] 
	attributes for URLs.
	* Login.cs: Fixed [Designer] attribute on class and all [Editor] 
	attributes for URLs.
	* Table.cs: Fixed [Editor] attribute for 2.0.
	* TableCellCollection.cs: Fixed [Editor] attribute for 2.0.
	* TableCell.cs: Fixed [Designer] attribute. Fixed property name for 
	AssociatedHeaderCellID and it's [DefaultValue] attribute.
	* TableHeaderCell.cs: Fix [DefaultValue] attributes for CategoryText 
	and Scope attributes.
	* TableRow.cs: Fixed [Designer] attribute. Added missing [DefaultValue]
	on TableSection attribute.
	* TableRowCollection.cs: Fixed [Editor] attribute for 2.0.

2005-08-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Image.cs: Fixed attributes for 2.0 profile.
	* Login.cs: Fixed some attributes and default values.
	* Table.cs: Fixed attributes for 2.0 profile. Added protected method
	RaisePostBackEvent (TODO) in 2.0 profile.
	* TableCell.cs: Fix properties (Bindable, Localizable, Designer...) 
	and added AssociateHeaderCellID property (TODO).
	* TableCellCollection.cs: Fixed [Editor] attribute for 2.0.
	* TableFooterRow.cs: New (2.0). TableRow that always shows on each
	page (if the device requires to breaks the table into multiple pages).
	This seems to be a "flag" class, the real work will be in Table.
	* TableHeaderCell.cs: Added CategoryText and Scope properties for 2.0.
	* TableHeaderRow.cs: New (2.0). TableRow that always shows on each
	page (if the device requires to breaks the table into multiple pages).
	This seems to be a "flag" class, the real work will be in Table.
	* TableItemStyle.cs: Remove [Bindable (true)] from 2.0 profile.
	* TableRow.cs: Remove [Bindable (true)] from properties and add
	[Bindable (false)] and [Designer] on class. Added new TableSection 
	property (TODO).
	* TableRowCollection.cs: Fixed [Editor] attribute for 2.0.
	* TableSectionStyle.cs: New (2.0). Add Visible to Style - but it's 
	broken (int beta2) for IsEmpty, CopyFrom, MergeWith...
	* TableStyle.cs: Fixed attributes for 2.0 profile. Added new 
	FillStyleAttributes method (2.0).

2005-08-13  Sebastien Pouliot  <sebastien@ximian.com>

	* Login.cs: New (2.0). Mostly a stub with copy-n-pasted code and 
	attributes from existing controls.
	* LoginCancelEventArgs.cs: New (2.0). Required to build Login.
	* LoginCancelEventHandler.cs: New (2.0). Required to build Login.

2005-08-12  Jackson Harper  <jackson@ximian.com>

	* TableRow.cs: No AutoID for TableRows.

2005-08-12  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs (CreateRenderColumns): If we aren't using data
	binding grab the rendercols from the data source columns.
	(LoadViewState): Restore the bound columns when reloading the
	viewstate.
	(InitializeNumericPager): Create elipsised pagers.
	(CreateItem): Don't set the item's ID.
	(CreateItem): Add the control to the table before it is databound
	so that it's value is saved in the viewstate.
	(CreateControlHierarchy): Create a fake data source when not using
	databinding. Don't add controls to the table as they are added in
	CreateItem now.
	(PrepareControlHierarchy): Make footers and header non visible if
	they aren't enabled.

2005-08-12  Chris Toshok  <toshok@ximian.com>

	* CompositeControl.cs (DataBind, Render, get_Controls): the MSDN
	docs says these methods/properties "ensure the child controls are
	created" -- so call EnsureChildControls() before invoking the base
	class's code.

2005-08-12  Jackson Harper  <jackson@ximian.com>

	* BoundColumn.cs: Set the controls text instead of adding a
	literal control. So it is saved in the controls viewstate.

2005-08-11  Jackson Harper  <jackson@ximian.com>

	* CheckBoxList.cs: Set the tabindex on the checkbox control and
	don't render it on the main table (Setting it to zero causes it to
	not be rendered). Also use the invariant culture on the id.

2005-08-11  Dick Porter  <dick@ximian.com>

	* CheckBox.cs: Let ViewState manage removals; apply styles and
	"style" attributes in a surrounding <span>.  Fixes unit tests.

2005-08-10  Chris Toshok  <toshok@ximian.com>

	* Label.cs (LoadViewState): set the Text attribute from our
	ViewState (if it exists) to clear out any child controls.  Fixes
	jsunit test label/label-child-control-postback.aspx.

2005-08-10  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: Respect paging with all data source types.

2005-08-09  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: Changed Controls property from "virtual new" 
	(2.0 doc) to "override" (monop) to fix the Visible bug (see
	datalist-invisible.aspx). Fixed AddParsedSubObject not to accept
	any controls (required due to change to Controls). Implemented 
	DataBind(bool) for 2.0.
	* DataListItem.cs: Fix the multiple table when extractRows is used.
	Removed extra span tags by rendering contents (not control). Added
	support for IDataItemContainer (2.0).

2005-08-08  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Apply the styles to each item type. 

2005-08-08  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: If paging is not enabled keep enumerating to
	the end of the list.

2005-08-08  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: Remove old compatibility stuff.
	* DataList.cs: Fix the edit|update for datalist-style-edit.aspx.
	* WebControl.cs: Always call CreateControlStyle to create the 
	ControlStyle. Fix the exception for datalist-style-edit.aspx.

2005-08-05  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Don't make the current page index a link in the
	pager.

2005-08-05  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Honour PagerPosition.

2005-08-05  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: Round PageCount properly.

2005-08-05  Dick Porter  <dick@ximian.com>

	* CheckBox.cs: Shut corcompare up a bit more.  Still need to
	figure out how to not use AddAttributesToRender to get it
	completely silent.

	* ButtonColumn.cs: Implement Initialize() and InitializeCell()

	* DataGridColumn.cs: Added the duplicate viewstate manipulation
	methods

2005-08-05  Chris Toshok  <toshok@ximian.com>

	* HyperLinkColumn.cs (FormatDataNavigateUrlValue): treat "" as
	null when it comes to the format string.
	(FormatDataTextValue): same.

2005-08-04  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (Validate): only test a validator if it's both
	enabled and visible.

2005-08-04  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (AddAttributesToRender): add "enabled" if
	!Enabled.

2005-08-04  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Add a new space control for each link. Also make
	the link's text 1 indexed. Don't add the space after the last
	item.

2005-08-04  Ben Maurer  <bmaurer@ximian.com>

	* LinkButton.cs: Fix up the test suite here.

	* Panel.cs: Fix up nowrap

2005-08-04  Peter Dennis Bartok  <pbartok@novell.com>

	* ListBox.cs: Use WriteXXXX to render HTML, this way it matches MS output
	* ListControl.cs: Clear item list before adding data (again)

2005-08-04  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: fixes issues with OnDayRender event and others

2005-08-04  Peter Dennis Bartok  <pbartok@novell.com> 

	* DataGrid.cs(CreateControlHierarchy): Consider the EditItemIndex when
	  creating rows
	* ListControl.cs(OnDataBinding): Only apply DataTextFormatString to text
	  if DataTextField is bound
	* EditCommandColumn.cs(InitializeCell): MS inserts a &nbsp; between the 
	  two controls in edit mode, lets do the same

2005-08-03  Jackson Harper  <jackson@ximian.com>

	* BoundColumn.cs: Respek for the thisExpr when data binding.

2005-08-03  Peter Dennis Bartok  <pbartok@novell.com> 

	* EditCommandColumn.cs: No need to offer edit when in edit mode.
	  Flipped output

2005-08-04  Dick Porter  <dick@ximian.com>

	* DataGridColumn.cs: New implementation

	* DataGrid.cs: 
	* DataGridColumnCollection.cs: Set the DataGridColumn's owner

2005-08-03  Peter Dennis Bartok  <pbartok@novell.com> 

	* WebControl.cs(CopyBaseAttributes): Use Enabled setter to also
	  set tracking var

2005-08-03  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Finally figured out how to use base control

2005-08-03  Jackson Harper  <jackson@ximian.com>

	* ButtonColumn.cs: Partial implementation.

2005-08-03  Peter Dennis Bartok  <pbartok@novell.com> 

	* DataGridPagerStyle.cs(PageButtonCount): Throw exception on
	  negative value

2005-08-03  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: fixes Save/Load state

2005-08-03  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: bug fixes

2005-08-03  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Merge the table style with the render table. Some
	initial work on the numeric pager. Remove some debugging code.
	
2005-08-03  Jackson Harper  <jackson@ximian.com>

	* BoundColumn.cs: Implement Initialize and InitializeCell. When
	Data is formated it uses the DataFormatString that was set at the
	time Initialize was called (or null if initialize was never
	called).

2005-08-02  Jordi Mas i Hernandez  <jordi@ximian.com>

	* RadioButtonList.cs: bug fixes

2005-08-02  Jordi Mas i Hernandez  <jordi@ximian.com>

	* CheckBox.cs, RadioButton.cs: mecanism to avoid exposing  
	AddAttributesToRender
	* RadioButtonList.cs: Implementation

2005-08-01  Jackson Harper  <jackson@ximian.com>

	* TableStyle.cs: Copy style bit when copying from another style.

2005-08-01  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: Implement missing properties, use yield for
	the Enumerator methods. Only allow the enums to return one page at
	a time.

2005-08-01  Chris Toshok  <toshok@ximian.com>

	* HyperLinkColumn.cs (ItemDataBinding): remove incorrect comment.

2005-08-01  Peter Dennis Bartok  <pbartok@novell.com> 

	* WebControl.cs: Track enabled state across sessions

2005-08-01  Peter Dennis Bartok  <pbartok@novell.com> 

	* ListControl.cs(OnDatabinding): Value is equivalent to text if
	  by default

2005-08-01  Jordi Mas i Hernandez  <jordi@ximian.com>

	* ImageButton.cs: fixes, complete missing parts

2005-07-31  Ben Maurer  <bmaurer@ximian.com>

	* TextBox.cs: Html encode for multiline text boxes

	* HyperLink.cs: Resolve images

2005-07-30  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: initial version of 2.0 properties
	ValidationGroup and SetFocusOnError.

2005-07-30  Chris Toshok  <toshok@ximian.com>

	* HyperLinkColumn.cs (InitializeCell): clean this up.

2005-07-30  Chris Toshok  <toshok@ximian.com>

	* HyperLinkColumn.cs (FormatDataNavigateUrlValue): just use
	DataBinder.FormatResult.
	(FormatDataTextValue): same.
	(Initialize): call base.Initialize.
	(ItemDataBinding): new function, get the text/navigateurl and set
	them on our HyperLink control.
	(InitializeCell): create a hyperlink control in the
	Item/EditItem/AlternatingItem case.

2005-07-30  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Handle 0 items situations correctly

	* HyperLink.cs: Resolve urls correctly

	* CheckBox.cs: use the correct ID for the label element.

	* Label.cs: Correct AddParsedSubObject impl. See FAQ

2005-07-29  Chris Toshok  <toshok@ximian.com>

	* BaseCompareValidator.cs (GetDateElementOrder): implement.

2005-07-29  Chris Toshok  <toshok@ximian.com>

	* BaseCompareValidator.cs (GetFullYear): implement two ways.  The
	#if'ed out version follows microsoft's docs on msdn, but doesn't
	match ms's behavior.  The other matches their behavior but not
	their docs.  we use the latter.  go figure.
	(get_CutoffYear): implement using
	CultureInfo.CurrentCulture.Calendar.TwoDigitYearMax.

2005-07-27  Peter Dennis Bartok  <pbartok@novell.com> 

	* FontInfo.cs:
	  - Name property now throws exception when set to null
	  - Names now handles situation where our bit tells us we have
	    a font, but it's not in the StateBag (null removal)
	* RangeValidator.cs: Removed unused vars

2005-07-29  Ben Maurer  <bmaurer@ximian.com>

	* Label.cs: ClientID should be used rather than UniqueID to get
	the For attribute

2005-07-29  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (Validatate): not sure if this is entirely
	correct (some fairly deep testing required), but setting Enabled =
	false has the effect of setting IsValid = true.

2005-07-29  Ben Maurer  <bmaurer@ximian.com>

	* RadioButton.cs: The "remove from groupstate" isn't needed any
	more, now that statebag is correct.

2005-07-29  Dick Porter  <dick@ximian.com>

	* RadioButton.cs: Hide nonstandard API; remove GroupName from the
	ViewState when it is null.

	* CheckBox.cs: Hide nonstandard API

2005-07-29  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: fixes exceptions, bug fixes, new features
	* SelectedDatesCollection.cs: Fixes bugs discovered by the tests
 	* CalendarDay.cs: fixes default value

2005-07-28  Ben Maurer  <bmaurer@ximian.com>

	* CompositeControl.cs: Stub

2005-07-27  Peter Dennis Bartok  <pbartok@novell.com> 

	* EditCommandColumn.cs: Implemented

2005-07-27  Chris Toshok  <toshok@ximian.com>

	* RegularExpressionValidator.cs (EvaluateIsValid): "" is valid.

2005-07-27  Peter Dennis Bartok  <pbartok@novell.com> 

	* CustomValidator.cs: Bug fixes (Thanks to Chris for creating the 
	  client side code)

2005-07-27  Peter Dennis Bartok  <pbartok@novell.com>

	* DataGrid.cs: DataGridPagerStyle does not need DataGrid as argument
	  for it's constructor, so remove it
	* DataGridPagerStyle.cs: Removed DataGrid argument from constructor

2005-07-27  Peter Dennis Bartok  <pbartok@novell.com> 

	* DataGridPagerStyle.cs: Implemented
	* TableItemStyle.cs (MergeWith): Now only sets style bits it owns
	* Style.cs: Added Styles enum values for DataGridPagerStyle

2005-07-27  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: get the styles right, honors more properties, fixes, fix 
	var names style

2005-07-26  Peter Dennis Bartok  <pbartok@novell.com>

	* DataGridItem.cs: Implemented

2005-07-26  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs (AddParsedSubObject): reversed the order of
	Controls.Add() and Text = null
	(set_Text): call Controls.Clear()
	(RenderContents): use HasControls() for the if test instead of
	Text != "".

	* HyperLink.cs (AddParsedSubObject): reversed the order of
	Controls.Add () and Text = null;

2005-07-26  Peter Dennis Bartok  <pbartok@novell.com>

	* DataGridItemCollection.cs: Implemented

2005-07-26  Chris Toshok  <toshok@ximian.com>

	* LinkButton.cs (AddParsedSubObject): copy implementation from
	HyperLink.
	(RenderContents): only call writer.Write(Text) if Text != "".
	Otherwise default to base.RenderContents.

2005-07-26  Chris Toshok  <toshok@ximian.com>
	
	* Button.cs, CheckBox.cs, TextBox.cs, DropDownList.cs, ListBox.cs,
	ImageButton.cs, LinkButton.cs (AddAttributesToRender): add if
	(Page != null) around my last commit.
	
2005-07-26  Peter Dennis Bartok  <pbartok@novell.com>

	* FontInfo.cs, CheckBox.cs, RadioButton.cs, ListItemCollection.cs:
	  Fixed use of literal strings, instead using Consts
	* Xml.cs, RegularExpressionValidator.cs, TemplateColumn.cs,
	  TextBox.cs, RequiredFieldValidator.cs, Repeater.cs, RepeaterItem.cs,
	  Panel.cs, Literal.cs: Added attributes
	* BaseValidator.cs: Added missing override

2005-07-26  Chris Toshok  <toshok@ximian.com>

	* Button.cs, CheckBox.cs, TextBox.cs, DropDownList.cs, ListBox.cs,
	ImageButton.cs, LinkButton.cs (AddAttributesToRender): call
	Page.VerifyRenderingInServerFormHere.

2005-07-26  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: remove some MonoTODO's about the client side
	validator stuff.

2005-07-26  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Calendar.cs: selection of dates, state load, save, track, support
	for new properties, many fixes. 

2005-07-26  Miguel de Icaza  <miguel@novell.com>

	* Style.cs: Temporary methods to help buliding .NET 2.x

2005-07-25  Peter Dennis Bartok  <pbartok@novell.com>

	* BaseValidator.cs: Added AssociateControlID (new in sp1), fixed 
	  attributes
	* Xml.cs: Fixed base class, attributes
	* Button.cs, DataGridColumnCollection.cs, HyperLinkColumn.cs, 
	  Label.cs, ListItem.cs, ListControl.cs, CustomValidator.cs, 
	  CheckBoxList.cs, AdRotator.cs, DropDownList.cs, HyperLink.cs, 
	  DataGrid.cs, ButtonColumn.cs, CompareValidator.cs, Calendar.cs, 
	  ListBox.cs, ImageButton.cs, LinkButton.cs: Attribute fixes

2005-07-25  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: WOOHOOO! all tests pass. Boy is this class
	cracktastic.
	
2005-07-25  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: If the repeater has one column, the separators
	are rendered on a different line

2005-07-25  Peter Dennis Bartok  <pbartok@novell.com> 

	* DataGridSortCommandEventArgs: Sealed class
	* ButtonColumn.cs, Calendar.cs: Added Attributes

2005-07-25  Peter Dennis Bartok  <pbartok@novell.com>

	* Button.cs, Style.cs, BaseCompareValidator.cs, RangeValidator.cs,
	  BaseValidator.cs, AdRotator.cs, BoundColumn.cs: Added Attributes

2005-07-25  Peter Dennis Bartok  <pbartok@novell.com> 

	* FontInfo.cs, Style.cs, RangeValidator.cs, ListItemCollection.cs,
	  DropDownList.cs, WebControl.cs, ValidationSummary.cs: Added Attributes

2005-07-25  Chris Toshok  <toshok@ximian.com>

	* ValidationSummary.cs (AddAttributesToRender): add client side
	support.
	(OnPreRender): set the "been here" flag.
	(Render): add client side support.

2005-07-25  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Split the horiz and vertical cases, because this
	class has rules that are beyond strange. Continue working to make
	my tests work.

2005-07-25  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Misc fixes for my test suite.

2005-07-25  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Set the command name and args on the link buttons.

2005-07-25  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Lots o implementation.

2005-07-25  Jackson Harper  <jackson@ximian.com>

	* BoundColumn.cs: Partial implementation to get the DataGrid tests
	passing again.

2005-07-23  Jordi Mas i Hernandez  <jordi@ximian.com>

	* Button.cs: fixes events, adds attributes

2005-07-23  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (GetControlValidateValue): handle ListItems as
	prop.GetValue results.
	(Render): fix the static non-uplevel case, so that we display text
	when there's an error.

2005-07-22  Chris Toshok  <toshok@ximian.com>

	* RegularExpressionValidator.cs (AddAttributesToRender): only
	output ValidationExpression if it's != null.

2005-07-22  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (AddAttributesToRender): fix up the Display
	rendering such it matches MS's output.
	(Render): stop using the huge complicated if's for each output
	stage and move to boolean flags, and fix the static-nonuplevel
	case, where a validator outputs as nothing but &nbsp;

2005-07-22  Jordi Mas i Hernandez  <jordi@ximian.com>
	* Calendar.cs: Initial implementation
	* CalendarSelectionMode.cs: fix enum order

2005-07-22  Sebastien Pouliot  <sebastien@ximian.com>

	* DataList.cs: Rewrote the IRepeatInfoUser.RenderItem to support all
	(or more?) specific cases - including correct support for separators.
	Added some (commented) debugging code.
	* HyperLink.cs: Only render href and target attributes if they're not
	empty. Add "border=0" when rendering <img> tag. Fix Target default 
	value.

2005-07-22  Peter Dennis Bartok  <pbartok@novell.com> 

	* Style.cs (CopyFrom): Reset must go, MS doesn't do it (See tests)

2005-07-22  Peter Dennis Bartok  <pbartok@novell.com> 

	* Style.cs (CopyFrom): Reset our styles and don't set bits from
	  target explicitly, properties will set them

2005-07-22  Dick Porter  <dick@ximian.com>

	* BoundColumn.cs: 
	* ButtonColumn.cs: Initial stubs

2005-07-22  Dick Porter  <dick@ximian.com>

	* RadioButton.cs:
	* CheckBox.cs: Add assembly attributes

2005-07-22  Ben Maurer  <bmaurer@ximian.com>

	* HyperLink.cs: Handle non-literal children.

2005-07-21  Ben Maurer  <bmaurer@ximian.com>

	* Label.cs: SP1 stuff

2005-07-21  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (RegisterValidatorCommonScript): remove the NS4
	stuff that I c&p'ed from elsewhere - NS4 doesn't support the DOM1
	stuff WebUIValidation.js uses, so we don't support it for uplevel
	rendering.

2005-07-21  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (DetermineRenderUplevel): include checks for
	the EcmaScriptVersion and W3CDomVersion.

2005-07-21  Sebastien Pouliot  <sebastien@ximian.com> 
  
	* BaseDataList.cs: Support IEnumerable.
	* DataList.cs: Fix alternate items.
	* TableCell.cs: Fixed AddParsedSubObject to work nicely with existing
	controls and the Text property.

2005-07-21  Ben Maurer  <bmaurer@ximian.com>

	* TextBoxMode.cs: Wrong ordering of enum...

2005-07-21  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (OnPreRender): call DetermineRenderUplevel and
	cache the results.

2005-07-21  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (get_PropertiesValid): use our containing
	NamingContainer, not ourselves, to look up controls.
	(CheckControlValidationProperty): same.
	(GetControlRenderID): same.
	(GetControlValidationValue): same.
	(AddAttributesToRender): add the display style attribute if
	Display != Static, and add the value of IsValid if it's false.
	(DetermineRenderUplevel): use a try block around (Page.Request)
	since that can raise an exception.
	(OnPreRender): set pre_render_called, so we can consult it in
	Render.
	(Render): complicate this method more to handle more of the
	Display/pre_render_called permutations.

2005-07-21  Peter Dennis Bartok  <pbartok@novell.com> 

	* CustomValidator.cs: Initial implementation, still work in progress

2005-07-21  Sebastien Pouliot  <sebastien@ximian.com>

	* DataList.cs: Fix rendering for special items (-1).

2005-07-21  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Fix most of the tests.

2005-07-21  Sebastien Pouliot  <sebastien@ximian.com>

	* Image.cs: Call ResolveUrl for ImageUrl and DescriptionUrl properties.
	Add a border=0 attribute if no style is defined.
	* TableCell.cs: Use HtmlTextWriterTag (not a string).
	* TableHeaderCell.cs: Use HtmlTextWriterTag (not a string).
	* TableRow.cs: Use HtmlTextWriterTag (not a string).

2005-07-21  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: Fix attributes.
	* HorizontalAlign.cs: Fix attributes.
	* Image.cs: Fix attributes and enums checks.
	* Table.cs: Fix attributes an enums checks.
	* TableCell.cs: Fix attributes.
	* TableCellCollection.cs: Fix attributes.
	* TableItemStyle.cs: Fix attributes and enums checks.
	* TableRowCollection.cs: Fix attributes.
	* TableRow.cs: Fix attributes.
	* TableStyle.cs: Fix attributes and enums checks.
	* VerticalAlign.cs: Fix attributes.

2005-07-21  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: Remove/#if-out useless/2.0 stuff.
	* DataList.cs: Added rendering support when ExtractTemplatesRows
	property is true (but RepeatInfo needs to be fixed to see it works).
	* DataListItem.cs: Added rendering support when extractRows parameter
	is true (but RepeatInfo still needs to be fixed ;-)

2005-07-21  Duncan Mak  <duncan@novell.com>

	* HyperLinkColumn.cs: Initial implementation.
	Todo: Figure out Initialize and InitializeCell.

2005-07-20  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: don't use Page.FindControl, use this Control's
	FindControl, so it'll use the same naming container.

2005-07-21  Duncan Mak  <duncan@novell.com>

        * DataGridCommandEventArgs.cs: 
        * DataGridPageChangedEventArgs.cs: 
        * RepeaterCommandEventArgs.cs:  Fixed visibility.

	* DataGridPageChangedEventArgs.cs (CommandSource): Fixed typo.
	* DataGridSortCommandEventArgs.cs (CommandSource): Ditto..       
	
2005-07-20  Chris Toshok  <toshok@ximian.com>

	* Button.cs: hook up the client side validation stuff.

	* ImageButton.cs: same.

	* LinkButton.cs: same, although it's a little more complicated
	here.

2005-07-20  Peter Dennis Bartok  <pbartok@novell.com> 

	* DropDownList.cs: 
	  - Implemented RaisePostDataChangedEvent()
	  - Spewing postback command if AutoPostBack is true

2005-07-20  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: another Page != null check when uplevel
	rendering.
	
2005-07-20  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: check Page != null when determining if we're
	rendering uplevel or not.

2005-07-20  Peter Dennis Bartok  <pbartok@novell.com> 

	* ListItemCollection.cs: Removed obsolete method that's no longer
	  referenced

2005-07-20  Peter Dennis Bartok  <pbartok@novell.com>

	* DropDownList.cs: Oops. Forgot to implement LoadPostData
	* ListItemCollection.cs: Added convenience method to have faster
	  PostData handling

2005-07-20  Peter Dennis Bartok  <pbartok@novell.com>

	* DropDownList.cs:
	  - Automatically select the first item if none are selected
	  - Throw exception if more than one item is selected

2005-07-20  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* DataList.cs: Fix style handling for RepeatLayout.Flow (which isn't
	handled by RepeatInfo).

2005-07-20  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Store the data source created columns in a 
	  DataGridColumnCollection. This way they can be put in the 
	  view state more easily, and accessed without casting.

2005-07-20  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs (AddAttributesToRender): render the client side
	attributes if we're in uplevel mode.
	(DetermineRenderUplevel): flesh out a bit - for now basically
	return true unless the control has it disabled.
	(OnInit): only add the validator to Page's list if there is, in
	fact, a page.
	(OnUnload): same for removal.
	(OnPreRender): hook up client scripting stuff here.  Only the call
	to RegisterValidatorCommonScript is a for sure thing here, the
	registering of the submit statement and startup script should
	probably go elsewhere, but I don't know where.
	(RegisterValidatorCommonScript): register the <script
	src=".../WebUIValidation.js"> tag, if it's not already there.
	(RegisterValidatorDeclaration): add our span object to the
	Page_Validators JS array.
	(Render): always render the tags (although this is probably not
	right), and call RegisterValidatorDeclaration here.
	
	* BaseCompareValidator.cs (AddAttributesToRender): render the
	client side attributes if we're in uplevel mode.
	(DetermineRenderUplevel): add MonoTODO.. why override this?  Just
	call base.DetermineRenderUplevel for now.

	* RegularExpressionValidator.cs (AddAttributesToRender): render
	the client side attributes if we're in uplevel mode.
	
	* RequiredFieldValidator.cs (AddAttributesToRender): same.

	* CompareValidator.cs (AddAttributesToRender): same.
	
2005-07-20  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Save the data source created column set in the 
	  view state.

2005-07-20  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* DataList.cs: Fix events and properties exceptions. Give the right
	informations to RenderItem.

2005-07-20  Peter Dennis Bartok  <pbartok@novell.com> 

	* ValidationSummary.cs: Implemented rendering

2005-07-20  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: column names are cached and only regenerated if useDataSource
	  is set to true. Otherwise they are just fetched from the last set that 
	  was generated from the source.

2005-07-20  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Assign some properties of newly created BoundColumns.

2005-07-20  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* DataList.cs: Fix viewstate ordering.

2005-07-20  Ben Maurer  <bmaurer@ximian.com>

	* SelectedDatesCollection.cs: Apprarently, I don't write code well
	at 1 am.

	* Repeater.cs: Uh, actually add stuff to the items collection
	 (thanks sp ;-)

2005-07-20  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* BaseDataList.cs: EnsureChildControls on Controls property.
	* DataList.cs: Fix rendering and Controls/Items differences.
	* DataListItem.cs: Added rendering of controls.

2005-07-20  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: Don't call base.Render (or we'll get an extra span).

2005-07-20  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Add some of the collections. Implement
          column creation.

2005-07-20  Jackson Harper  <jackson@ximian.com>

	* PagedDataSource.cs: Implement GetItemProperties, this is
	  needed for the datagrid.

2005-07-20  Ben Maurer  <bmaurer@ximian.com>

	* DataGridColumnCollection.cs: New impl

	* TemplateColumn.cs: New impl

2005-07-19  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: Call PrepareControlHierarchy from Render.
	* DataList.cs: Work in progress... Added attributes, proper 
	IRepeatInfoUser support and cool things stolen from other classes.
	* DataListCommandEventArgs.cs: Class is sealed.
	* DataListItem.cs: RenderItem is public.

2005-07-19  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Use Events Add/RemoveHandler. Don't create
	  a viewstate object if all the viewstate stuff is null.

2005-07-19  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Implement style properties and viewstate 
	  saving/loading/tracking.

2005-07-19  Chris Toshok  <toshok@ximian.com>
	
	* BaseValidator.cs: more fixes from pdb.

2005-07-19  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: some test-driven fixes.

2005-07-19  Chris Toshok  <toshok@ximian.com>

	* BaseValidator.cs: Initial implementation.

2005-07-19  Sebastien Pouliot  <sebastien@ximian.com>

	* Repeater.cs: Fix small typo.

2005-07-19  Peter Dennis Bartok  <pbartok@novell.com> 

	* ValidationSummaryTest.cs: Started implementation
	* RangeValidator.cs: Implemented
	* ValidatedControlConverter.cs: Implemented
	* DropDownList.cs: Implemented

2005-07-19  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: Implement bubble event.

2005-07-19  Jackson Harper  <jackson@ximian.com>

	* DataGrid.cs: New implementation. Just properties and events for 
	  now.

2005-07-18  Chris Toshok  <toshok@ximian.com>

	* BaseCompareValidator.cs: Initial implementation, with some NYI.

2005-07-19  Ben Maurer  <bmaurer@ximian.com>

	* FontUnit.cs: Corcompare fixes

	* UnitConverter.cs: Fix api diffs

2005-07-18  Ben Maurer  <bmaurer@ximian.com>

	* ListControl.cs: Fix api differences

2005-07-18  Sebastien Pouliot  <sebastien@ximian.com>

	* Table.cs: Fix indentation for caption. Simplify check when adding 
	controls.
	* TableRow.cs: Simplify check when adding controls.

2005-07-18  Chris Toshok  <toshok@ximian.com>

	* CompareValidator.cs: wtf, just use the base class's methods.

2005-07-18  Chris Toshok  <toshok@ximian.com>

	* CompareValidator.cs: do comparisons based on
	BaseCompareValidator.Type.

2005-07-18  Chris Toshok  <toshok@ximian.com>

	* CompareValidator.cs: initial implementation.

2005-07-18  Chris Toshok  <toshok@ximian.com>

	* RegularExpressionValidator.cs: initial implementation.

2005-07-18  Sebastien Pouliot  <sebastien@ximian.com>

	* DataList.cs: Fixed to match 1.1 behaviour (and new unit tests).

2005-07-18  Jackson Harper  <jackson@ximian.com>

	* CheckBoxList.cs: Implement LoadPostBackData. Also register 
	  checkboxes for postback if they are checked so we can find
	  out when they are unchecked. Copy the AutoPostBack variable 
	  to the to be rendered checkbox when rendering.

2005-07-18  Ben Maurer  <bmaurer@ximian.com>

	* TextBox.cs: Finish this up.

	* AdRotator.cs: Fix issues in the test suite. Minor style
	cleanups.

	* Repeater.cs: Fix a bug where the datasource is null and we do
	the binding

	* WebColorConverter.cs: Optimize by not doing a concat on a
	formatted string.

2005-07-17  Ben Maurer  <bmaurer@ximian.com>

	* ListItemCollection.cs: Multiple uses of equals rather than
	string.compare as below. Remove unreachable code warning.

	* WebColorConverter.cs (ConvertTo): Use the == operator on string
	rather than an invariant non-case ignoring compare. They are
	exactly the same thing. Use proper coding style in this method.

	* WebControl.cs: Return null when saving the view state if there
	is no state in any of the things we save. This creates a fairly
	large savings, because we can avoid saving anything about many
	levels of deaply nested controls.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* CheckBoxList.cs: Use the index as the ID, the rest of the 
	  id is built by being in the NamingContainer.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Use enum instead of string. Saves a lookup. 

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* CheckBoxList.cs: FindControl always returns 'this' according
	  to my probing.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* CheckBoxList.cs: New impl.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* WebControl.cs: Use the ClientID when rendering a controls ID
	  attribute so that naming containers are honoured. 

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: use the state manager interface for tracking
	  the viewstate.

2005-07-15  Ben Maurer  <bmaurer@ximian.com>

	* Repeater.cs (DoItem): Add the DataItem before we call user
	methods, as it seems to be there with msft.

2005-07-15  Sebastien Pouliot  <sebastien@ximian.com>

	* BaseDataList.cs: New. (mostly complete) implementation.
	* DataKeyCollection.cs: New. Implementation (complete).
	* DataList.cs: New. (mostly incomplete) implementation.
	* DataListItem.cs: New. (mostly complete) implementation.
	* DataListItemCollection.cs: New. Implementation (complete).

2005-07-15  Ben Maurer  <bmaurer@ximian.com>

	* Repeater.cs (DoItem): We need to .Add the control *before* we
	data bind it so that the state gets tracked correctly. Fixes the
	postback test case.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Simplify comparison. 

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs:
	* Repeater.cs: Use new utility class for resolving data sources.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Add attributes so the sub items get parsed 
	  properly. Remove old unneeded code for resolving lists.

2005-07-15  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Use the DataSourceHelper so DataMembers are 
	  resolved properly.

2005-07-14  Ben Maurer  <bmaurer@ximian.com>

	* WebControl.cs:
	  - Some optimizations
	    * Don't use enum formatting stuff, it is 1) expensive 2) does 
	      allocations. Use a new method in HtmlControl to do the right
	      formatting.
	    * Don't use Enum.IsDefined but an explicit check.
	    * (x == "" || x.Length < 2) is not needed since "".Length == 0 < 2
	  - Use the correct coding style.
	
2005-07-14  Peter Dennis Bartok  <pbartok@novell.com> 

	* WebColorConverter.cs: 
	  - Alpha of 255 is only set if the hex number is exactly 6 digits
	  - Ben didn't like the catch { throw; } (even though MS documents to
	    do so)
	  - Use Invariant Culture for parsing (thanks, Ben)

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Use DataBinder.Eval for data binding. This is more
	code-reuse-arific. Also use the IStateManager interface for loading
	data instead of the old internal method.

2005-07-14  Peter Dennis Bartok  <pbartok@novell.com>

	* WebColorConverter.cs: Implemented

2005-07-14  Ben Maurer  <bmaurer@ximian.com>

	* Repeater.cs: Cleanup; use the DataSourceHelper thingy.

2005-07-14  Ben Maurer  <bmaurer@ximian.com>

	* Repeater.cs: Get it working

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Initial implementation of Databinding. Make sure
	that the ListItemCollection is created when we load its ViewState. 

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: Fix typo.

2005-07-14  Jackson Harper  <jackson@ximian.com>

	* ListControl.cs: New Implementation. Lacks databinding support.

2005-07-14  Ben Maurer  <bmaurer@ximian.com>

	* Repeater.cs: The beginnings of this control

2005-07-14  Peter Dennis Bartok  <pbartok@novell.com>

	* TargetConverter.cs: Implemented

2005-07-14  Duncan Mak  <duncan@novell.com>

	* PagedDataSource.cs: Initial implementation.

	Methods that need to be figured out:
	CopyTo, GetItemProperties, PageCount, IsLastPage.

	To complete: CollectionEnumerator, ListEnumerator.

2005-07-13  Duncan Mak  <duncan@novell.com>

	* RepeatDirection.cs:
	* RepeatLayout.cs:
	* ValidationCompareOperator.cs:
	* ValidationDataType.cs:
	* ValidationSummaryDisplayMode.cs: 
	* ValidatorDisplay.cs: Added remaining enumerations.
	
2005-07-13  Peter Dennis Bartok  <pbartok@novell.com>

	* FontNamesConverter.cs: Implemented

2005-07-13  Ben Maurer  <bmaurer@ximian.com>

	* RepeaterItem.cs: Compile fix

	* RepeaterItemCollection.cs: New file

	* RepeaterItem.cs: get OnBubbleEvent right.

2005-07-13  Peter Dennis Bartok  <pbartok@novell.com> 

	* ListItemCollection.cs: Count can be derived from the array, which
	  allows us to use a Pair instead of a Triplet and save some space

2005-07-13  Ben Maurer  <bmaurer@ximian.com>

	* RepeaterItem.cs: Stub

2005-07-13  Peter Dennis Bartok  <pbartok@novell.com>

	* ListItemCollection.cs: Implemented
	* WebControl.cs: Added check for enumeration validity (thanks Jackson)

2005-07-13  Ben Maurer  <bmaurer@ximian.com>

	* RepeatInfo.cs: Impl.

2005-07-13  Peter Dennis Bartok  <pbartok@novell.com>

	* FirstDayOfWeek.cs: Added

2005-07-13  Jackson Harper  <jackson@ximian.com>

	* ListBox.cs: Some parameter checking.

2005-07-13  Sebastien Pouliot  <sebastien@ximian.com>
 
	* Image.cs: Added support for DescriptionUrl as this property was
	added in Fx 1.1 SP1.

2005-07-13  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs (AddAttributesToRender): Don't render attributes if they
	  contain only their default value

2005-07-13  Sebastien Pouliot  <sebastien@ximian.com> 

	* Table.cs: New. Initial re-implementation.
	* TableCell.cs: New. Initial re-implementation.
	* TableCellCollection.cs: New. Initial re-implementation.
	* TableHeaderCell.cs: New. Initial re-implementation.
	* TableItemStyle.cs: New. Initial re-implementation.
	* TableRow.cs: New. Initial re-implementation.
	* TableRowCollection.cs: New. Initial re-implementation.
	* TableStyle.cs: New. Initial re-implementation.

2005-07-13  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* Style.cs: Removed the call to Reset in CopyFrom. This fix the new
	unit tests (for Style) and more tests in Table* classes.

2005-07-13  Sebastien Pouliot  <sebastien@ximian.com>

	* Style.cs: TableStyle and TableItemStyle don't override IsEmpty, 
	however IsEmpty returns false if any of their properties are set.
	Looks ugly but it's compatible with MS implementation (feature and
	signature wise).

2005-07-13  Dick Porter  <dick@ximian.com>

	* CheckBox.cs: Reverted Ben's enum-to-int ViewState change, remove
	null Text properties from the ViewState, test for TextAlign being
	out of range.  All to make tests pass on both mono and ms
	runtimes.

2005-07-13  Jackson Harper  <jackson@ximian.com>

	* ListBox.cs: Use invariant culture when doing a ToString,
	  set value to the item's value, not to its Text.

2005-07-12  Peter Dennis Bartok  <pbartok@novell.com>

	* WebControl.cs (AddAttributesToRender): Added ID to rendered
	  attributes

2005-07-12  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs(MergeWith): Handle null styles

2005-07-12  Sebastien Pouliot  <sebastien@ximian.com>

	* TableCaptionAlign.cs: This enum was added in 1.1 SP1 so I removed
	the #if NET_2_0 on it.

2005-07-12  Peter Dennis Bartok  <pbartok@novell.com> 

	* Style.cs: Only render font elements if fontinfo object exists
	* WebControl.cs:
	  - Implemented SaveViewState()
	  - Added loading of Style to LoadViewState
	  - Implemented IAttributeAccessor methods

2005-07-12  Jackson Harper  <jackson@ximian.com>

	* ListBox.cs: Even track default values in the viewstate. Call
	  base's RenderContents.

2005-07-12  Jackson Harper  <jackson@ximian.com>

	* ListBox.cs: New impl.

2005-07-12  Peter Dennis Bartok  <pbartok@novell.com> 

	* WebControl.cs: 
	  - Implemented methods
	  - Fixed brackets

2005-07-12  Ben Maurer  <bmaurer@ximian.com>

	* ListItem.cs: New impl.

2005-07-12  Duncan Mak  <duncan@novell.com>

	* DayNameFormat.cs: Added.

2005-07-12  Peter Dennis Bartok  <pbartok@novell.com> 

	* WebControl.cs: Implemented properties

2005-07-12  Ben Maurer  <bmaurer@ximian.com>

	* TextBox.cs: Passwords seem 1) not to be rendered to the client
	if set, 2) not kept in view state (for security reasons...)

	* LinkButton.cs: 
	* Button.cs: Page.Validate () if needed. Gets the validator tests
	working again.

	* TextBox.cs: Properties to get the validator stuff to work.

2005-07-12  Miguel de Icaza  <miguel@novell.com>

	* Unit.cs: If the units are pixels, then truncate the value. 

2005-07-12  Dick Porter  <dick@ximian.com>

	* RadioButton.cs: New implementation

	* CheckBox.cs: Rearrange the attributes rendering to allow
	RadioButton to derive from this

2005-07-12  Jordi Mas i Hernandez  <jordi@ximian.com>

	* TitleFormat.cs: Add attribute
	* TextBoxMode.cs: Add attribute
	* CalendarDay.cs: Initial implementation
	* ImageButton.cs: Initial implementation
	* CalendarSelectionMode.cs:Initial implementation

2005-07-12  Jordi Mas i Hernandez  <jordi@ximian.com>

	* TextBoxMode.cs: simple enum
	* TitleFormat.cs: simple enum

2005-07-11  Peter Dennis Bartok  <pbartok@novell.com> 

	* FontInfo.cs: Now using BenM's fancy internal StateBag methods

2005-07-11  Peter Dennis Bartok  <pbartok@novell.com>

	* FontUnit.cs: Added TypeConverter attribute to class
	* FontUnitConverter.cs: Implemented

2005-07-11  Ben Maurer  <bmaurer@ximian.com>

	* LinkButton.cs: 
	* Button.cs: Bubble the Command event.

2005-07-11  Ben Maurer  <bmaurer@ximian.com>

	* Button.cs:
	  - Clean up style (with my wonderful state bag hack!)
	  - Fix a view state typo.
	  - Use AddAttributesToRender
	  - Don't add an extra <span>

2005-07-11  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs: Handle null constructor argument for bag

2005-07-11  Dick Porter  <dick@ximian.com>

	* CheckBox.cs: New implementation

	* RadioButton.cs: Initial stubbed version that just compiles

2005-07-10  Jordi Mas i Hernandez  <jordi@ximian.com> 
 
	* Button.cs: Initial Button implementation

2005-07-10  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* VerticalAlign.cs: Fixed enum name (copy/paste from HorizontalAlign).

2005-07-09  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* HorizontalAlign.cs: Typo in header.
	* VerticalAlign.cs: New. Required enum for TableRow control.

2005-07-09  Ben Maurer  <bmaurer@ximian.com>

	* TextBox.cs: More work on this

2005-07-09  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* GridLines.cs: New. Required enum for Table control.
	* HorizontalAlign.cs: New. Required enum for Table control.

2005-07-09  Duncan Mak  <duncan@novell.com>

	* CommandEventHandler.cs:
	* DataGridCommandEventHandler.cs:
	* DataGridItemEventHandler.cs:
	* DataGridPageChangedEventHandler.cs:
	* DataGridSortCommandEventHandler.cs:
	* DataListCommandEventHandler.cs:
	* DayRenderEventHandler.cs:
	* RepeaterCommandEventHandler.cs:
	* ServerValidateEventHandler.cs: Add delegates.
	
	* ListItemType.cs:
	* ListSelectionMode.cs:
	* NextPrevFormat.cs:
	* PagerMode.cs
	* PagerPosition.cs: Add enums.

2005-07-09  Ben Maurer  <bmaurer@ximian.com>

	* TextBox.cs: Add the work I did on this today. It's not complete
	yet, but its a start!

2005-07-09  Duncan Mak  <duncan@novell.com>

	* CommandEventArgs.cs:
	* DataGridCommandEventArgs.cs:
	* DataGridItemEventArgs.cs:
	* DataGridPageChangedEventArgs.cs:
	* DataGridSortCommandEventArgs.cs:
	* DataListCommandEventArgs.cs:
	* DataListItemEventArgs.cs:
	* DayRenderEventArgs.cs:
	* RepeaterCommandEventArgs.cs:
	* RepeaterItemEventArgs.cs:
	* ServerValidateEventArgs.cs: Implemented.
	
2005-07-08  Sebastien Pouliot  <sebastien@ximian.com>

	* Image.cs: New. Image class implementation.
	* ImageAlign.cs: New. ImageAlign enum definitions.

2005-07-08  Jackson Harper  <jackson@ximian.com>

	* Literal.cs: New implentation.
	* MonthChangedEventArgs.cs: new
	* MonthChangedEventHandler.cs: new
	
2005-07-08  Ben Maurer  <bmaurer@ximian.com>

	* LinkButton.cs: Command impl

2005-07-08  Ben Maurer  <bmaurer@ximian.com>

	* LinkButton.cs: Initial impl

2005-07-08  Jackson Harper  <jackson@ximian.com>

	* AdCreatedeventArgs.cs: New implementation.

2005-07-08  Dick Porter  <dick@ximian.com>

	* TextAlign.cs: 
	* BorderStyle.cs: Added

2005-07-07  Peter Dennis Bartok  <pbartok@novell.com>

	* FontInfo.cs: Fixed behaviour discrepancies showed by tests

2005-07-07  Miguel de Icaza  <miguel@novell.com>

	* Xml.cs: New implementation.  R00lz.

2005-07-07  Peter Dennis Bartok  <pbartok@novell.com>

	* FontInfo.cs: Added and implemented.
	* Style.cs: Fixed behaviour discrepancies showed by tests

2005-07-07  Ben Maurer  <bmaurer@ximian.com>

	* PlaceHolderControlBuilder.cs: new file

	* LabelControlBuilder.cs: New file

	* HyperLink.cs: use control builder; fix parsing stuff

	* HyperLinkControlBuilder.cs: new file

	* Panel.cs: misc fixes

2005-07-07  Miguel de Icaza  <miguel@novell.com>

	* Unit.cs: Add TypeConverter, so that web_panel.aspx works again.

	* UnitConverter.cs: Add new file, learned from the
	System.Drawing.ColorConverter.

2005-07-07  Ben Maurer  <bmaurer@ximian.com>

	* PlaceHolder.cs: New file. Seems to do nothing

	* Label.cs: Use my new statebag trick to reduce typing

	* HyperLink.cs: New file

2005-07-06  Peter Dennis Bartok  <pbartok@novell.com>

	* Style.cs: Added and implemented.

2005-07-06  Miguel de Icaza  <miguel@novell.com>

	* FontUnit.cs: New file.

	* Unit.cs: New file. 

	Added support for null and empty string constructors.

2005-07-06  Ben Maurer  <bmaurer@ximian.com>

	* Unit.cs: cctor not needed; static fields are 0 init'd by default

	* WebControl.cs: Kothari & Datye's book explains how these work.

	* IRepeatInfoUser.cs: Reimpl.

2005-07-06  Peter Dennis Bartok  <pbartok@novell.com>

	* WebControl.cs: Added stub

2005-07-05  Miguel de Icaza  <miguel@novell.com>

	* Label.cs: First control.

2005-06-27  Lluis Sanchez Gual <lluis@novell.com>

	* DataControlField.cs: Ignore the ShowHeader property when
	building the control's content. It is the resposability of
	the field container to decide if the header should be shown
	or not.

2005-06-10  Lluis Sanchez Gual <lluis@novell.com>

	* AdType.cs:
	* ImageFieldMode.cs:
	* DynamicImageParameterMode.cs:
	* TableViewMode.cs: Removed.
	
	* SortDirection.cs:
	* AdRotator.cs:
	* TableRowSection.cs:
	* AutoCompleteType.cs:
	* DayNameFormat.cs: Track changes in 2.0 api.
	
	* StringArrayConverter.cs: This class is 2.0 only.

2005-06-06  Lluis Sanchez Gual <lluis@novell.com>

	* GridView.cs:
	* FormView.cs:
	* DetailsView.cs: Bind the control after creating all child
	 controls.
	* DataBoundControl.cs: Call OnDataBinding and OnDataBound in
	the correct methods.
	* BaseDataBoundControl.cs: Don't call DataBind nor OnDataBound
	in this class. This is done in DataBoundControl. All this fixes
	bug #75076.

2005-05-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListItemCollection.cs: Patch from Curtis (eto@shaw.ca) that fixes
	FindByText. Closes bug #74205.

2005-05-26 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* PagedDataSource.cs: patch by Suresh Kumar that makes PageCount return
	1 when there's a datasource and 0 pages. Closes bug #73864.

2005-05-26  Lluis Sanchez Gual <lluis@novell.com>

	* DataListItem.cs:
	* GridViewRow.cs:
	* DataGridItem.cs:
	* RepeaterItem.cs:
	* FormView.cs:
	* MenuItemTemplateContainer.cs:
	* DetailsView.cs: Track changes in the IDataItemContainer interface.
	
	* CommandField.cs: Added CausesValidation property. Set that
	property value to all buttons of the field.
	
	* SqlDataSourceView.cs:
	* CollectionDataSource.cs:
	* XmlDataSourceView.cs: Properly initialize the base class.
	
	* SiteMapDataSource.cs:
	* SiteMapHierarchicalDataSourceView.cs:
	* SiteMapNodeItem.cs:
	* SiteMapDataSourceView.cs:
	* SiteMapPath.cs: Mostly implemented.
	
	* HierarchicalDataBoundControl.cs: Always bind the control when the
	page is loaded for the first time.
	
	* TreeView.cs: Properly bind the control when loaded from a callback.

2005-05-21  Ben Maurer  <bmaurer@ximian.com>

	* BaseDataList.cs: Caption is in 1.1 too, though not
	documented. Gonz owes me [more] ice cream. Yummmmm.

2005-05-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseDataList.cs: implemented 2.0 Caption property.

2005-05-18  Lluis Sanchez Gual <lluis@novell.com>

	* TreeView.cs: Always render the startup script. This fixes
	bug #74949. 

2005-05-13  Lluis Sanchez Gual <lluis@novell.com>

	* WizardStepBase.cs:
	* WizardStep.cs: Added missing attributes.
	* Wizard.cs: Implemented missing methods and properties. It can now
	be considered feature complete.

2005-05-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: cleanup in AutoCreateColumns. Don't throw at the end of
	the method if the data source was en empty IEnumerator. Fixes
	bug #74804.

2005-05-06  Lluis Sanchez Gual <lluis@novell.com>

	* TreeNode.cs:
	* TreeView.cs:
	* Menu.cs: Implemented some new properties from beta 2.
	
	* DataControlButton.cs: Render the ControlStyle if it
	is not empty.
	
	* UnitConverter.cs:
	* FontUnitConverter.cs: Improved the conversion to InstanceDescriptor.
	It will now generate an object creation, instead of a Parse call. 
	
	* GridViewCommandEventArgs.cs: Added missing property.
	* SubMenuStyleCollection.cs: This class is not sealed.
	* MultiView.cs: Set Visible=false to all views that are not
	shown. This ensures that it's view state is saved. 
	
	* BaseDataBoundControl.cs:
	* GridViewDeletedEventArgs.cs: Minor api fixes.
	
	* FormViewDeleteEventArgs.cs:
	* DetailsViewDeletedEventArgs.cs:
	* ListControl.cs: Fix warnings.
	
	* CircleHotSpot.cs
	* HotSpot.cs
	* HotSpotCollection.cs
	* ImageMap.cs
	* PolygonHotSpot.cs
	* RectangleHotSpot.cs
	* WizardStepCollection.cs : Implemented.
	
	* WizardStep.cs
	* WizardStepBase.cs
	* Wizard.cs: Initial implementation.

2005-05-04  Lluis Sanchez Gual <lluis@novell.com>

	* DataControlField.cs:
	* CommandField.cs: 
	* GridView.cs:
	* FormView.cs:
	* DataControlCommands.cs:
	* DetailsView.cs: Use constants to identify commands.

	* SubMenuStyle.cs: Use Unit instead of int for padding.
	* SubMenuStyleCollection.cs: Implemented.
	
	* DataList.cs:
	* Menu.cs: Added some missing methods and properties.
	
	* Literal.cs:
	* DataGridPagerStyle.cs: Fixed default value attributes.
	* ListControl.cs: Implemented IEditableTextControl interface.
	
	* MenuItemBinding.cs: Added Selectable property.
	* CustomValidator.cs: removed interface.
	
	* MenuItem.cs: Added support for custom binding. 
	* DropDownList.cs: Moved text properties to base class.

2005-04-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: OnDayRender can toggle IsSelectable on our back.

2005-04-26 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: when the day is active, modify the text of the literal
	control that holds the number, not the text of the TableCell. Also call
	OnDayRender before updating that text. Fixes bug #74718.

2005-04-22  Lluis Sanchez Gual <lluis@novell.com>

	* DataKey.cs: Added virtual TrackViewState and IsTrackingViewState
	members.
	* DataControlFieldHeaderCell.cs: Save Scope in view state.
	Added AbbreviatedText property.
	* AutoGeneratedField.cs: The constructor should actually be internal.
	* DataGridItem.cs: Added implemented interface in 2.0.
	* DataControlFieldCollection.cs: Implemented CloneFields and
	GetKnownTypes().
	* 

2005-04-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* StringArrayConverter.cs:
	* Calendar.cs: warnings.

2005-04-21  Lluis Sanchez Gual <lluis@novell.com>

	* FormViewDeleteEventArgs.cs:
	* FormViewInsertEventArgs.cs:
	* FormViewUpdateEventArgs.cs:
	* FormViewDeletedEventArgs.cs:
	* FormViewUpdatedEventArgs.cs:
	* FormViewInsertedEventArgs.cs: Implemented some missing properties.
	
	* LinkButton.cs:
	* IButtonControl.cs:
	* Button.cs: Removed SoftKey property.
	
	* CheckBox.cs: Don't try to load post back data if the control
	is disabled.
	
	* ImageField.cs:
	* AutoGeneratedField.cs:
	* DataControlField.cs:
	* CommandField.cs:
	* ButtonFieldBase.cs:
	* BoundField.cs:
	* CheckBoxField.cs:
	* TemplateField.cs:
	* ButtonField.cs: Don't bind fields in Insert state.
	Implemented CreateField and CopyProperties.
	
	* GridView.cs:
	* DetailsView.cs: Removed some unneeded interfaces. Don't
	generate the field rows if there are no items in the data source.
	Don't get the current keys until the whole control has been
	bound.

	* DetailsViewInsertedEventArgs.cs:
	* DataBoundControl.cs:	
	* ObjectDataSourceView.cs: Made some methods private.
	
	* MenuItemStyle.cs:
	* Menu.cs: Changed some properties from int to Unit.
	
	* DataControlButton.cs: javascript prefix is needed when raising
	the postback event from a link.
	
	* PagedDataSource.cs: Some fixes in Count and IsLastPage properties.
	The result was wrong when the total data source count was 0.
	
	* FormView.cs: Implemented.
	* FormViewRow.cs: Implemented.
	
	* Literal.cs:
	* Localize.cs: Fixed base interface.
	
	* BaseDataBoundControl.cs: In DataBind() call the base class
	DataBind method, so the binding context is properly set.

2005-04-15  Lluis Sanchez Gual <lluis@novell.com>

	* DetailsView.cs: Added some null checks.
	* TemplateField.cs: Implemented support for two-way bindings.

2005-04-14  Lluis Sanchez Gual <lluis@novell.com>

	* DetailsView.cs: Implemented support for Insert operation. 
	Added header and footer templates. Added missing style
	properties. 
	* ObjectDataSourceView.cs: Use ParameterCollection.GetValues
	to get filter values. Other minor fixes.
	* CommandField.cs: Properly render the Insert and New buttons.
	* ObjectDataSource.cs: Update the parameter collections after
	the page is loaded. This will fire the ParameterChanged event
	if needed.
	* DataBoundControl.cs: The OnDataSourceViewChanged method
	is called when the view changes, not when the datasource
	changes.
	
	* DetailsViewInsertedEventArgs.cs:
	* DetailsViewInsertEventArgs.cs: Implement Values property.
	
	* ImageField.cs:
	* AutoGeneratedField.cs
	* BoundField.cs:
	* CheckBoxField.cs:
	Take into account the Insert mode.
	
	* ParameterCollection.cs: Implemented UpdateValues and fixed
	GetValues (values can't be cached because can change).
	* Parameter.cs: Detect value changes in GetValue, and fire
	the change event if needed. Removed unused ParameterValue
	property. Other fixes.

2005-04-08  Lluis Sanchez Gual <lluis@novell.com>

	* DetailsView.cs: Initial implementation.
	* ObjectDataSourceView.cs: Notify changes in the parameters.
	* DetailsViewDeletedEventArgs.cs, DetailsViewUpdatedEventArgs.cs,
	  DetailsViewDeleteEventArgs.cs, DetailsViewUpdateEventArgs.cs:
	  Implemented some properties.
	* GridView.cs: Added null check in SelectedValue. Don't return null
	  for empty DataKeyNames list.
	* DetailsViewRowCollection.cs: Implemented.
	* DetailsViewRow.cs: Implemented.
	* ButtonFieldBase.cs: By default button field don't have headers.
	* BoundField.cs: Don't bind header fields.	  

2005-04-07  Lluis Sanchez Gual <lluis@novell.com>

	* ButtonField.cs: Get data item properties using TypeDescriptor.
	Made OnDataBindField private.
	* ObjectDataSourceView.cs: Implemented support for Delete and
	Insert operations, support for filtering and sorting,
	conflict detection, etc. It's now complete.
	* ObjectDataSource.cs: Completed most of functionality. Only
	caching support is missing.
	* ObjectDataSourceFilteringEventHandler.cs: New event handler.
	* TreeNode.cs: Get data item properties using TypeDescriptor.
	* PagerSettings.cs: Flush.
	* ObjectDataSourceFilteringEventArgs.cs: New event args.
	* GridView.cs: Get data item properties using TypeDescriptor
	and cache them. Properly set descending order in the sort
	expression. In UpdateRow, make sure we get the old values
	before the control is bound again.
	* ImageField.cs: Implemented.
	* AutoGeneratedField.cs: Initialize the field's sort
	expression in the constructor.
	* MenuItem.cs: Get data item properties using TypeDescriptor.
	* BoundField.cs: Get data item properties using TypeDescriptor.
	* CheckBoxField.cs: Added missing attributes.
	* TemplateField.cs: Implemented.

2005-04-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* UnitConverter.cs:
	* FontUnitConverter.cs: fixed ConvertTo to work with target
	InstanceDescriptor and value as a string.

	* Unit.cs: culture might be null.

	Fixes bug #74431.

2005-04-01  Lluis Sanchez Gual <lluis@novell.com>

	* ButtonField.cs: Mostly implemented.
	* DataControlFieldHeaderCell.cs: Implemented.
	* ObjectDataSourceView.cs: Initial implementation.
	* DataControlButton.cs: Added support for real buttons.
	* Label.cs, DataControlField.cs: Flush.
	* ObjectDataSource.cs: Initial implementation.
	* HiddenField.cs: Added class stub.
	* GridView.cs: Load autogenerated field properties before
	creating the children, to make sure that column info is ready.
	* ControlParameter.cs: Implemented Evaluate method.
	* ImageField.cs: Added class stub.
	* BoundField.cs: Added HtmlEncode property.
	* DataControlFieldCell.cs: Moved AccessibleDataControlFieldCell
	to its own file.
	* CheckBoxField.cs: Mostly implemented.
	* TemplateField.cs: Added class stub.
	* ObjectDataSourceSelectingEventArgs.cs: Added missing property.
	* ObjectDataSourceMethodEventArgs.cs: Fixed base class.
	* Parameter.cs: Added internal GetValue method (Evaluate is protected)

2005-03-23  Lluis Sanchez Gual <lluis@novell.com>

	* DataControlField.cs: Added missing InsertVisible property.
	* AutoGeneratedFieldProperties.cs: Implemented.
	* PagerSettings.cs: Minor fix.
	* GridView.cs: Implemented support for autogenerated fields, templates,
	accessible headers. Implemented paging using PagedDataSource.
	Implemented missing overridable methods.
	* AutoGeneratedField.cs: Initial implementation.
	* BoundField.cs: Added ReadOnly property.
	* PagedDataSource.cs: Implemented 2.0 api.
	* DataControlFieldCell.cs: Implemented AccessibleDataControlFieldCell
	cell class to be used by accessible headers.
	* TableCell.cs: Removed unneded constructor. If the cell is bound to
	a template, call the default RenderContents method.

2005-03-16  Lluis Sanchez Gual  <lluis@novell.com>

	* TreeNode.cs, TreeView.cs: Don't raise the SelectedNodeChanged
	  event when loading the view state. Fixes #73746.

2005-03-16  Lluis Sanchez Gual <lluis@novell.com>

	* ListControl.cs: Load selected indices in the right place. Fixes #73745.

2005-03-11  Lluis Sanchez Gual <lluis@novell.com>

	* Button.cs, ImageButton.cs: Interpret PostBackOptions.ClientSubmit
	  correctly.
	* CommandField.cs: Mostly implemented.
	* Menu.cs: Use callback methods moved to ClientScriptManager.
	* DataControlButton.cs: Internal control used to implement buttons
	  for navigating in data bound controls.
	* DataControlField.cs, PagerSettings.cs: Use the new DataControlButton
	  to render the column headers.
	* CheckBox.cs, RadioButton.cs, BulletedList.cs, TextBox.cs
	  DropDownList.cs, Calendar.cs, ListBox.cs, LinkButton.cs, TreeView.cs:
	  Don't use Page.GetPostBackClientEvent
	  since it is deprecated in 2.0.
	* GridView.cs: Implemented some several interfaces.
	  Implemented support client sorting and page navigation (using callbacks).
	  Implemented the autogenerated command column using the new CommandField
	  class.
	* ButtonFieldBase.cs: Implemented.
	* GridView.js: New helper script to support client side sorting and
	  paging in the grid view.

2005-03-04  Lluis Sanchez Gual <lluis@novell.com>

	* DataKey.cs: Implemented.
	* XmlDataSourceView.cs: Implemented support for row pagging.
	* Table.cs: Fixed attribute value.
	* DataControlField.cs: Added support for sorting headers.
	* ChildTable.cs: Created.
	* ListControl.cs: Delay selection assignment, since control state
	is now loaded before view state.
	* GridViewDeleteEventArgs.cs, GridViewUpdateEventArgs.cs,
	GridViewDeletedEventArgs.cs, GridViewUpdatedEventArgs.cs: Implemented
	several missing properties.
	* PagerSettings.cs: Fully implemented.
	* BaseDataList.cs: Added null check.
	* GridView.cs: Implemented more functionality.
	* BoundField.cs: Added support for cell editing.
	* StringArrayConverter.cs: Implemented.
	* DataKeyArray.cs: Implemented.
	* BaseDataBoundControl.cs: Reset the requires binding flag before
	executing the query. This avoids recursive query calls.
	* GridViewRow.cs: Handler commands raised from row childs.

2005-02-25  Lluis Sanchez Gual <lluis@novell.com>

	* XmlDataSourceView.cs: ExecuteSelect now returns a list of
	XmlDataSourceNodeDescriptor instead of a list of nodes. In this way
	it is possible to query for properties fore each data item.
	* Menu.cs, TreeView.cs: Make sure that objects are correctly created
	when loading its view state.
	* DataControlField.cs: Implement properties using a StateBag.
	* XmlDataSourcePropertyDescriptor.cs: Implemented.
	* PagerSettings.cs: Mostly implemented.
	* AccessDataSourceView.cs, AccessDataSource.cs: Added security attribute.
	* DataBoundControl.cs: Added null check.
	* GridView.cs: Initial implementation.
	* CompositeDataBoundControl.cs: Implemented.
	* BoundField.cs: Initial implementation.
	* GridViewRowCollection.cs: Initial implementation.
	* DataControlFieldCollection.cs: Initial implementation.
	* DataControlFieldCell.cs: Fixed control tag.
	* GridViewRow: Initial implementation.
	* XmlDataSourceNodeDescriptor.cs: Implemented.

2005-02-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* WebControl.cs: correctly use TagName in RenderBeginTag, ie, if TagKey
	is zero, use the TagName no matter its value. Fixes bug #72415.

2005-02-18  Lluis Sanchez Gual <lluis@novell.com>

	* Style.cs: Method name fix.
	* HyperLinkColumn.cs, HyperLink.cs: Moved SoftkeyLabel to HyperLink.
	* BaseCompareValidator.cs: Method signature fix.
	* CollectionDataSource.cs: Implemented DataSource wrapper for collections.
	* BaseDataList.cs, Repeater.cs: Fixed data binding code.
	* BulletedList.cs: Added missing method.
	* DataBoundControl.cs, BaseDataBoundControl.cs: Made it behave like MS.NET.

2005-02-16  Lluis Sanchez Gual  <lluis@novell.com>

	* HyperLinkColumn.cs, Label.cs: Added missing 2.0 properties.
	* RadioButton.cs: Added missing 2.0 methods.
	* ListItem.cs: Added Enabled property.
	* MailMessageEventArgs.cs: Use the correct message class.
	* ListControl.cs: Implemented missing properties and support for
	control state. Implemented base RenderContents method.
	* Image.cs: Implemented DescriptionUrl and GenerateEmptyAlternateText
	properties.
	* BaseCompareValidator.cs: Implemented methods that support conditional
	use of the invariant culture.
	* DataBoundControl.cs: Set RequiresDataBinding to true in OnLoad.
	* SqlDataSourceCommandEventArgs.cs, SqlDataSourceStatusEventArgs.cs:
	It takes a DbCommand instead of a IDbCommand.
	* GridViewSortEventArgs.cs: Added SortDirection property.
	* TextBox.cs, CheckBoxList.cs: Added protected version of
	IPostBackDataHandler methods.
	* RadioButtonList.cs: Added protected version of
	IPostBackDataHandler and IRepeatInfoUser methods.
	* Repeater.cs: Updated some method names.
	* DropDownList.cs:  Added protected version of
	IPostBackDataHandler methods. Reuse RenderContents from base class.
	* RepeaterItem.cs, Localize.cs, Literal.cs: Fix inheritance.
	* GridViewUpdatedEventArgs.cs: Fix typo.
	* ListBox.cs: Added protected version of IPostBackDataHandler methods.
	Reuse RenderContents from base class.
	* BaseDataBoundControl.cs: Several fixes.
	* ImageButton.cs, LinkButton.cs: Implemented several 2.0 properties.

2005-02-10  Lluis Sanchez Gual  <lluis@novell.com>

	* CheckBoxList.cs: Fix build.

2005-02-10  Lluis Sanchez Gual <lluis@novell.com>

	* Button.cs: Use validation group when validating page.
	* XmlDataSourceView.cs: Implemented ExecuteSelect.
	* Menu.cs: Minor fix.
	* CheckBox.cs: Added 2.0 properties and methods.
	* BaseDataList.cs: Always databind the control if view state
	is not enabled.
	* DataList.cs: In 2.0, use control state to save the selected index.
	* DetailsViewUpdatedEventArgs.cs: Fix typo.
	* CustomValidator.cs: Implement IStaticTextControl interface.
	* CheckBoxList.cs: Added missing 2.0 methods.
	* DropDownList.cs: Added missing 2.0 methods. Implemented ITextControl
	interface.
	* XmlDataSource.cs: Return childs of DocumentElement, not the root
	document.
	* DayRenderEventArgs.cs, CompareValidator.cs, DataListItem.cs:
	Implemented 2.0 API.
	

2005-02-04  Lluis Sanchez Gual  <lluis@novell.com>

	* Button.cs: Implemented all missing 2.0 features.
	* Table.cs: Render the table caption, when specified.
	* Calendar.cs: Implemented most of missing 2.0 features.
	* TableCell.cs: Fixed attributes.

2005-02-02  Lluis Sanchez Gual  <lluis@novell.com>

	* ControlPropertyNameConverter.cs: Added file.

2005-02-02  Lluis Sanchez Gual <lluis@novell.com>

	* Button.cs, MonthChangedEventArgs.cs, FontInfo.cs, Xml.cs, Style.cs,
	CookieParameter.cs, HyperLinkColumn.cs, Table.cs,
	RegularExpressionValidator.cs, WizardNavigationEventArgs.cs,
	ServerValidateEventArgs.cs, Menu.cs, DataControlField.cs,
	DataGridPagerStyle.cs, Label.cs, CheckBox.cs, ListItem.cs,
	RadioButton.cs, TableStyle.cs, ListControl.cs, Image.cs,
	BaseCompareValidator.cs, FontUnit.cs, DataListCommandEventArgs.cs,
	IButtonControl.cs, BaseDataList.cs, DataList.cs, BulletedList.cs,
	RangeValidator.cs, DataBoundControl.cs, ControlParameter.cs,
	RepeaterItemEventArgs.cs, SqlDataSource.cs, BaseValidator.cs,
	CustomValidator.cs, MenuItem.cs, SessionParameter.cs, TextBox.cs,
	QueryStringParameter.cs, Content.cs, ContentPlaceHolder.cs,
	CheckBoxList.cs, RepeaterCommandEventArgs.cs, RadioButtonList.cs,
	RequiredFieldValidator.cs, AdRotator.cs, DataListItemEventArgs.cs,
	DataGridSortCommandEventArgs.cs, Repeater.cs,
	MenuItemTemplateContainer.cs, HyperLink.cs, SqlDataSourceView.cs,
	XmlDataSource.cs, MultiView.cs, DataGridCommandEventArgs.cs,
	Panel.cs, CompositeControl.cs, DataGrid.cs, ButtonColumn.cs,
	CompareValidator.cs, HierarchicalDataBoundControl.cs,
	EditCommandColumn.cs, Calendar.cs, SiteMapDataSource.cs, 
	ListBox.cs, TableCell.cs, ObjectDataSourceSelectingEventArgs.cs,
	ObjectDataSourceMethodEventArgs.cs,DataGridPageChangedEventArgs.cs,
	WebControl.cs, BaseDataBoundControl.cs, FormParameter.cs,
	ValidationSummary.cs, View.cs, ImageButton.cs, TableRow.cs,
	LinkButton.cs, DataGridColumn.cs, Parameter.cs, TableItemStyle.cs,
	AdCreatedEventArgs.cs:
	
	General 2.0 API fixes: missing attributes, incorrect inheritance,
	missing sealed keywords, wrong signatures, etc.

2005-01-28  Lluis Sanchez Gual <lluis@novell.com>

	* Table.cs: Added some 2.0 properties.
	* FontUnitConverter.cs, UnitConverter.cs: Implemented conversion to
	InstanceDescriptor.
	* BaseValidator.cs: Fix warning.
	* MultiView.cs, ViewCollection.cs, View.cs: Implemented.

2005-01-26  Lluis Sanchez Gual <lluis@novell.com>

	* Menu.cs: Rendering fixes.

2005-01-21  Lluis Sanchez Gual <lluis@novell.com>

	* Content.cs, ContentPlaceHolder.cs, ContentControlBuilder.cs
	ContentPlaceHolderBuilder.cs: Implemented.

2005-01-20 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* CheckBox.cs: when rendering the input tag inside a span tag, keep the
	attributes that are meant to be in the input tag in their place.

2005-01-10 Juraj Skripsky <juraj@hotfeet.ch>

	* RepeatInfo.cs: fixed bug #68927 (DataList with RepeatLayout='Flow'
	generates invalid html).

2005-01-10  Lluis Sanchez Gual <lluis@novell.com>

	* Menu.cs: Implemented most of missing properties. Added support for
	item templates. Implemented menu scrolling.
	* MenuItemBinding.cs: Implemented most of missing properties.
	* MenuItem.cs: Implemented most of missing properties.
	* Menu.js: Implemented scrolling and menu reposition into screen.
	* MenuItemTemplateContainer.cs: Implemented.
	* SubMenuStyle.cs: Implemented.

2004-12-20 Lluis Sanchez Gual <lluis@novell.com>

	* Style.cs: Implemented RegisteredCssClass property. Added
	CopyTextStylesFrom method, which copies styles that only apply to text.
	* Menu.cs, Menu.js: Added hover style support. Define all menu styles
	in the page stylesheet. Added support for ItemSpacing property.
	* MenuItemStyle.cs: Implemented FillStyleAttributes method.
	
2004-12-17 Lluis Sanchez Gual <lluis@novell.com>

	* Style.cs: Generate styles using a CssStyleCollection, so the code can
	be reused for the 2.0 FillStyleAttributes method.
	* Menu.cs: Implemented more properties and events. Rendering is very
	complete now.
	* MenuItem.cs: Added PopOutImageUrl property.
	* Menu.js: More work on submenu management.

2004-12-10 Lluis Sanchez Gual <lluis@novell.com>

	* Menu.cs: Implemented basic rendering. Added some missing properties.
	* MenuItem.cs: Improved implementation of Depth.
	* Unit.cs: Added serializable attribute.
	* TreeView.cs: Moved GetScriptLiteral method to ClientScriptManager,
	so it can be reused.
	* Menu.js: New script to support he Menu control.

2004-12-03 Lluis Sanchez Gual <lluis@novell.com>

	* MenuEventArgs.cs: Changed to sealed.
	* TreeView.cs: Minor fix.
	* Menu.cs, MenuItemBindingCollection.cs, MenuItemCollection.cs,
	MenuItemStyle.cs, MenuItemBinding.cs, MenuItem.cs,
	MenuItemStyleCollection.cs: Initial Menu code.

2004-12-02 Lluis Sanchez Gual <lluis@novell.com>

	* TreeNodeBindingCollection.cs, TreeNodeStyleCollection.cs: 
	Implemented SetDirtyObject.
	* Style.cs: Implemented SetDirty().
	* TreeNodeBinding.cs: Added missing attributes. Implemented SetDirty().
	* TreeNode.cs: Added missing attributes added support for
	PopulateOnDemand. Added some missing property bindings.
	* TreeNodeCollection.cs: Several minor fixes. SetDirty must be called
	to newly added elements to make sure al new data is saved.
	* TreeView.js: Implemented support for client population of nodes.
	* TreeNodeStyle.cs: Added missing attributes.
	* TreeView.cs: Implemented support for PopulateNodesFromClient and
	PopulateOnDemand. Improved rendering.

2004-11-29 Sanjay Gupta <gsanjay@novell.com>

	* DataControlField.cs:
	* DataControlFieldCell.cs: Initial implementation.

2004-11-26 Lluis Sanchez Gual <lluis@novell.com>

	* TreeNodeBindingCollection.cs: Implemented.
	* TreeNodeBinding.cs: Implemented.
	* TreeNode.cs: Added support for data binding.
	* TreeView_Default_Collapse.gif, TreeView_Default_Expand.gif
	  TreeView_Default_NoExpand.gif: Moved to resources directory.
	* ListControl.cs: Fixed api.
	* XmlHierarchicalEnumerable.cs: Made internal.
	* DataBoundControl.cs: Modified api to match latest ms.net.
	* TreeView.js: New javascript file to support TreeView in the client.
	* XmlDataSource.cs: Added missing attributes.
	* HierarchicalDataBoundControl.cs: Mostly implemented.
	* BaseDataBoundControl.cs: Mostly implemented.
	* XmlHierarchyData.cs: Made internal.
	* TreeView.cs: Mostly implemented. The major missing feature is
	  client side tree population.

2004-11-25 Sanjay Gupta <gsanjay@novell.com>

	* BaseDataList.cs: 
	* DataBountControl.cs:
	* Repeater.cs: Added SelectArguments property and updated.
	* SiteMapDataSourceView.cs:
	* SqlDataSourceView.cs:
	* XmlDataSourceView.cs: Removed extra method, which was there to
				keep things compiling.

2004-11-23 Lluis Sanchez Gual <lluis@novell.com>

	* TreeNodeBindingCollection.cs, TreeNodeBinding.cs, TreeNode.cs,
	TreeNodeCollection.cs, TreeNodeStyleCollection.cs, TreeNodeStyle.cs,
	TreeView.cs: Initial implementation.
	* DataBoundControl.cs: Set the correct base class.
	* HierarchicalDataBoundControl.cs, BaseDataBoundControl.cs: Created stub.
	* TreeNodeSelectAction.cs: Formatting.
	* TreeView_Default_Collapse.gif, TreeView_Default_Expand.gif,
	TreeView_Default_NoExpand.gif: TreeView images.

2004-11-22 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSourceView.cs: Updated methods and added one property.
	 
2004-11-19 Sanjay Gupta <gsanjay@novell.com>

	* AccessDataSource.cs: 
	* SqlDataSourceView.cs: Implemented CreateDataSourceView () method.	 
2004-11-19 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSource.cs: Updated call to constructor of SqlDataSourceView.cs.
	* SqlDataSourceView.cs: Updated constructor.
	 
2004-11-19 Sanjay Gupta <gsanjay@novell.com>

	* AccessDataSourceView.cs: Added new class.

2004-11-19 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSourceView.cs: Corrected exception handling in 
	  ExecuteSelect method.

2004-11-18 Lluis Sanchez Gual <lluis@novell.com>

	* SiteMapHierarchicalDataSourceView.cs, SiteMapDataSource.cs: New files.
	* SiteMapDataSourceView.cs: Minor fix.

2004-11-18 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSourceView.cs: Updated ExecuteSelect method.

2004-11-18 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSource.cs: Corrected Select method.

2004-11-18 Sanjay Gupta <gsanjay@novell.com>

	* SqlDataSource.cs: Updated Select method definition.
	* SqlDataSourceStatusEventArgs.cs: Updated class.
	 
2004-11-15 Lluis Sanchez Gual <lluis@novell.com>

	* SqlDataSourceView.cs: Removed implementation of Events (it is inherited
	from DataSourceView.cs).

2004-11-10  Raja R Harinath  <rharinath@novell.com>

	* SqlDataSourceView.cs (Select): Add 'override' to make it compile.

2004-11-05 Sanjay Gupta <gsanjay@novell.com>
	
	* SqlDataSource.cs: Corrected method calls.
	* SqlDataSourceView.cs: Partial implementation of few methods.

2004-10-25 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListItemCollection.cs: fixed bug when indexing changed elements in
	LoadViewState. Patch from Alois Bělaška.

2004-10-20 Sanjay Gupta <gsanjay@novell.com>
	
	* SiteMapDataSourceView.cs: 
	* SqlDataSourceView.cs:
	* XmlDataSourceView.cs: Cosmetic changes because of modifications in 
	base class, DataSourceView. Changes are to keep things compiling. 

2004-10-19 Sanjay Gupta <gsanjay@novell.com>
	
	* SiteMapDataSourceView.cs: Corrected class definition and updated.
	* XmlHierarchicalDataSourceView.cs: Modified according to changes in 
	  base class.

2004-10-14 Sanjay Gupta <gsanjay@novell.com>
	
	* AdRotator.cs: Updated.

2004-10-12 Sanjay Gupta <gsanjay@novell.com>

	* AccessDataSource.cs: Updated.

2004-10-08 Sanjay Gupta <gsanjay@novell.com>

	* ValidatedControlConverter.cs: Updated.

2004-10-08 Sanjay Gupta <gsanjay@novell.com>

	* AssociatedControlConverter.cs: Implemented.

2004-10-08 Sanjay Gupta <gsanjay@novell.com>

	* ControlIDConverter.cs: Initial implementation.

2004-10-04 Sanjay Gupta <gsanjay@novell.com>

	* IButtonControl.cs: Corrected property name.

2004-10-04 Sanjay Gupta <gsanjay@novell.com>

	* ParameterCollection.cs: Updated.

2004-10-04 Sanjay Gupta <gsanjay@novell.com>

	* Parameter.cs: Updated and completed implementation.

2004-10-01 Sanjay Gupta <gsanjay@novell.com>

	* ParameterCollection.cs: Resolved warnings, "Unreachable code detected"
	  while compilation.

2004-10-01 Sanjay Gupta <gsanjay@novell.com>

	* AccessDataSource.cs: Initial implementation.

2004-09-30 Sanjay Gupta <gsanjay@novell.com>

	* DataControlRowState.cs: 
	* ScrollBars.cs:
	* TreeNodeTypes.cs: Added attribute.
	* DataControlRowType.cs:
	* HotSpotMode.cs:
	* SortDirection.cs: Corrected enumeration values.
	* TableRowSection.cs: Added new enumeration.
	* ObjectDataSourceStatusEventHandler.cs: Corrected method name.

2004-09-28 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TableStyle.cs: don't render empty 'rules' attribute (again).

2004-09-21 Sanjay Gupta <gsanjay@novell.com>

	* FormViewUpdatedEventArgs.cs: Spelling mistake.

2004-09-14 Sanjay Gupta <gsanjay@novell.com>
	
	* Literal.cs: Added new method Focus().

2004-09-12 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* RadioButton.cs: fix GroupName when the control is inside a
	NamingContainer different from Page. Closes bug #65586.

2004-09-07  Sanjay Gupta <gsanjay@novell.com>
	
	* Localize.cs: Added new class.

2004-09-03  Gaurav Vaish <gvaish_mono AT lycos.com>

	* CompositeControl.cs  : Completed
	* Login.cs             : Initial implementation.

2004-09-01 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Xml.cs: fixed get_DocumentContent (it was returning "" always!) and
	don't call MapPathSecure on the content itself.
	
	* XmlBuilder.cs: handle XML documents written inside asp:xml. The
	document is checked at parse time and will be checked again at run time.

	Fixes bug #63828.

2004-08-31  Sanjay Gupta <gsanjay@novell.com>

	* AuthenticateEventHandler.cs: 
	* CreateUserErrorEventArgs.cs:
	* CreateUserErrorEventHandler.cs:
	* DetailsViewCommandEventHandler.cs:
	* DetailsViewDeleteEventArgs.cs:
	* DetailsViewDeleteEventHandler.cs:
	* DetailsViewDeletedEventArgs.cs:
	* DetailsViewDeletedEventHandler.cs:
	* DetailsViewInsertEventArgs.cs:
	* DetailsViewInsertEventHandler.cs:
	* DetailsViewInsertedEventArgs.cs:
	* DetailsViewInsertedEventHandler.cs:
	* DetailsViewModeEventArgs.cs:
	* DetailsViewModeEventHandler.cs:
	* DetailsViewPageEventHandler.cs:
	* DetailsViewUpdateEventArgs.cs:
	* DetailsViewUpdateEventHandler.cs:
	* DetailsViewUpdatedEventArgs.cs:
	* DetailsViewUpdatedEventHandler.cs:
	* FormViewCommandEventHandler.cs:
	* FormViewDeleteEventArgs.cs:
	* FormViewDeleteEventHandler.cs:
	* FormViewDeletedEventArgs.cs:
	* FormViewDeletedEventHandler.cs:
	* FormViewInsertEventArgs.cs:
	* FormViewInsertEventHandler.cs:
	* FormViewInsertedEventArgs.cs:
	* FormViewInsertedEventHandler.cs:
	* FormViewModeEventHandler.cs:
	* FormViewPageEventHandler.cs:
	* FormViewUpdateEventArgs.cs:
	* FormViewUpdateEventHandler.cs:
	* FormViewUpdatedEventArgs.cs:
	* FormViewUpdatedEventHandler.cs:
	* GridViewCancelEditEventArgs.cs:
	* GridViewCancelEditEventHandler.cs:
	* GridViewCommandEventHandler.cs:
	* GridViewDeleteEventArgs.cs:
	* GridViewDeleteEventHandler.cs:
	* GridViewDeletedEventArgs.cs:
	* GridViewDeletedEventHandler.cs:
	* GridViewEditEventHandler.cs:
	* GridViewPageEventHandler.cs:
	* GridViewRowEventHandler.cs:
	* GridViewSelectEventHandler.cs:
	* GridViewSortEventArgs.cs:
	* GridViewSortEventHandler.cs:
	* GridViewUpdateEventArgs.cs:
	* GridViewUpdateEventHandler.cs:
	* GridViewUpdatedEventArgs.cs:
	* GridViewUpdatedEventHandler.cs:
	* ImageMapEventHandler.cs:
	* MailMessageEventHandler.cs:
	* MenuEventHandler.cs:
	* ObjectDataSourceDisposingEventHandler.cs:
	* ObjectDataSourceEventHandler.cs:
	* ObjectDataSourceMethodEventArgs.cs:
	* ObjectDataSourceMethodEventHandler.cs:
	* ObjectDataSourceSelectingEventArgs.cs:
	* ObjectDataSourceSelectingEventHandler.cs:
	* ObjectDataSourceStatusEventArgs.cs:
	* ObjectDataSourceStatusEventHandler.cs:
	* SendMailErrorEventHandler.cs:
	* SiteMapNodeItemEventHandler.cs:
	* SqlDataSourceSelectingEventArgs.cs:
	* SqlDataSourceSelectingEventHandler.cs:
	* TreeNodeEventHandler.cs:
	* WizardNavigationEventArgs.cs:
	* WizardNavigationEventHandler.cs: Minor modifications, compiler error
	corrections and removing "sealed" access specifier from *EventHandler.cs

2004-08-18  Sanjay Gupta <gsanjay@novell.com>

	* Literal.cs: Added new attributes and property for .Net 2.0

2004-08-13  Sanjay Gupta <gsanjay@novell.com>

	* GridViewDeleteEventArgs.cs: Removed extra code.

2004-08-12  Sanjay Gupta <gsanjay@novell.com>

	* SendMailErrorEventArgs.cs:
	* SendMailErrorEventHandler.cs:
	* SiteMapNodeItemEventArgs.cs:
	* SiteMapNodeItemEventHandler.cs:
	* SqlDataSourceSelectingEventArgs.cs:
	* SqlDataSourceSelectingEventHandler.cs:
	* TreeNodeEventArgs.cs:
	* TreeNodeEventHandler.cs:
	* WizardNavigationEventArgs.cs:
	* WizardNavigationEventHandler.cs: Added new delegates.

2004-08-11  Sanjay Gupta <gsanjay@novell.com>

	* ImageMapEventArgs.cs:
	* ImageMapEventHandler.cs:
	* MailMessageEventArgs.cs:
	* MailMessageEventHandler.cs:
	* MenuEventArgs.cs:
	* MenuEventHandler.cs:
	* ObjectDataSourceDisposingEventArgs.cs:
	* ObjectDataSourceDisposingEventHandler.cs:
	* ObjectDataSourceEventArgs.cs:
	* ObjectDataSourceEventHandler.cs:
	* ObjectDataSourceMethodEventArgs.cs:
	* ObjectDataSourceMethodEventHandler.cs:
	* ObjectDataSourceSelectingEventArgs.cs:
	* ObjectDataSourceSelectingEventHandler.cs:
	* ObjectDataSourceStatusEventArgs.cs:
	* ObjectDataSourceStatusEventHandler.cs: Added new delegates.

2004-08-11  Sanjay Gupta <gsanjay@novell.com>

	* DetailsViewCommandEventArgs.cs:
	* FormViewCommandEventArgs.cs:
	* GridViewCommandEventArgs.cs: Corrected constructor.

2004-08-11  Sanjay Gupta <gsanjay@novell.com>

	* GridViewCancelEditEventArgs.cs:
	* GridViewCancelEditEventHandler.cs:
	* GridViewCommandEventArgs.cs:
	* GridViewCommandEventHandler.cs:
	* GridViewDeletedEventArgs.cs:
	* GridViewDeletedEventHandler.cs:
	* GridViewDeleteEventArgs.cs:
	* GridViewDeleteEventHandler.cs:
	* GridViewEditEventArgs.cs:
	* GridViewEditEventHandler.cs:
	* GridViewPageEventArgs.cs:
	* GridViewPageEventHandler.cs:
	* GridViewRowEventArgs.cs:
	* GridViewRowEventHandler.cs:
	* GridViewSelectEventArgs.cs:
	* GridViewSelectEventHandler.cs:
	* GridViewSortEventArgs.cs:
	* GridViewSortEventHandler.cs:
	* GridViewUpdatedEventArgs.cs:
	* GridViewUpdatedEventHandler.cs:
	* GridViewUpdateEventArgs.cs:
	* GridViewUpdateEventHandler.cs: Added new delegates.

2004-08-11  Sanjay Gupta <gsanjay@novell.com>

	* FormViewUpdatedEventArgs.cs: Corrected constructor.

2004-08-11  Sanjay Gupta <gsanjay@novell.com>

	* FormViewCommandEventArgs.cs: Corrected name of class.

2004-08-10 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Xml.cs: use MapPath in DocumentSource and documentContent. Fixes
	bug #62726.

2004-08-10  Sanjay Gupta <gsanjay@novell.com>

	* FormViewCommandEventArgs.cs:
	* FormViewCommandEventHandler.cs:
	* FormViewDeletedEventArgs.cs:
	* FormViewDeletedEventHandler.cs:
	* FormViewDeleteEventArgs.cs:
	* FormViewDeleteEventHandler.cs:
	* FormViewInsertedEventArgs.cs:
	* FormViewInsertedEventHandler.cs:
	* FormViewInsertEventArgs.cs:
	* FormViewInsertEventHandler.cs:
	* FormViewModeEventArgs.cs:
	* FormViewModeEventHandler.cs:
	* FormViewPageEventArgs.cs:
	* FormViewPageEventHandler.cs:
	* FormViewUpdatedEventArgs.cs:
	* FormViewUpdatedEventHandler.cs:
	* FormViewUpdateEventArgs.cs:
	* FormViewUpdateEventHandler.cs: Added new delegates.

2004-08-10  Sanjay Gupta <gsanjay@novell.com>

	* DetailsViewCommandEventArgs.cs:
	* DetailsViewCommandEventHandler.cs:
	* DetailsViewDeletedEventArgs.cs:
	* DetailsViewDeletedEventHandler.cs:
	* DetailsViewDeleteEventArgs.cs:
	* DetailsViewDeleteEventHandler.cs:
	* DetailsViewInsertedEventArgs.cs:
	* DetailsViewInsertedEventHandler.cs:
	* DetailsViewInsertEventArgs.cs:
	* DetailsViewInsertEventHandler.cs:
	* DetailsViewModeEventArgs.cs:
	* DetailsViewModeEventHandler.cs:
	* DetailsViewPageEventArgs.cs:
	* DetailsViewPageEventHandler.cs:
	* DetailsViewUpdatedEventArgs.cs:
	* DetailsViewUpdatedEventHandler.cs:
	* DetailsViewUpdateEventArgs.cs:
	* DetailsViewUpdateEventHandler.cs: Added new delegates.

2004-08-09  Sanjay Gupta <gsanjay@novell.com>

	* AuthenticateEventArgs.cs:
	* AuthenticateEventHandler.cs:
	* CreateUserErrorEventArgs.cs:
	* CreateUserErrorEventHandler.cs: Added new delegates.

2004-08-05  Sanjay Gupta <gsanjay@novell.com>

	* IButtonControl.cs:
	* ICallbackContainer.cs:
	* ICompositeControlDesignerAccessor.cs:
	* IPostBackContainer.cs: Added new interfaces.

2004-08-03  Sanjay Gupta <gsanjay@novell.com>

	* AdType.cs:
	* AutoCompleteType.cs:
	* ContentDirection.cs:
	* DataControlCellType.cs:
	* DataControlRowState.cs:
	* DataControlRowType.cs:
	* DetailsViewMode.cs:
	* DynamicImageParameterMode.cs:
	* FormViewMode.cs:
	* HotSpotMode.cs:
	* ImageFieldMode.cs:
	* LiteralMode.cs:
	* LogoutAction.cs:
	* Orientation.cs:
	* PagerButtons.cs:
	* PathDirection.cs:
	* ScrollBars.cs:
	* SiteMapNodeItemType.cs:
	* SiteMapNodeType.cs:
	* SiteMapViewType.cs:
	* SortDirection.cs:
	* TableCaptionAlign.cs:
	* TableHeaderScope.cs:
	* TableViewMode.cs:
	* TreeNodeSelectAction.cs:
	* TreeNodeTypes.cs:
	* TreeViewImageSet.cs:
	* WizardStepType.cs: Added enumerations

2004-08-02  Duncan Mak  <duncan@ximian.com>

	* ButtonType.cs:
	* LoginFailureAction.cs:
	* LoginTextLayout.cs: Added enumerations.

2004-07-29 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseValidator.cs: in Validate(), when the control is not visible or
	enabled, return inmediately after setting IsValid to true. Fixes bug
	#61831.

2004-07-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: s/HasChildren/HasControls()/.

2004-07-27 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataList.cs: style.

2004-07-27 Alon Gazit <along@mainsoft.com>
	* DataList.cs: Replaced foreach statement with for statement, 
	in order to improve performence.

2004-07-27 Alon Gazit <along@mainsoft.com>
	* WebControl.cs: changed RenderBeginTag()to use TagKey instead of 
	TagName.
	* Unit.cs : changed GetTypeFromString() and GetStringFromPixel() to use 
	switch statements in order to improve performance.

2004-06-10 Alon Gazit <along@mainsoft.com>
	* WebControl.cs: fixed LoadViewState(). 
	Creates new attributes state bag only when the current is null.

2004-06-07  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: implemented OnPreRender and HasWeekSelectors.

2004-06-05  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: set the title class attribute if we have it. Fixes bug
	53671.

2004-06-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Style.cs: added SetBit.

2004-06-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs:
	* CompareValidator.cs:
	* ImageButton.cs:
	* Style.cs:
	* WebControl.cs: Added protected missing members and attributes.

2004-05-18  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TextBox.cs: don't save the Text if in ViewState if it's a password.
	Save it if the control is not visible or not enabled. Fixes bug #58497.

2004-05-14  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: fire OnDayRender after assigning the calendar cell text.
	Fixes bug #58097.

2004-05-09 Gert Driesen (drieseng@users.sourceforge.net)
	* Parameter.cs: 
	* SqlDataSourceCommandEventArgs:
	* XmlDataSource.cs : removed temporary workarounds for CLS 
	compliance as System.Data is now CLS compliant

2004-05-06 Alon Gazit <along@mainsoft.com>
	* WebControl.cs: fixed LoadViewState() and SaveViewState(). 
	Before the change the Enabled property wasn't updated when a postback
	event was raised.
	* ListControl.cs: fixed SelectedIndex property implementation.
	Prevents throwing ArgumentOutOfRangeException (that should not be
	thrown), when the list is empty.

2004-04-28 Alon Gazit <along@mainsoft.com>
	* WebControl.cs: fixed LoadViewState(). 
	Always loading the saved attributes collection.

2004-04-18 Alon Gazit <along@mainsoft.com>
	* Repeater.cs: fixed InstantiateItem() and DataSource property.
	The change in DataSource prevents throwing ArgumentException while
	setting property value to null.
	The change in InstantiateItem() prevents NullReferenceException.

2004-04-07  Lluis Sanchez Gual <lluis@ximian.com>

	* BaseValidator.cs: Store Display property in the correct ViewState
	property. Don't render anything if Display is ValidatorDisplay.None.

2004-03-30  Lluis Sanchez Gual <lluis@ximian.com>

	* Xml.cs: In LoadXpathDoc(), don't use MapPathSecure with documentSource,
	  since it is already a physical path. Fixes bug #55334.

2004-02-13  Jackson Harper  <jackson@ximian.com>

	* Calendar.cs: Match MS postback data. This allows sites that
	parse the postback data manually to work.
	
2004-02-04 Alon Gazit <along@mainsoft.com>
	* EditCommandColumn.cs: fixed InitializeCell().
	The rendered LiteralControl should contain "&nbsp;" and not " ".

2004-02-01 Alon Gazit <along@mainsoft.com>

	* DataGrid.cs: fixed a problem in the paging mechanism in the method
	InitializePager().
	the problem was when (PagerStyle.Mode == PagerMode.NumericPages),
	while clicking the "..." link in the second page.

2004-01-28 Alon Gazit <along@mainsoft.com>

	* Calendar.cs: prevent NullReferenceException in RenderAllDays().

2004-01-27  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: when rendering days, add a LiteralControl containing the
	day before OnDayRender is called. Only generate the default links for
	days when IsSelectable is true after OnDayRender. Fixes bug #53372.

2004-01-21  Martin Baulig  <martin@ximian.com>

	* XmlHierarchyData.cs: Make this compile with csc.

	* BulletedList.cs (BulletedList.SelectedItem): Removed the `set'
	accessor since the base class doesn't have one.

2004-01-18 Alon Gazit <along@mainsoft.com>

	* CheckBoxList.cs: fix problem with negative TabIndex (wasn't rendered).
	
2004-01-18 Alon Gazit <along@mainsoft.com>

	* Style.cs: CopyFrom method shouldn't copy a value that is equal to
	Property default value.
	* FontInfo.cs : CopyFrom method shouldn't copy a value that is equal to 
	Property default value.	

2004-01-15 Alon Gazit <along@mainsoft.com>

	* RadioButtonList.cs: RepeatLayout property should affect the rendered
	html.	

2004-01-15 Alon Gazit <along@mainsoft.com>
	* FontInfo.cs: Add validation check to Size property.	

2004-01-07 Alon Gazit <along@mainsoft.com>
	* DataGrid.cs: Fixed PrepareControlHierarchyForItem().
	merge the column's style to the cell's style and not to
	the item's(row) style.	

2004-01-04 Alon Gazit <along@mainsoft.com>
	* RangeValidator.cs: Fixed ControlPropertiesValid().
	
2004-01-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Xml.cs: mono-stylized and removed warnings.

2004-1-1 Alon Gazit <along@mainsoft.com>
	* RadioButtonList.cs: update RenderItem() so that each RadioButton
	is enabled or disabled like the RadioButtonList.
	* CheckBoxList.cs: update RenderItem() so that each CheckBox
	is enabled or disabled like the CheckBoxList. 	

2004-1-1 Alon Gazit <along@mainsoft.com>
	* DataGrid.cs: Fixed PrepareControlHierarchyForItem().
	The Header or Footer Style shouldn't merge with the cells Style.	  	 
	
2004-1-1 Alon Gazit <along@mainsoft.com>
	* DataGridColumn.cs: Headers and Footers are initialized  
	with the relevant Style object.	 

2003-12-30 Alon Gazit <along@mainsoft.com>
	* RepeatInfo.cs: Fixed DoVerticalRendering () and 
	DoHorizontalRendering().
	Current implementation produces few extra html tags.
	   
2003-12-29  Alon Gazit <along@mainsoft.com>

	* CheckBox.cs: change the implementation of LoadPostData. 
	Currently, while the AutoPostBack property equals true ,
	it isn't possible to perform uncheck.

2003-12-19  Jackson Harper <jackson@ximian.com>

	* TableCell.cs: Setting a cells text should clear its control
	collection as per la specification. This fixes bug #51825.
	
2003-12-18  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGridColumn.cs: stylized LoadViewState.
	* DataGridColumnCollection.cs: when TrackViewState is called, also
	call it on all the existing columns. Fixes bug #52334.

2003-12-18  Alon Gazit <along@mainsoft.com>

	* DataGridPagerStyle.cs: merge DataGridPagerStyle properties when Style 
	is empty.

2003-12-18  Alon Gazit <along@mainsoft.com>

	* TableStyle.cs: merge TableStyle properties when Style is empty.

2003-12-16  Alon Gazit <along@mainsoft.com>

	* HyperLink.cs: Change Text property implementation. in MS when the Text
	property is set, all the controls in the HyperLink are being deleted. 
	This fixes bug #52239.   

2003-12-15  Alon Gazit <along@mainsoft.com>
	* RepeatInfo.cs: Fixed DoVerticalRendering () and 
	DoHorizontalRendering().
	Both methods add additional empty table row in the head of each item
	table when the variable named isTable equals true (happenes with the
	default instantiation of RepeatInfo). These additional rows should be
	added when isTable equals false.
	This fixes bug #52225.   

2003-12-15  Alon Gazit <along@mainsoft.com>

	* RepeatInfo.cs: Fixed DoVerticalRendering() and
	DoHorizontalRendering().
	Both methods add to rendered Header a colspan attribute according to the
	rows count. after the change the colspan is added according to the
	columns count.   

2003-12-15  Alon Gazit <along@mainsoft.com>
	* CheckBox.cs: Disabled CheckBox does not produce same HTML as .NET.
	In .NET if the checkbox is disabled ,its text appears disabled too.
	In Mono the text appears enabled. the fix is in Render().
	This fixes bug #52180.

2003-12-15  Alon Gazit <along@mainsoft.com>
	* Repeater.cs: Change the implementation of CreateControlHierarchy().
	The current implementation renders extra Header and footer 
	without Repeater.DataSource assign. 
	This fixes bug #52179.

2003-12-15  Alon Gazit <along@mainsoft.com>
	* DataGrid.cs: Change the implementation of the property 
	BackImageUrl. The current implementation has no influence 
	on the rendered Html.

2003-12-15  Alon Gazit <along@mainsoft.com>
	* WebControl.cs: Change the implementation of the property 
	Enabled. Before the change the WebControl also looked at 
	parent.Enabled . fixed bug #52171.

2003-12-11  Jackson Harper <jackson@ximian.com>

	* RepeatInfo.cs: When rendering vertically figure out how many
	colmns are not going to be filled in in the last row, and adjust
	things accordingly. This fixes bug #51863.
	
2003-12-10  Alon Gazit <along@mainsoft.com>
	* TableRow.cs: Change the implementation of the properties 
	HorizontalAlign and  VerticalAlign. The current implementation      
	has no influence on the rendered Html.

2003-12-10  Alon Gazit <along@mainsoft.com>
	* TableItemStyle.cs: Add setting of The WRAP flag in the Wrap
	property's set method.
	
2003-12-09  Jackson Harper <jackson@ximian.com>

	* PagedDataSource.cs (PrivateICollectionEnumerator.MoveNext):
	Increment counter when moving to start. Fixes bug #51926.
	
2003-12-08  Jackson Harper <jackson@ximian.com>

	* HyperLinkColumn.cs: Fix navigate url rendering. Patch by
	Benjamin Jemlich. Fixes bug #51823.
	
2003-12-07  Alon Gazit <along@mainsoft.com>
	* Panel.cs: Panel doesn't render nowrap attribute while the Wrap
	property is set to false. Fixes bug #58120.
	
2003-12-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* TableItemStyle.cs: merge TableItemStyle properties when Style is
	empty. Fixes bug #51689. Patch by Alon Gazit <along@mainsoft.com>.

2003-12-03  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* RadioButtonList.cs: render tabindex attribute if needed. Fixes bug
	#51648.

2003-12-02  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* WebControl.cs: don't create the attributes when GetAttribute is
	called.

2003-12-01  Jackson Harper <jackson@ximian.com>

	* WebControl.cs: Only allow access keys to be null or a single
	char. Patch by Alon Gazit <along@mainsoft.com>.
	
2003-11-30  Jackson Harper <jackson@ximian.com>

	* CheckBoxList.cs: A checkbox will have null post data if it is
	unselected. This fixes bug #51516.
	
2003-11-29  Jackson Harper <jackson@ximian.com>

	* DataGrid.cs: Display paging controls even when there is no
	data. Path by Mohammad DAMT. Fixes bug #51487.
	
2003-11-29  Jackson Harper <jackson@ximian.com>

	* DataGrid.cs: Call TrackViewState when loading bound columns view
	state. So that their state is saved. This fixes bug #51424. Also
	set ReadOnly.
	
2003-11-26  Jackson Harper <jackson@ximian.com>

	* BaseDataList.cs: Change && to || We will call that a typo so no
	one gets embarrased.
	
2003-11-24  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseDataList.cs: allow setting null as Datasource.

	* DataGrid.cs: keep autogenerated columns in the ViewState.

	Patches by Alon Gazit <along@mainsoft.com>.

2003-11-22 Ben Maurer  <bmaurer@users.sourceforge.net>

	* SqlDataSource*: Implement almost everything. Data access is
	still missing.

2003-11-22 Ben Maurer  <bmaurer@users.sourceforge.net>

	* Calendar.cs (SaveViewState):
	    - We were allocating a 11 item array, we only used 10 items,
	      so only allocate 10.
	    - We only need to save the selected dates if there are any.
	* DataGrid.cs (SaveViewState):
	* DataGridColumn.cs (SaveViewState):
	* DataGridColumnCollection.cs (SaveViewState):
	    - Only return the array if there is anything in it
	* Style.cs (SaveViewState):
	    - Only save the bits if there were changes.
	* WebControl.cs (SaveViewState), (LoadViewState):
	    - Don't save Enabled into the viewstate here, we already
	      do it in the property. This just caused *EVERY* control
	      to have a non-null state, taking up lots of extra room
	      in the ViewState.
	    - The style will always be created with this control's
	      viewstate, so the style will always return null for the
	      viewstate. As such, we do not need to store it. We can
	      also reduce the triplet to a pair because of this.

2003-11-22  Jackson Harper <jackson@ximian.com>

	* ValidationSummary.cs: Fix number of messages and message array computation.

2003-11-21  Andreas Nahr <ClassDevelopment@A-SoftTech.com>

	* Xml.cs: Corrected attribute
	* XmlBuilder.cs: Added

2003-11-21  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Xml.cs: class status based fixes.

2003-11-19  Jackson Harper  <jackson@ximian.com>

	* HyperLink.cs: Use ResolveUrl instead of ResolveBaseUrl.
	
2003-11-19  Jackson Harper  <jackson@ximian.com>

	* HyperLink.cs: Use ResolveBaseUrl so that ~/ is interpreted as
	teh applications base directory. This fixes bug #51092.
	
2003-11-18  Todd Berman  <tberman@gentoo.org>

	* ControlParameter.cs:
	* CookieParameter.cs:
	* FormParameter.cs:
	* QueryStringParameter.cs:
	* SessionParameter.cs: added public .ctor ()
	* Parameter.cs: added public .ctor (), internal SetOwnerCollection
	and handling, as well as internal ParameterValue for easy access.
	NOTE: ParameterValue doesnt respect TreatEmptyStringAsNull yet.
	* ParameterCollection.cs: implementation redux.

2003-11-18  Todd Berman  <tberman@gentoo.org>

	* ParameterCollection.cs: Implemented
	* Parameter.cs: Added _owner, SetOwnerCollection and proper handling.
	ToString () now matches asp.net

2003-11-17 Ben Maurer  <bmaurer@users.sourceforge.net>

	* ControlParameter.cs:
	* CookieParameter.cs:
	* FormParameter.cs:
	* Parameter.cs:
	* QueryStringParameter.cs: New v2 files. Mostly
	implemented, still need a few methods.

2003-11-16  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ListItem.cs: prevent nullrefs ni Get/SetAttribute. Thanks to Alon
	Gazit <along@mainsoft.com>.

2003-11-13  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* RadioButton.cs: fixed RenderInputTag for negative TabIndex values.
	Patch by Alon Gazit <along@mainsoft.com>.

2003-11-09 Ben Maurer  <bmaurer@users.sourceforge.net>

	* DataBoundControl.cs: Implement 
	* ListControl.cs: inherit from the above.
	* Repeater.cs, BaseDataList.cs: should reset whenever we databind.

2003-11-09 Ben Maurer  <bmaurer@users.sourceforge.net>

	* BaseDataList.cs:
	* DataGrid.cs:
	* DataList.cs:
	* Repeater.cs: add v2 databinding stuff
	* XmlDataSource.cs: make it load the xml.

2003-11-09 Ben Maurer  <bmaurer@users.sourceforge.net>

	* XmlDataSource.cs:
	* XmlDataSourceView.cs:
	* XmlHierarchicalDataSourceView.cs:
	* XmlHierarchicalEnumerable.cs:
	* XmlHierarchyData.cs: Implement

2003-11-08 Ben Maurer  <bmaurer@users.sourceforge.net>

	* SiteMapDataSourceView.cs: Implement.

2003-11-07 Jackson Harper <jackson@ximian.com>

	* ImageButton.cs: This is a workaround for bug #49819. It appears
	that the .x and .y values are not being posted, and only the x
	value is being posted with the ctrl's id as the key.
	
2003-11-07 Jackson Harper <jackson@ximian.com>

	* DataGrid.cs (CreateControlHierarchy): Current page index is
	alolowed to equal page count. This prevents an exception being
	thrown when both are zero.
	
2003-11-06 Jackson Harper <jackson@ximian.com>

	* ValidationSummary.cs: Add Render method. Patch by Yaron Shkop.
	* BaseValidator.cs: Disable base control so the isValid flag is
	not reset.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* TemplateColumn.cs: Use the same renderer for selected items as
	normal items. This fixes bug #49744.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* DataList.cs:
	* WebControl.cs: Fix argument out of range exceptions on
	properties. Patch by Yaron Shkop.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* TemplateColumn.cs: If the item is selected but there is no
	editItemTemplate use the itemTemplate. This matches MS behvoir.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* Repeater.cs: Always set alternating items to the AlternatingItem
	type, when instantiating alternating items use the itemTemplate if
	the alternatingItem template is null. This matches MS behavoir and
	fixes bug #50157.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* DataGridPagerStyle.cs: Name of view state attribute is
	PagerVisible not Visible. Call owner.OnPagerChanged when the pager
	visibility is changed. Patch by Yaron Shkop.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* RepeatInfo.cs: When doing horizontal rendering use the repeat
	columns as the number of columns in a row. This fixes bug #49016.
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* PagedDataSource.cs (PageCount): Return page count of 1 if there
	paging is disabled. Patch by Yaron Shkop.
	* PagedDataSource.cs (CopyTo): Improve. Patch by Yaron Shkop.
	* TableStyle.cs (AddAttributesToRender): Render border style
	collapse. Patch by Yaron Shkop.
	* TableStyle.cs:
	* TableItemStyle.cs:
	* DataGridPagerStyle.cs: Call base copy and merge even if style is of
	the wrong type. Patch by Yaron Shkop.	
	
2003-11-03 Jackson Harper <jackson@ximian.com>

	* BoundColumn.cs: Render readonly columns. Patch by Mohammad DAMT.
	
2003-11-02 Ben Maurer  <bmaurer@users.sourceforge.net>

	* BulletStyle.cs:
	* BulletedListDisplayMode.cs:
	* BulletedListEventHandler.cs:
	* BulletedList.cs:
	* BulletedListEventArgs.cs: V2 controls (yay!)

2003-10-30 Jackson Harper <jackson@ximian.com>

	* Repeater.cs: Throw an exception if the datasource is set to
	something that does not implement either IListSource or
	IEnumerable. This fixes bug #50155.
	
2003-10-30 Jackson Harper <jackson@ximian.com>

	* DataGridPagerStyle.cs: Do not allow page button counts to be set
	to less then 1. Patch by Yaron Shkop. This fixes bug #50236.
	
2003-10-29 Jackson Harper <jackson@ximian.com>

	* ButtonColumn.cs: Format string and text to format were
	inversed. This fixes bug #50171.
	
2003-10-29 Jackson Harper <jackson@ximian.com>

	* DataGridColumn.cs: If an item style is set apply it to the
	cell. This fixes bug #50173.
	
2003-10-29 Ben Maurer  <bmaurer@users.sourceforge.net>

	* HyperLinkColumn.cs: Patch by Yaron Shkop. Fixes #50234. Remove
	old debugging value.

2003-10-29 Jackson Harper <jackson@ximian.com>

	* PagedDataSource.cs:
	* DataGrid.cs: Patch by Mohammad DAMT. Do not go past the
	end of the last page. Fixes bug #5085.
	
2003-10-29 Jackson Harper <jackson@ximian.com>

	* CheckBox.cs: Do not change the status of a checkbox when there
	is no post data. This fixes bug #49091.
	* CheckBoxList.cs: Do not change the status of the checkboxes when
	there is no post data. This fixes bug #49093.
	
2003-10-26 Ben Maurer  <bmaurer@users.sourceforge.net>

	* RadioButton.cs: Patch by Yaron Shkop. Enables disabling a
	RadioButton. Fixes #50132

2003-10-25 Ben Maurer  <bmaurer@users.sourceforge.net>

	* PagedDataSource.cs: Patch by Ivo Haamer. Typo prevented
	paging from working. Fixes #48814.

2003-10-25 Ben Maurer  <bmaurer@users.sourceforge.net>

	* DataGrid.cs: A few typos kept us from viewing datagrids
	that were based on customized collections.

2003-10-24 Ben Maurer  <bmaurer@users.sourceforge.net>

	* DataGridCommandEventArgs.cs: typo, cmdSrc was becoming origionalArgs.

2003-10-23 Ben Maurer  <bmaurer@users.sourceforge.net>

	* Calendar.cs: render the next month button so that aligns to the
	right.

2003-10-23  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* BaseCompareValidator.cs: splitted Convert. Fixed bug #49927. The fix
	was just changing && by || after the first Match.

2003-10-23  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: apply header style in RenderHeader. Fixes bug #49144.
	Patch by Yaron Shkop.

2003-10-22  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* DataGrid.cs: applied patch from Yaron Shkop (yaronsh@mainsoft.com)
	that fixes bug #49744. Now the selection doesn't lose its data.

2003-10-21 Ben Maurer  <bmaurer@users.sourceforge.net>

	* EditCommandColumn.cs: Implement; fix #49736

2003-10-21 Ben Maurer  <bmaurer@users.sourceforge.net>

	* ButtonColumn.cs: Use the DataGridLinkButton, so that we inherit
	the forground color. bug #49738

2003-10-19  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Calendar.cs: fixed bug #49727.

2003-10-18 Ben Maurer  <bmaurer@users.sourceforge.net>

	* TableStyle.cs: fix #49740.

2003-10-19  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* SelectedDatesCollection.cs: fix by Yaron for bug #49698.
